/**************************************************************
* $Id: niclib.js,v 1.4 2007-08-14 19:13:13 sjaviel Exp $
* Copyright (C) 2006 Hewlett-Packard Development Group, L.P.
**************************************************************/

var ifVlanId;
var ifVlanName;


//*************************************************************



function nicinfo(pindex)
{       /*
        index
        slot
        port
        mibport
        ioaddr
        cond
        iffor
        redundant
        needport
        */
    this.index = cpqHoIfPhysMapEntry[pindex].cpqHoIfPhysMapIndex;
        this.slot = cpqHoIfPhysMapEntry[pindex].cpqHoIfPhysMapSlot;
        if (cpqHoIfPhysMapEntry[pindex].cpqHoIfPhysMapPort == null ||
                cpqHoIfPhysMapEntry[pindex].cpqHoIfPhysMapPort == 4294967295)
                this.mibport = 1;
        else
                this.mibport = cpqHoIfPhysMapEntry[pindex].cpqHoIfPhysMapPort;
        if (cpqHoIfPhysMapEntry[pindex].cpqHoIfPhysMapIoBaseAddr == null ||
                cpqHoIfPhysMapEntry[pindex].cpqHoIfPhysMapIoBaseAddr == 4294967295)
                this.ioaddr = 0;
        else
                this.ioaddr = cpqHoIfPhysMapEntry[pindex].cpqHoIfPhysMapIoBaseAddr;
        if (cpqHoIfPhysMapEntry[pindex].cpqHoIfPhysMapIoBaseAddr == 34816)
                this.mibport = 1;
        if (cpqHoIfPhysMapEntry[pindex].cpqHoIfPhysMapCondition == null)
                this.cond = 1;  // Other
        else
                this.cond = cpqHoIfPhysMapEntry[pindex].cpqHoIfPhysMapCondition;        // Other
        this.port = this.mibport;
    
}
nicinfotable = new Array();

function ifinfo()
{       /*
        index
        desc
        type
        physaddr
        */
}
ifinfotable = new Array();

function getModelName(nic)
{
	// Get the Model Name
	nicString = "";
	if (cpqSePciMemoryEntry.length > 0) {
	    // Is PCI
		if (cpqSePciMemoryEntry[0].cpqSePciMemoryType &&
		    cpqSePciMemoryEntry[0].cpqSePciMemoryBaseAddr) {    
			for (y = 0; y < cpqSePciMemoryEntry.length; y++) {
				thisMem = cpqSePciMemoryEntry[y];
				
				if (((thisMem.cpqSePciMemoryType == 2) && (thisMem.cpqSePciMemoryBaseAddr == nic.ioaddr)) ||
				    ((thisMem.cpqSePciMemoryType == 3) && (thisMem.cpqSePciMemoryBaseAddr == nic.memaddr))) {
					for (z = 0; z < cpqSePciSlotEntry.length; z++) {
						thisSlot = cpqSePciSlotEntry[z];
						if ((thisSlot.cpqSePciSlotBusNumberIndex == thisMem.cpqSePciMemoryBusNumberIndex) &&
						    (thisSlot.cpqSePciSlotDeviceNumberIndex == thisMem.cpqSePciMemoryDeviceNumberIndex)) {
							nicString +=  thisSlot.cpqSePciSlotBoardName;
							break;
						}
					}
				}
				
				if (nicString != "") {
					break;
				}
			}
		}
	}

	if (nicString == "") {
		if (nic.slot > 0) {
		    // EISA
			if (cpqSeEisaSlotBoardName[nic.slot] != null) {
				nicString +=  cpqSeEisaSlotBoardName[nic.slot];
			}
		}
		else {
			// Slot = 0 is Virtual NIC
        	// Add Kludge for Special x8800 NIC
        	if( 0==nic.ioaddr ) {
        		nicString +=  "Virtual Network Adapter";
        	}
        	else {
        		if( 0==nic.ioaddr.length ) {
        			nicString +=  "Virtual Network Adapter";
        		}
        		if(-1 != nic.real_slot && 4294967295 != nic.real_slot) {
        			nic.needport = false;
        		}
        	}
        }
	}

    if(nicString == "(Empty)") {
    	nicString = "Unknown"
    }

	return nicString;
}

function buildHwLocation(nic)
{
  var nicString = "";

  if (parseInt(nic.slot) < 0)
  {
    // Need to convert to Hex first!
    if (nic.ioaddr == "0x880")
    {
      nicString +=  " (System Brd)";
    }
    else
    { 
      if ( nic.memtype == 3 )
      {
        //code block below must be exactly like this to work in both Netscape and IE browsers
        if( 0 > nic.ioaddr ) 
        {
          nic.ioaddr = - nic.ioaddr;
          nic.ioaddr = (0xFFFFFFFF+1) - nic.ioaddr;
        }

        upperMemAddr = ( nic.ioaddr / 16) & 0xfffffff;
        lowerMemAddr = nic.ioaddr & 0xf;
        hexMemAddr = upperMemAddr.toString(16).toUpperCase() + lowerMemAddr.toString(16).toUpperCase();
        //end block

        if(-1 != nic.real_slot && 4294967295 != nic.real_slot)
          nicString +=  " Mem " + hexMemAddr;

      }
      else
      {
        nicString +=  " I/O " + hexfromdec(nic.ioaddr);
      }
    }
  }
  else
  {
    if(parseInt(nic.slot))
    {
      if (!isPartitionedSystem() || ("" == nic.hwlocation) || ("NULL" == nic.hwlocation) || (null == nic.hwlocation) )
        nicString += " in Slot " + nic.slot;
    }
    else
      nicString = "Embedded " + nicString;
  }

  if ( isPartitionedSystem() && ("" != nic.hwlocation) && ("NULL" != nic.hwlocation) && (null != nic.hwlocation) )
    nicString += " at " + nic.hwlocation;
    
  if (nic.needport)
    nicString += " Port " + nic.port;

  return nicString;
}

function buildString(nic)
{
  var nicString = "";

  if("undefined" == typeof(nic.NicName) || "" == nic.NicName)
    nicString = getModelName(nic);
  else
    nicString = nic.NicName;

  nicString += buildHwLocation(nic);
  
  return nicString;

}

function displayNicItem(itemName, itemValue)
{
  rc = parseInt(itemValue);
  if (itemValue == null)
    rc = "N/A";
  else
  if (rc < 0)
    rc = "N/A";
  else
  if (rc == 4294967295)
    rc = "N/A";
  else
  if (isNaN(rc))
    rc = "N/A";
  else
    rc = displayItem(itemName, itemValue);
  return rc;
}

function displayStatItem(itemValue)
{
  rc = parseInt(itemValue);
  if (itemValue == null)
    rc = "N/A";
  else
  if (rc < 0)
    rc = "N/A";
  else
  if (rc == 4294967295)
    rc = "N/A";
  else
  if (isNaN(rc))
    rc = "N/A";
  else
    rc = itemValue;
  return rc;
}

// added for compatibility between java 1.0 and 1.1 parseInt;
// if value is Not-A-Number, return 0; this is what was done
// in java 1.0 when parseInt could not parse a number. -tonycu
function parseNicInt(itemValue)
{
  rc = parseInt(itemValue);
  if (isNaN(rc))
    rc = 0;
  return rc;
}


//********************************************************************

function physName( physIndex )
{
   var i, j;
   var pname = "Single NIC";

   for(i=0; i<cpqNicIfPhysAdapterEntry.length; i++)
   {
      if( physIndex == cpqNicIfPhysAdapterEntry[i].cpqNicIfPhysAdapterIndex )
      {
         break;
      }
   }

   if(i < cpqNicIfPhysAdapterEntry.length)
   {

      // create an object that mimics an entry in the nicinfotable to fake out the
      // function getModelName from the older NIC stuff
      nic = new Object;
      nic.ioaddr = cpqNicIfPhysAdapterEntry[i].cpqNicIfPhysAdapterIoAddr;
      nic.memaddr = cpqNicIfPhysAdapterEntry[i].cpqNicIfPhysAdapterMemAddr;
      nic.memtype = 2;

      if(nic.ioaddr == 0)    //=0 -> memory mapped i/o  (jo012500)
      {
        nic.ioaddr = cpqNicIfPhysAdapterEntry[i].cpqNicIfPhysAdapterMemAddr;
        nic.memtype = 3;
      }

      
      nic.slot = cpqNicIfPhysAdapterEntry[i].cpqNicIfPhysAdapterSlot;
      nic.hwlocation = cpqNicIfPhysAdapterEntry[i].cpqNicIfPhysAdapterHwLocation;
      
      for(j=0;j<cpqNicIfPhysAdapterEntry.length; j++)
      {
         if( physIndex!=cpqNicIfPhysAdapterEntry[j].cpqNicIfPhysAdapterIndex &&
             nic.slot == cpqNicIfPhysAdapterEntry[j].cpqNicIfPhysAdapterSlot )
             {
               nic.needport = true;
               nic.port = cpqNicIfPhysAdapterEntry[i].cpqNicIfPhysAdapterPort;
             }
      }

      if( -1==nic.slot || 4294967295==nic.slot)  // old way was 0 for both embedded and unknown
      {
         nic.real_slot = nic.slot;
         nic.slot = 0;     // new way has 0 for embedded and 255 for unknown
      }

      if("undefined" !=
         typeof(cpqNicIfPhysAdapterEntry[i].cpqNicIfPhysAdapterName))
        nic.NicName = cpqNicIfPhysAdapterEntry[i].cpqNicIfPhysAdapterName;
          
      pname = buildString( nic );
   }

   return pname;
}

function nicName( logNicIndex )
{
   var i,j;
   var logName = "unknown NIC";
   var ifnum;

   for(i=0; i<cpqNicIfLogMapEntry.length; i++)
   {
      if( cpqNicIfLogMapEntry[i].cpqNicIfLogMapIndex == logNicIndex )
      {
         break;
      }
   }

   if( i < cpqNicIfLogMapEntry.length )
   {
      ifnum=0;
      for(j=0; j<4 && j<cpqNicIfLogMapIfNumber[i].length; j++)
      {
         ifnum += cpqNicIfLogMapIfNumber[i][j] << 8*j;
      }
      var ifnumDisplay = ifnum.toString(16);

      if( cpqNicIfLogMapEntry[i].cpqNicIfLogMapGroupType > 2 )
      {
         logName = cpqNicIfLogMapEntry[i].cpqNicIfLogMapDescription;
         if(""==logName)
         {
            logName = displayItem("cpqNicIfLogMapGroupType", cpqNicIfLogMapEntry[i].cpqNicIfLogMapGroupType);
         }

         logName = logName + " (" + ifnumDisplay + ")";
      }
      else if( 0 == cpqNicIfLogMapEntry[i].cpqNicIfLogMapAdapterCount )
      {
         logName = "Virtual Interface " + ifnumDisplay;
      }
      else
      {
         logName = physName( cpqNicIfLogMapPhysicalAdapters[i][0] );
      }

   }

   return logName;
}

function PhyIndexToLogicalIndex(p_index)
{
  p_index++;
  for(i = 0; i < cpqNicIfLogMapPhysicalAdapters.length; i ++)
  {
    for(j = 0; j < cpqNicIfLogMapPhysicalAdapters[i].length; j++)
    {
      if(parseInt(cpqNicIfLogMapPhysicalAdapters[i][j]) == parseInt(p_index))
        return i;
    }
  }
  return 0;
}

function writeControllerInfo( physindex )
{
   with( cpqNicIfPhysAdapterEntry[physindex] )
   {
      var model = "";
      var nic = new Object;
      var label;
      var nicType;
      var ifindex;
      var i;
      var slot;

  if("undefined" != typeof(cpqNicIfPhysAdapterName))
    model = cpqNicIfPhysAdapterName;

  if("" == model)
  {
    // fake out old getModelName function by creating a nic object and
    // putting in the necessary members to have that function work
    nic.ioaddr = cpqNicIfPhysAdapterIoAddr;
    nic.memaddr = cpqNicIfPhysAdapterMemAddr;
    nic.memtype = 2;
    if(nic.ioaddr == 0)    //=0 -> memory mapped i/o  (jo012500)
    {
      nic.ioaddr = cpqNicIfPhysAdapterMemAddr;
      nic.memtype = 3;
    }
    nic.slot = (-1==cpqNicIfPhysAdapterSlot ||
      4294967295==cpqNicIfPhysAdapterSlot) ? 0 :
      cpqNicIfPhysAdapterSlot;  // new way is 0->embedded, -1->unknown old was 0 for both
    nic.real_slot = cpqNicIfPhysAdapterSlot;
    model = getModelName( nic );
    if(""==model)  model = "Unknown";
  }

  label = "Controller Information";
  nicType = 1;
  if( 3 < window.cpqNicIfPhysAdapterIfNumber[physindex].length )
  {
    ifindex=0;

    for(i=0;i<4;i++)
    {
      ifindex += window.cpqNicIfPhysAdapterIfNumber[physindex][i] << (4*i);
    }

    for(i=0;i<ifEntry.length;i++)
    {
      if( ifindex == ifEntry[i].ifIndex )
      {
        nicType = ifEntry[i].ifType;
        break;
      }
    }
  }

  if(1<nicType)
  {
    label = displayItem("ifType", nicType) + " " + label;
  }

  writeTableLabel( label );
  writeTableHead();
  writeSingleTableRowInDoubleTable("Model:",   model);
  writeDoubleTableRow(
         "Status:",  displayItem( "cpqNicIfPhysAdapterStatus", cpqNicIfPhysAdapterStatus),
         "Role:",    displayItem( "cpqNicIfPhysAdapterRole",   cpqNicIfPhysAdapterRole)
         );

  if(!isHPVM())
  {
    slot = displayItem( "cpqNicIfPhysAdapterSlot",   cpqNicIfPhysAdapterSlot);
    if(-1==slot || 4294967295==slot)
      slot = "Unknown";
    else if(0==slot)
      slot = "Embedded";

    writeDoubleTableRow(
        "Slot (CBHSS):", slot,
        "Port:", displayItem( "cpqNicIfPhysAdapterPort",   cpqNicIfPhysAdapterPort)
        );
  }

//code block below must be exactly like this to work in both Netscape and IE browsers
  var tmpMemAddr = cpqNicIfPhysAdapterMemAddr;
  if(0>tmpMemAddr)
  {
    tmpMemAddr = - tmpMemAddr;
    tmpMemAddr = (0xFFFFFFFF+1) - tmpMemAddr ;
  }
  upperMemAddr = (tmpMemAddr / 16) & 0xfffffff;
  lowerMemAddr = tmpMemAddr & 0xf;
  hexMemAddr = upperMemAddr.toString(16).toUpperCase() + lowerMemAddr.toString(16).toUpperCase() + "h";
//end block

  writeDoubleTableRow(
       "Duplex:",        displayItem( "cpqNicIfPhysAdapterDuplexState",  cpqNicIfPhysAdapterDuplexState),
       "Base Mem Addr:",  0==cpqNicIfPhysAdapterMemAddr ? "N/A" : hexMemAddr
       );
  writeDoubleTableRow(
       "Base I/O Addr:", 0==cpqNicIfPhysAdapterIoAddr ? "N/A" : (cpqNicIfPhysAdapterIoAddr-0).toString(16) + "h",
       "DMA Channel:",   displayItem( "cpqNicIfPhysAdapterDma",  cpqNicIfPhysAdapterDma)
       );
  writeDoubleTableRow(
       "IRQ:",              0==cpqNicIfPhysAdapterIrq ? "N/A" : cpqNicIfPhysAdapterIrq,
       "Physical Address:", rawToHex( window.cpqNicIfPhysAdapterMACAddress[physindex], " ")
       );

/*
Must confirm with Ricky.
Since 
cpqNicIfPhysAdapterSlot="80107";
cpqNicIfPhysAdapterHwLocation="Cabinet 8, IO Bay 0, IO Chassis 1, Slot 7 - Connected To - Cabinet 0, Cell 3"
seems wrong:
  (cabinet 8->cabinet 0)
  (Slot 80107->Slot7)

*/
  if(isPartitionedSystem())
  {
    var hwlocation = "";
    
    writeSingleTableRowInDoubleTable(
      "Hardware Location:", displayItem( "cpqNicIfPhysAdapterHwLocation", cpqNicIfPhysAdapterHwLocation)
    );
  }


  if(typeof(cpqNicIfLogMapEntry[PhyIndexToLogicalIndex(physindex)].cpqNicIfLogMapAdvancedTeaming) != "undefined" &&
parseInt(cpqNicIfLogMapEntry[PhyIndexToLogicalIndex(physindex)].cpqNicIfLogMapAdvancedTeaming) & (8|4))
  {
    if(parseInt(cpqNicIfPhysAdapterAggregationGID) >= 0)
      writeDoubleTableRow(
           "Aggregation Group:", cpqNicIfPhysAdapterAggregationGID,
           "", ""
           );
  }

  if(1 == cpqNicIfPhysAdapterStatsValid)
  {
    writeSingleTableRowInDoubleTable( "&#160", "&#160" );
    writeDoubleTableRow( "<u>Receive Statistics</u>",  "&#160", "<u>Transmit Statistics</u>",  "&#160");
    writeDoubleTableRow(
         "Good Frames:",   displayItem("cpqNicIfPhysAdapterGoodReceives", cpqNicIfPhysAdapterGoodReceives),
         "Good Frames:",   displayItem("cpqNicIfPhysAdapterGoodTransmits", cpqNicIfPhysAdapterGoodTransmits)
           );
    writeDoubleTableRow(
         "Bad Frames:",   displayItem("cpqNicIfPhysAdapterBadReceives", cpqNicIfPhysAdapterBadReceives),
         "Bad Frames:",   displayItem("cpqNicIfPhysAdapterBadTransmits", cpqNicIfPhysAdapterBadTransmits)
            );
    writeDoubleTableRow(
         "Alignment Errors:",   displayItem("cpqNicIfPhysAdapterAlignmentErrors", cpqNicIfPhysAdapterAlignmentErrors),
         "Carrier Sense Err:",   displayItem("cpqNicIfPhysAdapterCarrierSenseErrors", cpqNicIfPhysAdapterCarrierSenseErrors)
         );
    writeDoubleTableRow(
         "Frame Too Long:",   displayItem("cpqNicIfPhysAdapterFrameTooLongs", cpqNicIfPhysAdapterFrameTooLongs),
         "Mult. Coll. Frames:",   displayItem("cpqNicIfPhysAdapterMultipleCollisionFrames", cpqNicIfPhysAdapterMultipleCollisionFrames)
         );
    writeDoubleTableRow(
         "FCS Errors:",   displayItem("cpqNicIfPhysAdapterFCSErrors", cpqNicIfPhysAdapterFCSErrors),
         "Late Collisions:",   displayItem("cpqNicIfPhysAdapterLateCollisions", cpqNicIfPhysAdapterLateCollisions)
         );
    writeDoubleTableRow(
         "MAC Recv Errs:",   displayItem("cpqNicIfPhysAdapterInternalMacReceiveErrors", cpqNicIfPhysAdapterInternalMacReceiveErrors),
         "Single Coll. Frames:",   displayItem("cpqNicIfPhysAdapterSingleCollisionFrames", cpqNicIfPhysAdapterSingleCollisionFrames)
         );
    writeDoubleTableRow(
         "&#160", "&#160",
         "Excessive Coll.:",   displayItem("cpqNicIfPhysAdapterExcessiveCollisions", cpqNicIfPhysAdapterExcessiveCollisions)
         );
    writeDoubleTableRow(
         "&#160", "&#160",
         "Deferred Xmits:",   displayItem("cpqNicIfPhysAdapterDeferredTransmissions", cpqNicIfPhysAdapterDeferredTransmissions)
         );
    writeDoubleTableRow(
         "&#160", "&#160",
         "MAC Xmit Errs:",   displayItem("cpqNicIfPhysAdapterInternalMacTransmitErrors", cpqNicIfPhysAdapterInternalMacTransmitErrors)
         );
  }
  writeTableTail();
  }
}

function writeIfInfo( ifindex, vlanId, vlanName,sysUpTime, logindex )
{
   var i;
   var tableindex;
   var buffer1;
   var x, i;
   var physAddress;
   var lastChange;
   var diffTimeValue, diffDays, diffHours, diffMinutes;
   var statindex, protocolindex;
   var interfaceStatus;
   var speed =  cpqNicIfLogMapEntry[logindex].cpqNicIfLogMapSpeed;
   var ifLastChange =  cpqNicIfLogMapEntry[logindex].cpqNicIfLogMapLastChange;
   var tmp;

   for(tableindex=0;tableindex<ifEntry.length;tableindex++)
   {
     if(ifEntry[tableindex].ifIndex == ifindex )
     {

     //hack so that the interface description does not include the string "&#000" - problem unique to Win2000
     if((ifDescPosition =ifEntry[tableindex].ifDescr.lastIndexOf("&#000")) != -1)
     {
       ifEntry[tableindex].ifDescr = ifEntry[tableindex].ifDescr.substring(0,ifDescPosition);
     }
     //end of hack

     if(3 == cpqHoOsType ||
       15 == cpqHoOsType ||
       17 == cpqHoOsType ||
       18 == cpqHoOsType) // winnt, 2k, 2003, 2003x64
     {
       // get the name from cpq mib and not from MIB2
       var logname = cpqNicIfLogMapEntry[logindex].cpqNicIfLogMapDescription;

       if("" != logname)
         ifEntry[tableindex].ifDescr = logname;
     }

     writeTableLabel("Interface Information - " + displayItem("ifDescr", ifEntry[tableindex].ifDescr));

     writeTableHead();

     for(i=0; i<ipAddrEntry.length; i++)
     {
       if( ipAddrEntry[i].ipAdEntIfIndex == ifindex )
       {
         var ipAddress = ipAdEntAddr[i][0] + "." + ipAdEntAddr[i][2] + "." + ipAdEntAddr[i][4] + "." + ipAdEntAddr[i][6];
	 if (ipAddress == "0.0.0.0"){
	 	ipAddress = "N/A";
	 }
         writeSingleTableRowInDoubleTable("IP Address:", ipAddress);

         break;
       }
     }

     if ( vlanId > 0 )
     {
       writeDoubleTableRow( "VLAN Id:", displayItem( "cpqNicIfVlanMapVlanId", vlanId), "VLAN Name:", vlanName );
     }
	if( 0 == cpqNicIfLogMapEntry[logindex].cpqNicIfLogMapAdapterCount ) {
		speed = "N/A";
	}
	else {

	     if ( tableindex > 0 )
	     {
	       if (speed >= 1000000)
		 speed = (speed/1000000) + " Mbit/Sec";
	     }
	     else if(cpqHoOsType == 2)
	     {
	       if (speed >= 1000000)
		 speed = (speed/1000000) + " Mbit/Sec";
	     }
	     else
	       speed = "N/A";

	     if(typeof(cpqNicIfLogMapEntry[logindex].cpqNicIfLogMapSpeedMbps) != "undefined")
	     {
	       var dwspeed = parseInt(cpqNicIfLogMapEntry[logindex].cpqNicIfLogMapSpeedMbps);
	       if(dwspeed < 1000)
		 speed = dwspeed + " Mbps";
	       else
		 speed = (dwspeed/1000.0) + " Gbps";
	     }

             // bug 7793 wrong Speed displayed at the Network page at IMA webapp
             // changed by Spark Xu 2008-07-22
             //****************************************************************
	     //if(cpqNicIfLogMapEntry[logindex].cpqNicIfLogMapCondition == 4)
	     //  speed = "Unknown";
             //****************************************************************
	}

     writeDoubleTableRow("Type:",  displayItem("ifType", ifEntry[tableindex].ifType),
          "Speed:", displayItem("ifSpeed", speed));


     buffer1 = "";
     for (x=0; x<=5; x++)
     {
       if (ifPhysAddress[tableindex][x] == null)
         buffer1 = buffer1 + "00 ";
       else
         buffer1 = buffer1 + hexfromdec(ifPhysAddress[tableindex][x]).substring(2, 4) + " ";
     }
     if (buffer1 == "00 00 00 00 00 00 ")
       physAddress = "N/A";
     else
       physAddress = buffer1;
  // Determine the interface status from cpqNicIfPhysAdapterStatus. A "OK" in cpqNicIfPhysAdapterStatus
   // is treated as "Up" and everything else is treated as "Down". Assuming that the 'tableindex' used to
   // determine index into ifEntry table can be used to get the index into cpqNicPhysAdapterEntry table.
   // This change affects all the Operating Systems (Windows, Netware and Linux). The issue is with the
   // Netware and Linux not updating the ifOperStatus, when link is lost on a NIC.
   
   	var cond;
   	var interfaceStatus;
   
   	if( 0 == cpqNicIfLogMapEntry[logindex].cpqNicIfLogMapAdapterCount ) {
   	   	cond = new cpqCondition(2);
   	    interfaceStatus = cond.image() + "OK";
       }
       else {
   	   	cond = new cpqCondition( cpqNicIfLogMapEntry[logindex].cpqNicIfLogMapCondition );
   	    interfaceStatus = cond.image() + displayItem("cpqNicIfLogMapStatus", cpqNicIfLogMapEntry[logindex].cpqNicIfLogMapStatus);
       }

        writeDoubleTableRow(
              "Interface Status:", interfaceStatus,
              "Physical Addr:",    displayItem("ifPhysAddress", physAddress)
            );
         //if (ifEntry[tableindex].ifLastChange < 0 || sysUpTime < 0)
         if (ifLastChange < 0 || sysUpTime < 0) {
           lastChange = "N/A";
         }

         if (cpqHoOsType == 14) {
           if (hrSystemUptime == "NULL") {
             lastChange = "N/A";
           }
           else {
             tmp = sysUpTime;
             sysUpTime = hrSystemUptime;
           }
         } 

         if (lastChange != "N/A") {
	/****************************************************************************
	#bug7792 IMA webapp shows the different value of ' Last Status Change'
	Add by Spark Xu 2008-07-31
	****************************************************************************/
            if ( ifLastChange == 0 ){
		diffTimeValue = sysUpTime / 6000;
	    }
	    else{	
		diffTimeValue = ifLastChange / 6000;
	    }	
            diffDays = parseNicInt( diffTimeValue / 1440 ); 
            diffHours = parseNicInt( (diffTimeValue % 1440) / 60);
            diffMinutes = parseNicInt( diffTimeValue % 60);
            if (diffDays > 0)
            {
               lastChange = diffDays + " Days, " +
                  diffHours + " Hours, " +
                  diffMinutes + " Minutes ago";
            }
            else
            if (diffHours > 0)
            {
               lastChange = diffHours + " Hours, " +
                  diffMinutes + " Minutes ago";
            }
            else
               lastChange = diffMinutes + " Minutes ago";
         }

         if (cpqHoOsType == 14) {
             sysUpTime = tmp;
         }
         writeDoubleTableRow(
            "Max Packet Size:",     displayItem("ifMtu", ifEntry[tableindex].ifMtu + " bytes"),
            "Last Status Change:",  displayItem("ifLastChange", lastChange)
            );

         writeDoubleTableRow("<br><u>Receive Statistics</u>", "&#160", "<br><u>Transmit Statistics</u>", "&#160");
         writeDoubleTableRow(
            "Bytes:", displayStatItem(ifEntry[tableindex].ifInOctets),
            "Bytes:", displayStatItem(ifEntry[tableindex].ifOutOctets)
            );
         writeDoubleTableRow(
            "Total Packets:", displayStatItem((parseNicInt(ifEntry[tableindex].ifInUcastPkts) +
               parseNicInt(ifEntry[tableindex].ifInNUcastPkts) +
               parseNicInt(ifEntry[tableindex].ifInDiscards) +
               parseNicInt(ifEntry[tableindex].ifInErrors) +
               parseNicInt(ifEntry[tableindex].ifInUnknownProtos))),
            "Total Packets:", displayStatItem((parseNicInt(ifEntry[tableindex].ifOutUcastPkts) +
               parseNicInt(ifEntry[tableindex].ifOutNUcastPkts) +
               parseNicInt(ifEntry[tableindex].ifOutDiscards) +
               parseNicInt(ifEntry[tableindex].ifOutErrors)))
               );
         writeDoubleTableRow(
            "Unicast Packets:", displayStatItem(ifEntry[tableindex].ifInUcastPkts),
            "Unicast Packets:",  displayStatItem(ifEntry[tableindex].ifOutUcastPkts)
            );
         writeDoubleTableRow(
            "Non-Unicast Packets:", displayStatItem(ifEntry[tableindex].ifInNUcastPkts),
            "Non-Unicast Packets:", displayStatItem(ifEntry[tableindex].ifOutNUcastPkts)
            );
         writeDoubleTableRow(
            "Discarded Packets:", displayStatItem(ifEntry[tableindex].ifInDiscards),
            "Discarded Packets:", displayStatItem(ifEntry[tableindex].ifOutDiscards)
            );
         writeDoubleTableRow(
            "Error Packets:", displayStatItem(ifEntry[tableindex].ifInErrors),
            "Error Packets:", displayStatItem(ifEntry[tableindex].ifOutErrors)
            );
         writeDoubleTableRow(
            "Unknown Protocols:", displayStatItem(ifEntry[tableindex].ifInUnknownProtos),
            "Queue Length:", displayStatItem(ifEntry[tableindex].ifOutQLen)
            );

         writeTableTail();

         if( 6 == ifEntry[tableindex].ifType || 7 == ifEntry[tableindex].ifType )
         {
            for(statindex=0; statindex < dot3StatsEntry.length; statindex++)
            {

               if( dot3StatsEntry[statindex].dot3StatsIndex == ifindex )
               {
                  document.write("<br>");
                  writeEthernetStats( statindex );
                  break;
               }
            }
         }
         else if( 9 == ifEntry[tableindex].ifType )
         {

            for(protocolindex=0; protocolindex<dot5Entry.length; protocolindex++)
            {

               if( dot5Entry[protocolindex].dot5IfIndex == ifindex )
               {

                  document.write("<br>");

                  writeTokenRingInfo( protocolindex );
               }
            }

            for(statindex=0; statindex < dot5StatsEntry.length; statindex++)
            {

               if( dot5StatsEntry[statindex].dot5StatsIfIndex == ifindex )
               {

                  document.write("<br>");

                  writeTokenRingStats( statindex );
                  break;
               }
            }
         }
      }
   }
}

function writeEthernetStats( dot3pageindex )
{
   var   receiveTotalErrors,
         frameTooLongs,
         alignmentErrors,
         macReceiveErrors,
         fcsErrors,
         transmitTotalErrors,
         macTransmitErrors,
         carrierSenseErrors,
         multipleCollisionFrames,
         lateCollisions,
         singleCollisionFrames,
         excessiveCollisions,
         deferredTransmissions
         ;

   frameTooLongs = dot3StatsEntry[dot3pageindex].dot3StatsFrameTooLongs;
   alignmentErrors = dot3StatsEntry[dot3pageindex].dot3StatsAlignmentErrors;
   macReceiveErrors = dot3StatsEntry[dot3pageindex].dot3StatsInternalMacReceiveErrors;
   fcsErrors = dot3StatsEntry[dot3pageindex].dot3StatsFCSErrors;

   if(-1 == fcsErrors || 4294967295 == fcsErrors)
     fcsErrors = 0;

   receiveTotalErrors = displayStatItem(
      parseNicInt(alignmentErrors) +
      parseNicInt(fcsErrors) +
      parseNicInt(frameTooLongs) +
      parseNicInt(macReceiveErrors)
      );

   frameTooLongs = displayStatItem(frameTooLongs);
   alignmentErrors = displayStatItem(alignmentErrors);
   macReceiveErrors = displayStatItem(macReceiveErrors);
   fcsErrors = displayStatItem(dot3StatsEntry[dot3pageindex].dot3StatsFCSErrors);

   transmitTotalErrors = displayStatItem(
      parseNicInt(dot3StatsEntry[dot3pageindex].dot3StatsCarrierSenseErrors) +
      parseNicInt(dot3StatsEntry[dot3pageindex].dot3StatsLateCollisions) +
      parseNicInt(dot3StatsEntry[dot3pageindex].dot3StatsExcessiveCollisions) +
      parseNicInt(dot3StatsEntry[dot3pageindex].dot3StatsInternalMacTransmitErrors) +
      parseNicInt(dot3StatsEntry[dot3pageindex].dot3StatsMultipleCollisionFrames) +
      parseNicInt(dot3StatsEntry[dot3pageindex].dot3StatsSingleCollisionFrames) +
      parseNicInt(dot3StatsEntry[dot3pageindex].dot3StatsDeferredTransmissions)
      );

   macTransmitErrors = displayStatItem(dot3StatsEntry[dot3pageindex].dot3StatsInternalMacTransmitErrors);
   carrierSenseErrors = displayStatItem(dot3StatsEntry[dot3pageindex].dot3StatsCarrierSenseErrors);
   multipleCollisionFrames = displayStatItem(dot3StatsEntry[dot3pageindex].dot3StatsMultipleCollisionFrames);
   lateCollisions = displayStatItem(dot3StatsEntry[dot3pageindex].dot3StatsLateCollisions);
   singleCollisionFrames = displayStatItem(dot3StatsEntry[dot3pageindex].dot3StatsSingleCollisionFrames);
   excessiveCollisions = displayStatItem(dot3StatsEntry[dot3pageindex].dot3StatsExcessiveCollisions);
   deferredTransmissions = displayStatItem(dot3StatsEntry[dot3pageindex].dot3StatsDeferredTransmissions);

   writeTableLabel("Interface Ethernet Statistics");
   writeTableHead();
   writeDoubleTableRow("<u>Receive Errors</u>", "", "", "");
   writeDoubleTableRow(
    "Total Errors:",     receiveTotalErrors,
    "Frame Too Long:",   frameTooLongs
    );
   writeDoubleTableRow(
      "Alignment Errors:", alignmentErrors,
      "MAC Recv Errs:",    macReceiveErrors
      );
   writeDoubleTableRow(
      "FCS Errors:", fcsErrors,
      "",            ""
      );

   writeDoubleTableRow("&#160<br><u>Transmit Errors</u>", "", "", "");
   writeDoubleTableRow(
     "Total Errors:",  transmitTotalErrors,
     "MAC Xmit Errs:", macTransmitErrors
     );
   writeDoubleTableRow(
     "Carrier Sense Err:",   carrierSenseErrors,
     "Mult. Coll. Frames:",  multipleCollisionFrames
     );
   writeDoubleTableRow(
     "Late Collisions:",     lateCollisions,
     "Single Coll. Frames:", singleCollisionFrames
     );
   writeDoubleTableRow(
     "Excessive Coll:",   excessiveCollisions,
     "Deferred Xmits:",   deferredTransmissions
     );
   writeTableTail();
}

function writeTokenRingInfo( dot5pageindex )
{
   var   ringSpeed,
         upstreamAddr,
         ringState,
         actMonParticipate,
         ringStatus,
         functionalAddr,
         ringOpenStatus
         ;

   ringSpeed = displayNicItem("dot5RingSpeed", dot5Entry[dot5pageindex].dot5RingSpeed);
   if ( "0,0,0,0,0,0" == dot5UpStream[dot5pageindex] )
        upstreamAddr = "N/A";
   else
        upstreamAddr = rawToHex( dot5UpStream[dot5pageindex], " ");
   ringState = displayNicItem("dot5RingState", dot5Entry[dot5pageindex].dot5RingState);
   actMonParticipate = displayNicItem("dot5ActMonParticipate", dot5Entry[dot5pageindex].dot5ActMonParticipate);
   //ringStatus = rawToHex( dot5RingStatus[dot5pageindex], " ");
   ringStatus = (dot5Entry[dot5pageindex].dot5RingStatus - 0).toString(16) + "h";
   functionalAddr = rawToHex(dot5Functional[dot5pageindex], " ");
   ringOpenStatus = displayNicItem("dot5RingOpenStatus", dot5Entry[dot5pageindex].dot5RingOpenStatus);

   writeTableLabel("Interface Token Ring Information");
   writeTableHead();
   writeDoubleTableRow(
    "Ring Speed:",    ringSpeed,
    "Upstream Addr:", upstreamAddr
    );
   writeDoubleTableRow(
    "Ring State:",       ringState,
    "Active Monitor:",   actMonParticipate
    );
   writeDoubleTableRow(
    "Ring Status:",      ringStatus,
    "Functional Addr:",  functionalAddr
    );
   writeDoubleTableRow(
    "Ring Open Status:", ringOpenStatus,
    "",                  ""
    );
   writeTableTail();

}

function writeTokenRingStats( dot5statsindex )
{
   var   lostFrameErrors,
         internalErrors,
         receiveCongestions,
         tokenErrors,
         frameCopiedErrors,
         transmitBeacons,
         abortTransErrors,
         removes,
         softErrors,
         recoverys,
         hardErrors,
         lobeWires,
         lineErrors,
         signalLoss,
         burstErrors,
         freqErrors,
         acErrors,
         singles
         ;

   lostFrameErrors = displayStatItem(dot5StatsEntry[dot5statsindex].dot5StatsLostFrameErrors);
   internalErrors = displayStatItem(dot5StatsEntry[dot5statsindex].dot5StatsInternalErrors);
   receiveCongestions = displayStatItem(dot5StatsEntry[dot5statsindex].dot5StatsReceiveCongestions);
   tokenErrors = displayStatItem(dot5StatsEntry[dot5statsindex].dot5StatsTokenErrors);
   frameCopiedErrors = displayStatItem(dot5StatsEntry[dot5statsindex].dot5StatsFrameCopiedErrors);
   transmitBeacons = displayStatItem(dot5StatsEntry[dot5statsindex].dot5StatsTransmitBeacons);
   abortTransErrors = displayStatItem(dot5StatsEntry[dot5statsindex].dot5StatsAbortTransErrors);
   removes = displayStatItem(dot5StatsEntry[dot5statsindex].dot5StatsRemoves);
   softErrors = displayStatItem(dot5StatsEntry[dot5statsindex].dot5StatsSoftErrors);
   recoverys = displayStatItem(dot5StatsEntry[dot5statsindex].dot5StatsRecoverys);
   hardErrors = displayStatItem(dot5StatsEntry[dot5statsindex].dot5StatsHardErrors);
   lobeWires = displayStatItem(dot5StatsEntry[dot5statsindex].dot5StatsLobeWires);
   lineErrors = displayStatItem(dot5StatsEntry[dot5statsindex].dot5StatsLineErrors);
   signalLoss = displayStatItem(dot5StatsEntry[dot5statsindex].dot5StatsSignalLoss);
   burstErrors = displayStatItem(dot5StatsEntry[dot5statsindex].dot5StatsBurstErrors);
   freqErrors = displayStatItem(dot5StatsEntry[dot5statsindex].dot5StatsFreqErrors);
   acErrors = displayStatItem(dot5StatsEntry[dot5statsindex].dot5StatsACErrors);
   singles = displayStatItem(dot5StatsEntry[dot5statsindex].dot5StatsSingles);

   writeTableLabel("Interface Token Ring Statistics");
   writeTableHead();
   writeDoubleTableRow(
       "Lost Frame Errors:",   lostFrameErrors,
       "Internal Errors:",     internalErrors
       );
   writeDoubleTableRow(
       "Receive Congest:",  receiveCongestions,
       "Token Errors:",     tokenErrors
       );
   writeDoubleTableRow(
       "Frame Copy Errors:",   frameCopiedErrors,
       "Xmit Beacons:",        transmitBeacons
       );
   writeDoubleTableRow(
       "Abort Xmit Errors:",   abortTransErrors,
       "Removes:",             removes
       );
   writeDoubleTableRow(
       "Soft Errors:",   softErrors,
       "Recoveries:",    recoverys
       );
   writeDoubleTableRow(
       "Hard Errors:",   hardErrors,
       "Lobe Faults:",   lobeWires
       );
   writeDoubleTableRow(
       "Line Errors:",   lineErrors,
       "Signal Loss:",   signalLoss
       );
   writeDoubleTableRow(
       "Burst Errors:",     burstErrors,
       "Frequency Errs:",   freqErrors
       );
   writeDoubleTableRow(
       "AC Errors:",        acErrors,
       "Single Station:",   singles
       );
   writeTableTail();
}

