<!-- $Id: servSubsections.js,v 1.54 2007-11-23 14:49:49 sjaviel Exp $ -->
function ModUUID()
{
	if (!arguments || arguments.length < 1 || !RegExp)
	{
		return;
	}
	var tstr = arguments[0];
	var t = /([^%]*)%('.|0|\x20)?(-)?(\d+)?(\.\d+)?(%|x)(.*)/;
	var a = b = [];
	nSubst = 0;
	nMatches = 0;
	while (a = t.exec(tstr))
	{
		nMatches++;
		nSubst++;
		var param = arguments[nSubst];
		var subst = param;
		subst = ('' + parseInt(param).toString(16)).toLowerCase();
		tstr = subst;
	}
	return tstr;
}
		
//*************** GetCPUSpeedinTwoFloatDigit
function GetCPUSpeedinTwoFloatDigit(s)
{
	var cpuspeed = s/1000 + "";
	return cpuspeed;
}
//*************** End of GetCPUSpeedinTwoFloatDigit

//*************** cpuHeader
function cpuHeader(cabNumber, cellNumber, socketNumber, numOfCores, threadStatus, generation, friendly)
{
    var openTag = "";
    var closeTag = "";
	if (!friendly) {
		openTag = "<h3 class=\"subTitle\">";
		closeTag = "</h3>";
	}

	var htmlCode = openTag;
	
	if (isPartitionedSystem()) {
		// cabinet number
		if (cabNumber != "") {
			htmlCode += "Cabinet: " + cabNumber + ",&nbsp;&nbsp;&nbsp;";
		}
		else {
			htmlCode += "Cabinet: N/A,&nbsp;&nbsp;&nbsp;";
		}

		// cell number
		if (cellNumber != "") {
			htmlCode += "Cell: " + cellNumber + ",&nbsp;&nbsp;&nbsp;";
		}
		else {
			htmlCode += "Cell: N/A,&nbsp;&nbsp;&nbsp;";
		}
	}

	// socket number
	if (socketNumber != "") {
		htmlCode += "Socket: " + socketNumber;
	}
	else {
		htmlCode += "Socket: N/A";
	}

	// number of cores
	if (numOfCores > 1) {
		if (numOfCores != "") {
			htmlCode += ",&nbsp;&nbsp;&nbsp;" + "Cores: " + numOfCores;
		}
		else {
			htmlCode += ",&nbsp;&nbsp;&nbsp;Cores: N/A";
		}
	}


	// thread status
	if (!(((generation == "Montecito") || (generation == "Montvale")) && (numOfCores == 1))) {
         	if (threadStatus == 2) {
			htmlCode += ",&nbsp;&nbsp;&nbsp;Thread Status: Enabled";
		}	
		else if(threadStatus == 3) {
			htmlCode += ",&nbsp;&nbsp;&nbsp;Thread Status: Disabled";
		}
	}

	htmlCode += closeTag;

	if (friendly) {
		var htmlCodeTmp = tableLabelH3(htmlCode);
		htmlCode = htmlCodeTmp;
	}

	return htmlCode;
}
//*************** End of cpuHeader

//*************** CPU
// returns a string with the whole CPUs subsection
// parameters:
//   friendly (true - format for friendly version
//             false - format to display normally in SMH)
//   cellIndex (the number of the cell to be printed. if receives -1, print CPUs
//              for all cells)
//   systemReport (true - section will be displayed in System Report page
//                 false - section will be displayed in a page other than System Report
function cpuSection(friendly, cellIndex, inSystemReport)
{
	var cpuSubsectionText = "";

	if (cpqSeCpuEntry.length == 0) {
		return getEmptySectionTable("Processor Details");
	}

	cpuSubsectionText += tableLabel("Processor Details");

	var displayCpus = new Array();
	for (i = 0 ; i < cpqSeCpuEntry.length; i++) {
		displayCpus[i] = new Object();
		displayCpus[i] = true;
	}

	var numOfDegradedCPU = 0;
	var totalActiveCPUs = 0;
	var socket, cores, proc, step, coproc, l4cache, maxspeed, serialnum;
	var partnum, action, generation, l3cache, coreNumber, currCellNum, cabinetNum;

	for ( i = 0 ; i < cpqSeCpuEntry.length; i++)
	{
		cpqSeCpuEntry[i].procstatus = new cpqCondition(cpqSeCpuEntry[i].cpqSeCpuStatus == 5 ? 3 : cpqSeCpuEntry[i].cpqSeCpuStatus);

		// don't display the current CPU if cellIndex != -1 and if the
		// current CPU don't belong to the cell referred by cellIndex
		if((cellIndex != -1) && (cellIndex != cpqSeCpuEntry[i].cpqSeCpuCellTablePtr)) {
			continue;
		}

		// if current CPU is OK, count it as an active CPU
		if (cpqSeCpuEntry[i].cpqSeCpuStatus == 2) {
			totalActiveCPUs++;
		}

		// don't display the current CPU if it belongs to a CPU socket
		// already displayed
		// don't display the current CPU if the slot is unused
		if (!displayCpus[i] || (cpqSeCpuEntry[i].cpqSeCpuStatus == 0)) {
			continue;
		}


		/********************** CPU HEADER ***********************************/
		// socket
		socket = "";
		if (!isHPVM()) {
			socket = displayItem("cpqSeCpuSocketNumber", cpqSeCpuEntry[i].cpqSeCpuSocketNumber);
		}

		// thread status
		threadStatus = (typeof(cpqSeCpuEntry[i].cpqSeCPUMultiThreadStatus) != "undefined") ? cpqSeCpuEntry[i].cpqSeCPUMultiThreadStatus : 1;

		// cores
		cores = "";
		if (!isHPVM()) {
			cores = cpqSeCpuEntry[i].cpqSeCpuCore;
		}

		// generation
		generation = displayItem("cpqSeCPUChipGenerationName", cpqSeCpuEntry[i].cpqSeCPUChipGenerationName);

		// cell number and cabinet number
		currCellNum = "";
		cabinetNum = "";
		if (isPartitionedSystem() && (cpqSeCellEntry.length > 0) &&
		    (cpqSeCpuEntry[i].cpqSeCpuCellTablePtr != "undefined")) {
			currCellNum = cpqSeCellEntry[cpqSeCpuEntry[i].cpqSeCpuCellTablePtr].cpqSeCellCellNumber;
			cabinetNum = cpqSeCellEntry[cpqSeCpuEntry[i].cpqSeCpuCellTablePtr].cpqSeCellCabinetNumber;
		}

		// show cpu header
		if (!isHPVM()) {
			cpuSubsectionText += cpuHeader(cabinetNum, currCellNum, socket, cores, threadStatus, generation, friendly);
		}
		else 
		{
			if (friendly) 
			{
				cpuSubsectionText += tableLabelH3("CPU " + i);
			} 
			else
			{
				cpuSubsectionText += "<h3 class=\"subTitle\">CPU " + i + "</h3>";
			}
		}

		cpuSubsectionText += ptTblHead(friendly);

		// processor
		proc = displayItem("cpqSeCpuEntry", cpqSeCpuEntry[i].cpqSeCpuName);
		if (cpqSeCpuEntry[i].cpqSeCpuSpeed != 0) {
			if(cpqSeCpuEntry[i].cpqSeCpuSpeed < 1000) {
				proc += " / " + cpqSeCpuEntry[i].cpqSeCpuSpeed + " MHz";
			}
			else {
				proc += " / " + GetCPUSpeedinTwoFloatDigit(cpqSeCpuEntry[i].cpqSeCpuSpeed) + " GHz";
			}
		}
		if (friendly) {
			cpuSubsectionText += singleTableRow("Processor:", proc);
		}
		else {
			cpuSubsectionText += singleTableRow(cpqSeCpuEntry[i].procstatus.image() + "Processor:", proc);
		}
		
		// step
		cpuSubsectionText += singleTableRow("Step:", displayItem("cpqSeCpuStep", cpqSeCpuEntry[i].cpqSeCpuStep));

		// coprocessor
		coproc = "none";
		for (k=0; k < cpqSeFpuEntry.length; k++) {
			if (cpqSeFpuEntry[k].cpqSeFpuUnitIndex ==  cpqSeCpuEntry[i].cpqSeCpuUnitIndex) {
				if (cpqSeFpuEntry[k].cpqSeFpuType == 2) {
					if(cpqSeFpuEntry[k].cpqSeFpuSpeed < 1000) {
						coproc = "Integrated " + cpqSeFpuEntry[k].cpqSeFpuName +
								 " / " + cpqSeFpuEntry[k].cpqSeFpuSpeed + " MHz";
					}
					else {
						coproc = "Integrated " + cpqSeFpuEntry[k].cpqSeFpuName +
								 " / " + GetCPUSpeedinTwoFloatDigit(cpqSeFpuEntry[k].cpqSeFpuSpeed) + " GHz";
					}
				}
				break;
			}
		}

		if (isHPVM() == false) {
			cpuSubsectionText += singleTableRow("Coprocessor:", coproc);
		}
		
 		if (cores <= 1){
 		// for other systems, don't show total cache and show cache per cpu
			cacheL3 = "", cacheL4 = "";
			for (var y = 0; y < cpqSeCpuCacheEntry.length; y++) {
				// match cache entry with current cpu
			if (cpqSeCpuEntry[i].cpqSeCpuSlot != cpqSeCpuCacheEntry[y].cpqSeCpuCacheCpuSlot){
					continue;
				}
				// don't show cache if size is 0
				if (cpqSeCpuCacheEntry[y].cpqSeCpuCacheSize <= 0) {
					continue;
				}
				// cache l3
				if (cpqSeCpuCacheEntry[y].cpqSeCpuCacheLevelIndex == 3) {
					cacheL3 = cpqSeCpuCacheEntry[y].cpqSeCpuCacheSize + " KB";
				}
				// cache l4
				if (cpqSeCpuCacheEntry[y].cpqSeCpuCacheLevelIndex == 4) {
					cacheL4 = cpqSeCpuCacheEntry[y].cpqSeCpuCacheSize + " KB";
				}
				// if both caches were found, finish loop
				if ((cacheL3 != "") && (cacheL4 != "")) {
					break;
				}
			}
			// show cache l3 (if found)
			if (cacheL3 != "") {
				cpuSubsectionText += singleTableRow("L3 Cache:", cacheL3);
			}
			// show cache l4 (if found)
			if (cacheL4 != "") {
				cpuSubsectionText += singleTableRow("L4 Cache:", cacheL4);
			}
		}
		
		// maximum speed
		maxspeed = cpqSeCpuEntry[i].cpqSeCPUMaxSpeed == 0 ? "N/A" : cpqSeCpuEntry[i].cpqSeCPUMaxSpeed + " MHz";
		cpuSubsectionText += singleTableRow("Maximum Speed:", maxspeed);

		// serial num, part num and action
		if (isHPVM() == false) {
			// serial num		
			cpuSubsectionText += singleTableRow("Serial Num:", displayItem("cpqSeCPUSerialNumberMfgr", cpqSeCpuEntry[i].cpqSeCPUSerialNumberMfgr));

			// part num
			cpuSubsectionText += singleTableRow("Part Num:", displayItem("cpqSeCPUPartNumberMfgr", cpqSeCpuEntry[i].cpqSeCPUPartNumberMfgr));
		}

		 if (cores > 1) {
			// for Hondo, Montvale and Montecito, show total cache per cpu and cache per core
			totalCacheL3 = 0, totalCacheL4 = 0, totalActiveLogicalProcs = 0;
			// search for cpus in the same socket
			lastCore = -1;
			for (var j = 0 ; j < cpqSeCpuEntry.length; j++) {
				sameSocket = false;
				// check if the CPUs are in the same socket
				var sockNumA = cpqSeCpuEntry[i].cpqSeCpuSocketNumber;
				var sockNumB = cpqSeCpuEntry[j].cpqSeCpuSocketNumber;

				if (sockNumA == sockNumB) {
					if (isPartitionedSystem() && (cpqSeCellEntry.length > 0)) {
						var cellNumA = cpqSeCellEntry[cpqSeCpuEntry[i].cpqSeCpuCellTablePtr].cpqSeCellCellNumber;
						var cellNumB = cpqSeCellEntry[cpqSeCpuEntry[j].cpqSeCpuCellTablePtr].cpqSeCellCellNumber;
						var cabNumA = cpqSeCellEntry[cpqSeCpuEntry[i].cpqSeCpuCellTablePtr].cpqSeCellCabinetNumber;
						var cabNumB = cpqSeCellEntry[cpqSeCpuEntry[j].cpqSeCpuCellTablePtr].cpqSeCellCabinetNumber;
						
						if ((cellNumA == cellNumB) && (cabNumA == cabNumB)) {
							sameSocket = true;
						}
					}
					else {
						sameSocket = true;
					}
				}

				// don't show if it's not in the same socket
				if (!sameSocket) {
					continue;
				}
				
				// count only once per logical cpu
				if(lastCore == cpqSeCpuEntry[j].cpqSeCPUCoreIndex) {
					continue;
				}
				lastCore = cpqSeCpuEntry[j].cpqSeCPUCoreIndex;

				for (var y = 0; y < cpqSeCpuCacheEntry.length; y++) {
					// match cache entry with current cpu
					if (cpqSeCpuEntry[i].cpqSeCpuUnitIndex != cpqSeCpuCacheEntry[y].cpqSeCpuCacheUnitIndex)  {
						continue;
					}			
					// add cache l3
					if (cpqSeCpuCacheEntry[y].cpqSeCpuCacheLevelIndex == 3) {
						totalCacheL3 += parseInt(cpqSeCpuCacheEntry[y].cpqSeCpuCacheSize);
					}
					// add cache l4
					if (cpqSeCpuCacheEntry[y].cpqSeCpuCacheLevelIndex == 4) {
						totalCacheL4 += parseInt(cpqSeCpuCacheEntry[y].cpqSeCpuCacheSize);
					}
				}

				// Total Number Of Active Logical Processors
				// don't add active logical processors if cpu is de-configured/disabled
				if ((cpqSeCpuEntry[i].cpqSeCpuStatus != 5) && (cpqSeCpuEntry[j].cpqSeCpuStatus != 5)) {
					if(cpqSeCpuEntry[j].cpqSeCPUMultiThreadStatus == 2) {
						totalActiveLogicalProcs += parseInt(cpqSeCpuEntry[j].cpqSeCPUCoreMaxThreads);
					}
					else {
						// if threads status is disabled or unknown, add 1 active logical processor
						totalActiveLogicalProcs++;						
					}
				}
			}
				
			if ((generation == "Montecito") || (generation == "Montvale")) {
				// show total cache l3 (if found)
				if (totalCacheL3 > 0) {
					cpuSubsectionText += singleTableRow("Total L3 Cache:", totalCacheL3 + " KB");
				}
				// show total cache l4 (if found)
				if (totalCacheL4 > 0) {
					cpuSubsectionText += singleTableRow("Total L4 Cache:", totalCacheL4 + " KB");
				}
			}

			// show total number of active logical processors
			cpuSubsectionText += singleTableRow("Total Number Of Active Logical Processors:", totalActiveLogicalProcs);
		}

		cpuSubsectionText += tblTail;


		/********************** CORES ****************************************/
		if (isHPVM() == false) {
			coreNumber = 0;
			lastCore = -1;
			hasDegradedCPU = false;
			// show cpu cores
			for ( j = 0 ; j < cpqSeCpuEntry.length; j++)
			{
				socketA = displayItem("cpqSeCpuSocketNumber", cpqSeCpuEntry[j].cpqSeCpuSocketNumber);

				sameSocket = false;

				// check if the CPUs are in the same socket
				var sockNumA = cpqSeCpuEntry[i].cpqSeCpuSocketNumber;
				var sockNumB = cpqSeCpuEntry[j].cpqSeCpuSocketNumber;

				if (sockNumA == sockNumB) {
					if (isPartitionedSystem() && (cpqSeCellEntry.length > 0)) {
						var cellNumA = cpqSeCellEntry[cpqSeCpuEntry[i].cpqSeCpuCellTablePtr].cpqSeCellCellNumber;
						var cellNumB = cpqSeCellEntry[cpqSeCpuEntry[j].cpqSeCpuCellTablePtr].cpqSeCellCellNumber;
						var cabNumA = cpqSeCellEntry[cpqSeCpuEntry[i].cpqSeCpuCellTablePtr].cpqSeCellCabinetNumber;
						var cabNumB = cpqSeCellEntry[cpqSeCpuEntry[j].cpqSeCpuCellTablePtr].cpqSeCellCabinetNumber;
						
						if ((cellNumA == cellNumB) && (cabNumA == cabNumB)) {
							sameSocket = true;
						}
					}
					else {
						sameSocket = true;
					}
				}

				// don't show if it's not in the same socket
				if (!sameSocket) {
					continue;
				}

				// avoid multicore cpus being displayed as multiple cpus
				displayCpus[j] = false;
				
				// count degraded cpus
				if(cpqSeCpuEntry[j].cpqSeCpuStatus == 3) {
					hasDegradedCPU = true;
				}

				// show cores only in Hondo, Montvale and Montecito			
				if (cores <= 1) {
					continue;
				}
				
				if(lastCore != cpqSeCpuEntry[j].cpqSeCPUCoreIndex) {
					lastCore = cpqSeCpuEntry[j].cpqSeCPUCoreIndex;

					if ((cpqSeCpuEntry[j].cpqSeCpuStatus != 0) && (cpqSeCpuEntry[j].cpqSeCpuCore > 0)) {
						l3cache = "";
						l4cache = "";
						for (y = 0; y < cpqSeCpuCacheEntry.length; y++) {
							if (cpqSeCpuCacheEntry[y].cpqSeCpuCacheCpuSlot == cpqSeCpuEntry[j].cpqSeCpuSlot) {
								// Verify L3 Cache
								if ((cpqSeCpuCacheEntry[y].cpqSeCpuCacheLevelIndex == 3) && (cpqSeCpuCacheEntry[y].cpqSeCpuCacheSize > 0)) {
									l3cache = cpqSeCpuCacheEntry[y].cpqSeCpuCacheSize + "&nbsp;KB"
								}

								// Verify L4 Cache
								if ((cpqSeCpuCacheEntry[y].cpqSeCpuCacheLevelIndex == 4) && (cpqSeCpuCacheEntry[y].cpqSeCpuCacheSize > 0)) {
									l4cache = cpqSeCpuCacheEntry[y].cpqSeCpuCacheSize + "&nbsp;KB"
								}
							}
						}

						var coreText = "Core " + coreNumber;

						cpuSubsectionText += tblTail;
						cpuSubsectionText += tableLabel5(coreText);
						cpuSubsectionText += ptTblHead();
						
						if (l3cache != "") {
							cpuSubsectionText += singleTableRow("L3 Cache:", l3cache);
						}
						
						if (l4cache != "") {
							cpuSubsectionText += singleTableRow("L4 Cache:", l4cache);
						}						

						cpuSubsectionText += tblTail;

						coreNumber++;
					}
				}
			}
			
			// count only 1 degraded cpu per socket
			if (hasDegradedCPU) {
				numOfDegradedCPU++;
			}
		}
	}

	
	/************************** FOOTNOTES ************************************/
	if ( isHPVM() == false ) {
		cpuSubsectionText += ptTblHead(friendly);

		// if it is showing a specific cell
		var postFix;
		if (cellIndex != -1) { 
			postFix = " in this cell.</b>";
		}
		else if (isPartitionedSystem()) {
			postFix = " in this partition.</b>";
		}
		else {
			postFix = " in this system.</b>";
		}
		
		var totalunusedCPUsockets = 0;
		var unusedCPUsockets = new Array();

		// initialize array
		for (i = 0 ; i < cpqSeCpuEntry.length; i++) {
			unusedCPUsockets[cpqSeCpuEntry[i].cpqSeCpuCellTablePtr] = 0;
		}
		
		// count empty sockets
		for (i = 0 ; i < cpqSeCpuEntry.length; i++) {
			// if the socket is unused
			if (cpqSeCpuEntry[i].cpqSeCpuStatus == 0) {
				// total
				totalunusedCPUsockets++;				
				// total per cell
				unusedCPUsockets[cpqSeCpuEntry[i].cpqSeCpuCellTablePtr]++;
			}		
		}
		
		// show empty cpu sockets (for non-cellular sytems)
		if (!isPartitionedSystem()) {
			if (totalunusedCPUsockets == 1) {
				cpuSubsectionText += sectionFootnote("<b>There is 1 empty CPU socket.");
			}
			else if (totalunusedCPUsockets > 1) 	{
				cpuSubsectionText += sectionFootnote("<b>There are " + totalunusedCPUsockets + " empty CPU sockets.");
			}
		} 
		else {
			// show empty cpu sockets in all cell (System Report Page)
			for ( i = 0 ; i < unusedCPUsockets.length; i++) {
				// if it's showing a specific cell
				if ((cellIndex != -1) && (cellIndex != i)) {
					continue;
				}

				// get cell number
				currCellNum = cpqSeCellEntry[i].cpqSeCellCellNumber;
				cabinetNum = cpqSeCellEntry[i].cpqSeCellCabinetNumber;

				if (unusedCPUsockets[i] == 1) {
					cpuSubsectionText += sectionFootnote("<b>There is 1 empty CPU socket in Cabinet "+cabinetNum+", Cell "+currCellNum);
				}
				else if (unusedCPUsockets[i] > 1) {
					cpuSubsectionText += sectionFootnote("<b>There are " + unusedCPUsockets[i] + " empty CPU sockets in Cabinet "+cabinetNum+", Cell "+currCellNum);
				}
			}
		}
		/****************************************************************************/
		
		// show sockets with degraded processor(s)
		if (numOfDegradedCPU == 1) 	{
			cpuSubsectionText += sectionFootnote("<b>There is 1 socket with degraded processor(s)" + postFix);
		}
		else if (numOfDegradedCPU > 0) {
			cpuSubsectionText += sectionFootnote("<b>There are " + numOfDegradedCPU + " sockets with degraded processor(s)" + postFix);
		}

		// show total number of active logical processors
		if (totalActiveCPUs > 0) {
			postFix = "";
			// if it is showing a specific cell
			if (cellIndex != -1) { 
				postFix = " in this cell: ";
			}
			else if (isPartitionedSystem()) {
				postFix = " in this partition: ";
			}
			else {
				postFix = " in this system: ";
			}
			cpuSubsectionText += sectionFootnote("<b>Total active logical processors" + postFix + totalActiveCPUs);
		}
		cpuSubsectionText += tblTail;
		cpuSubsectionText += whiteSpaceDivider();
	}
	return cpuSubsectionText;
}
//*************** End of CPU

//*************** Complex
// returns a string with the whole Complex Name subsection
// parameters:
//   friendly (true - format for friendly version
//             false - format to display normally in SMH)
function complexSubFunction(friendly)
{
	var complexName = displayItem("cpqSeComplexName", cpqSeComplexName);

	var str = tableLabel("Complex Name: " + complexName);
	str += ptTblHead(friendly);
	
	var totalCabinet = "Unknown";
	if (cpqSeComplexTotalCabinet != 0) {
		totalCabinet = displayItem("cpqSeComplexTotalCabinet", cpqSeComplexTotalCabinet);
	}
	str += singleTableRow("Total Number of Cabinets:", totalCabinet);
	
	str += singleTableRow("Number of Compute Cabinets:", displayItem("cpqSeComplexComputeCabinet", cpqSeComplexComputeCabinet));
	str += singleTableRow("Number of IOX Cabinets:", displayItem("cpqSeComplexIOXCabinet", cpqSeComplexIOXCabinet));
	str += singleTableRow("Complex Name:", complexName);
	str += singleTableRow("Partition Number:", displayItem("cpqSePartitionNumber", cpqSePartitionNumber));
	str += tblTail;
	str += whiteSpaceDivider();
	
	return str;
}
//*************** End of Complex

//*************** Memory Module
// returns a string with the whole Memory subsection
// parameters:
//   friendly (true - format for friendly version
//             false - format to display normally in SMH)
function memorymoduleSubSection(friendly, cellIndex)
{
  var strMemoryModuleSubSection = "";
  if( isHPVM() == false)
  {
  
  	  if (!cpqSiMemModuleEntry.length)
  	  {
  	  	return(getEmptySectionTable("Memory Modules"));
  	  }

  	  for (x=0; x<=cpqSiMemModuleEntry.length-1; x++)
  	  {
  		cpqSiMemModuleEntry[x].procstatus = new cpqCondition(cpqSiMemModuleEntry[x].cpqSiMemModuleCellStatus);
  	  }
	  var cellname = " ";
	  strMemoryModuleSubSection += tableLabel("Memory Modules");
	  strMemoryModuleSubSection += ptTblHead(friendly);
	  var columns = new Array();
	  if (isPartitionedSystem())
	  {
	    columns = new Array("Index", "Location", "Description", "HP Serial Num", "HP Part Num");
	  }
	  else
	  {
	    if (isHPVM() == false)
	      columns = new Array("Index", "Location", "Description", "HP Serial Num", "HP Part Num");
	    else
	      columns = new Array("Index", "Location", "Description");
	  }

	  var size = type = speed = tech = null;
	  var emptyDIMM = 0;
	  for ( i = 0 ; i < cpqSiMemModuleEntry.length; i++)
	  {
	    size = cpqSiMemModuleEntry[i].cpqSiMemModuleSize;
	    if (size == 0)
	    {
	    	if(((cellIndex != -1) && (cellIndex == cpqSiMemModuleEntry[i].cpqSiMemModuleCellTablePtr)) ||
	    	   (cellIndex == -1))
	    	{
	    		emptyDIMM++;
	    	}
	    }
	  }

	  // if all slots is empty not return the table header
	  if (cpqSiMemModuleEntry.length > emptyDIMM)
	  {
	  	strMemoryModuleSubSection += simpleTableRow( columns, columns.length, "B" );
	  }

	  for ( i = 0 ; i < cpqSiMemModuleEntry.length; i++)
	  {

        // don't display the current slot if cellIndex != -1 and if the
	    // current slot don't belong to the cell referred by cellIndex
	    if((cellIndex != -1) && (cellIndex != cpqSiMemModuleEntry[i].cpqSiMemModuleCellTablePtr))
	    {
	       continue;
	    }
	    
	    size = cpqSiMemModuleEntry[i].cpqSiMemModuleSize;
	     
	    if (size != 0)
	    {
	      if (isPartitionedSystem() &&
	          (cpqSiMemModuleEntry[i].cpqSiMemModuleCellTablePtr != -1) && (cpqSeCellEntry.length > 0) )
	      {
	        cellname = " Cabinet " +
	                   cpqSeCellEntry[cpqSiMemModuleEntry[i].cpqSiMemModuleCellTablePtr].cpqSeCellCabinetNumber +
	                   " Cell " +
	                   cpqSeCellEntry[cpqSiMemModuleEntry[i].cpqSiMemModuleCellTablePtr].cpqSeCellCellNumber;
	                   
	      }
	      speed = displayItem("cpqSiMemModuleSpeed",
	                          cpqSiMemModuleEntry[i].cpqSiMemModuleSpeed);

	      if ((speed == 0) || (speed == "N/A"))
	        buf2 = "";
	      else
	        buf2 = " - " + speed + "ns";
	      buf3 = "";

	      tech = displayItem("cpqSiMemModuleTechnology",
	                         cpqSiMemModuleEntry[i].cpqSiMemModuleTechnology);
	      if (cpqSiMemModuleEntry[i].cpqSiMemModuleTechnology != 0 &&
	          tech != null && tech != "Unknown")
	        buf3 = tech;
	      buf4 = "";

	      type = cpqSiMemModuleEntry[i].cpqSiMemModuleType;
	      if (size == 0)
	        buf = "Not Installed";
	      else
	      {
	        if (size%1024 != 0)
	          buf = displayItem("cpqSiMemModuleType", type) + " " + size
	                            + " KB" + " " + buf2 + buf3 + buf4;
	        else
	          buf = displayItem("cpqSiMemModuleType", type) + " " +
	                            (size/1024) + " MB" + " " + buf2 + buf3
	                            + buf4;
	        label = displayItem("cpqSiMemModuleHwLocation",
	                            cpqSiMemModuleEntry[i].cpqSiMemModuleHwLocation);
	        if(cellname != " "){
	            label = "Socket:" + label + cellname;
	        } else {
	            label = "Socket:" + label;
	        }
	        memserial = displayItem("cpqSiMemModuleSerialNo",
	                                cpqSiMemModuleEntry[i].cpqSiMemModuleSerialNo.toUpperCase());
	        mempart = displayItem("cpqSiMemModulePartNo",
	                              cpqSiMemModuleEntry[i].cpqSiMemModulePartNo);

	        dataRow = new Array();
	        if (isPartitionedSystem()) {
	          if(friendly) {
	          	dataRow = new Array(i, label, buf, memserial, mempart);
	          } 
	          else {
	          	dataRow = new Array(cpqSiMemModuleEntry[i].procstatus.image() + i, label, buf, memserial, mempart);
	          }
	        }
	        else {
	          if (isHPVM() == false) {
	          	if(friendly) {
	          		dataRow = new Array(i, label, buf, memserial, mempart);
	          	}
	          	else {
                                // bug 7424: there is a question mark for "Memory" in SMH Home page
                                // not show up memory status on non-cellular systems
                                // dataRow = new Array(cpqSiMemModuleEntry[i].procstatus.image() + i, label, buf, memserial, mempart);
                                dataRow = new Array(i, label, buf, memserial, mempart);
	          	}
	          }
	          else {
	          	if(friendly) {
	          		dataRow = new Array(i, label, buf);
	          	}
	          	else {
	          		dataRow = new Array(cpqSiMemModuleEntry[i].procstatus.image() + i, label, buf);
	          	}
	          }
	        }
	        strMemoryModuleSubSection += simpleTableRow( dataRow, dataRow.length );
	      }
	    }
	  }
	  
	  /*********************** EMPTY DIMM ***********************************/
	  var totalemptyDIMM = 0;
	  var emptyDIMM = new Array();

	  // initialize array
	  for (var i = 0 ; i < cpqSiMemModuleEntry.length; i++) {
	  	emptyDIMM[cpqSiMemModuleEntry[i].cpqSiMemModuleCellTablePtr] = 0;
	  }

	  // count empty DIMM slots
	  for (var i = 0 ; i < cpqSiMemModuleEntry.length; i++) {
	  	if (cpqSiMemModuleEntry[i].cpqSiMemModuleSize == 0) {
	  		// total
	  		totalemptyDIMM++;
	  		
	  		// total per cell
	  		emptyDIMM[cpqSiMemModuleEntry[i].cpqSiMemModuleCellTablePtr]++;
	  	}
	  }
	  
	  // show empty DIMM info
	  if ((totalemptyDIMM != 0) && (isHPVM() == false)) {
		// show empty cpu sockets (for non-cellular sytems)
		if(!isPartitionedSystem()) {
			if (totalemptyDIMM > 0) {
				var emptyDIMMText;
				if (totalemptyDIMM == 1) {
					emptyDIMMText = "There is 1 empty DIMM slot.";
				}
				if (totalemptyDIMM > 1) {
					emptyDIMMText = "There are " + totalemptyDIMM + " empty DIMM slots.";
				}
				strMemoryModuleSubSection += sectionFootnote(emptyDIMMText);
			}
		}
		else 
		{
			// show empty dimm for selected cell only (cell info page)
			if (cellIndex != -1) {
				if ((typeof(emptyDIMM[cellIndex]) != "undefined") && (parseInt(emptyDIMM[cellIndex]) > 0)) {		
					// get cell number
					var currCellNum = cpqSeCellEntry[cellIndex].cpqSeCellCellNumber;
					var currCabinetNum = cpqSeCellEntry[cellIndex].cpqSeCellCabinetNumber;
					var emptyDIMMText;

					if (emptyDIMM[cellIndex] == 1) {
						emptyDIMMText = "There is 1 empty DIMM slot in Cabinet "+currCabinetNum+", Cell "+currCellNum+".";
					}
					else {
						emptyDIMMText = "There are " + emptyDIMM[cellIndex] + " empty DIMM slots in Cabinet "+currCabinetNum+", Cell "+currCellNum+".";
					}
					strMemoryModuleSubSection += sectionFootnote(emptyDIMMText);
				}
			}
			else {
				// show empty DIMM slots of all cell (System Report Page)
				for ( i = 0 ; i < emptyDIMM.length; i++) {
					if (parseInt(emptyDIMM[i]) <= 0) {
						continue;
					}
					
					// get cell number
					var currCellNum = cpqSeCellEntry[i].cpqSeCellCellNumber;
					var currCabinetNum = cpqSeCellEntry[i].cpqSeCellCabinetNumber;
					var emptyDIMMText;
					
					if (emptyDIMM[i] == 1) {
						emptyDIMMText = "There is 1 empty DIMM slot in Cabinet "+currCabinetNum+", Cell "+currCellNum+".";
					}
					else {
						emptyDIMMText = "There are " + emptyDIMM[i] + " empty DIMM slots in Cabinet "+currCabinetNum+", Cell "+currCellNum+".";
					}
					strMemoryModuleSubSection += sectionFootnote(emptyDIMMText);
				}
			}
		}
	  }
	  /**********************************************************************/	  

	  strMemoryModuleSubSection += tblTail;
	  strMemoryModuleSubSection += whiteSpaceDivider();
  }
  return(strMemoryModuleSubSection);
}
//*************** End of Memory Module

//*************** Total Memory
// returns a string with the whole Total Memory subsection
// this funcion work only nopartitioned system
function totalmemorySubSection()
{
  var strtotalmemory = "";
  strtotalmemory += tableLabel("Memory");
  strtotalmemory += ptTblHead();
  if((cpqSeTotalMemMB == undefined) || (cpqSeTotalMemMB == "NULL"))
  {
  	strtotalmemory += singleTableRow("Total Memory: ", "N/A");
  }
  else
  {
  	strtotalmemory += singleTableRow("Total Memory:", daDisplayCapacity(cpqSeTotalMemMB));
  }
  strtotalmemory += tblTail;
  strtotalmemory += whiteSpaceDivider();
  
  return (strtotalmemory);
}
//*************** End of Total Memory

//*************** Advanced Memory
// returns a string with the whole Advanced Memory subsection
// this funcion work only nopartitioned system
function advancedMemorySubsection()
{
  var strtotalmemory = "";
  if ((cpqHeResilientMemTypeAvailable != null) && (cpqHeResilientMemTypeAvailable != 0))
  {
    // only show if resil mem available (doesn't need to be enabled).
    var strtotalmemory = "";
    strtotalmemory += whiteSpaceDivider();
    strtotalmemory += tableLabel("Advanced Memory Protection");
    strtotalmemory += ptTblHead();

    if (cpqHeResilientMemTypeAvailable & 0x01)  // On-line spare
    {
      strtotalmemory += singleTableRow("Advanced Memory Protection Types Available:", "On-line Spare");
    }
    else
    {
      strtotalmemory += singleTableRow("Advanced Memory Protection Types Available:", "None");
    }

    strtotalmemory += singleTableRow("Advanced Memory Protection Type Active:",
    displayItem("cpqHeResilientMemTypeActive",
                cpqHeResilientMemTypeActive));

    resMemCondition = new cpqCondition(cpqHeResilientMemCondition);
    resMemStat = resMemCondition.image() +
                 displayItem("cpqHeResilientMemStatus",
                             cpqHeResilientMemStatus);
    strtotalmemory += singleTableRow("Status:", resMemStat);

    strtotalmemory += tblTail;
    strtotalmemory += whiteSpaceDivider();
  }
  return(strtotalmemory);
}
//*************** End of Advanced Memory

//*************** Power Supply Group
function powerSupplyGroupsSubsection(friendly)
{
	var powerEntries = cpqHeFltTolPowerSupplyEntry.length;
	
	if (powerEntries <= 0) {
		return getEmptySectionTable("Power Supply Groups");
	}

	postfix["cpqHeFltTolPowerSupplyCapacityMaximum"] = "W";
	postfix["cpqHeFltTolPowerSupplyCapacityUsed"] = "W";

	var subsectionText = "";
	
	if (cpqHeFltTolPowerSupplyEntry.length > 0)
	{
		// GROUP POWER SUPPLIES ACCORDING TO cpqHeFltTolPowerSupplyRedundantPartner
		var powerGroup = new Array();
		var thisPower, currGroup, currPower, groupFound, newGroup;
		for(var i = 0; i < cpqHeFltTolPowerSupplyEntry.length; i++)
		{
			thisPower = cpqHeFltTolPowerSupplyEntry[i];
			currGroup = thisPower.cpqHeFltTolPowerSupplyRedundantPartner;
			currPower = i;
			// verify if the current group was already added to
			// powerGroup vector
			groupFound = false;
			for (var j = 0; j < powerGroup.length; j++) {
				if (powerGroup[j].groupNumber == currGroup) {
					groupFound = true;
					powerGroup[j].powerSupply.push(thisPower);
					break;
				}
			}
			// if the group isn't in the vector, add the new group
			// with the current power supply
			if (!groupFound) {
				newGroup = new Object;
				newGroup.groupNumber = currGroup;
				newGroup.powerSupply = new Array;
				newGroup.powerSupply.push(thisPower);
				powerGroup.push(newGroup);
			}
		}

		// Print the power supply groups
		subsectionText += tableLabel("Power Supply Groups");
		subsectionText += ptTblHead(friendly);

		firstGroupPrinted = false;
		var groupHeader, groupRedundancy, locationText, powerStatus;

		for(var i = 0; i < powerGroup.length; i++) {
			currGroup = powerGroup[i];
			// print line separating groups
			if (firstGroupPrinted) {
				subsectionText += "\n<tr><td colspan=7><hr noshade size=1/></td></tr>";
			}
			firstGroupPrinted = true;

			// compose group header with redundancy info and columns names
			groupHeader = "";

			currGroupRedundancy = powerGroupRedundancy(currGroup.powerSupply);

			if (currGroupRedundancy == 3) {
				if (friendly) {
					groupHeader = oneItemTableRowInDoubleTable("<b>Group Redundancy:</b> Redundant");
				}
				else {
					groupHeader = oneItemTableRowInDoubleTable("<img src='images/ok.gif' width=14 height=14> <b>Group Redundancy:</b> Redundant");
				}
			}
			else if (currGroupRedundancy == 2) {
				if (friendly) {
					groupHeader = oneItemTableRowInDoubleTable("<b>Group Redundancy:</b> Not Redundant");
				}
				else {
					groupHeader = oneItemTableRowInDoubleTable("<img src='images/degraded.gif' width=14 height=14> <b>Group Redundancy:</b> Not Redundant");
				}
			}
			else
			{
				groupHeader = oneItemTableRowInDoubleTable("<b>Group Redundancy:</b> N/A");
			}

			if (currGroup.groupNumber != 0) {
				subsectionText += groupHeader;
			}

			for (var j = 0; j < currGroup.powerSupply.length; j++)
			{
				// power supplies in group 0 are singletons, so they must be displayed
				// in separate groups (one group header for each power supply)
				if (currGroup.groupNumber == 0) {
					subsectionText += groupHeader;
				}

				thisPower = currGroup.powerSupply[j];

				// print power entry information
				subsectionText += oneItemTableRowInDoubleTable("&nbsp;");

				locationText = "";
				if (!friendly) 	{
					powerStatus = new cpqCondition(thisPower.cpqHeFltTolPowerSupplyCondition);
					locationText += powerStatus.image();
				}
				locationText += " <b>Location: </b>";

				subsectionText += doubleTableRow(locationText,
				                                 displayItem("cpqHeFltTolPowerSupplyHwLocation",
				                                             thisPower.cpqHeFltTolPowerSupplyHwLocation),
				                                 "Present:",
				                                 displayItem("cpqHeFltTolPowerSupplyPresent",
				                                             thisPower.cpqHeFltTolPowerSupplyPresent));
				subsectionText += doubleTableRow("Redundancy State:",
				                                 displayItem("cpqHeFltTolPowerSupplyRedundant",
				                                             thisPower.cpqHeFltTolPowerSupplyRedundant),
				                                 "Status:",
				                                 displayItem("cpqHeFltTolPowerSupplyStatus",
				                                             thisPower.cpqHeFltTolPowerSupplyStatus));

				PowerUsed = thisPower.cpqHeFltTolPowerSupplyCapacityUsed;
				PowerMax = thisPower.cpqHeFltTolPowerSupplyCapacityMaximum;

				subsectionText += doubleTableRow("Used Capacity(%):",
				                                 percentGraph(parseInt(PowerUsed/PowerMax*100)),
				                                 "Hot Pluggable:",
				                                 displayItem("cpqHeFltTolPowerSupplyHotPlug",
				                                             thisPower.cpqHeFltTolPowerSupplyHotPlug));

				subsectionText += doubleTableRow("Used Capacity(W):",
				                                 PowerUsed,
				                                 "Model:",
				                                 displayItem("cpqHeFltTolPowerSupplyModel",
				                                             thisPower.cpqHeFltTolPowerSupplyModel));

				subsectionText += doubleTableRow("Max Capacity:",
				                                 PowerMax,
				                                 "Serial Number:",
				                                 displayItem("cpqHeFltTolPowerSupplySerialNumber",
				                                             thisPower.cpqHeFltTolPowerSupplySerialNumber));

				subsectionText += doubleTableRow("Voltage (V):",
				                                 displayItem("cpqHeFltTolPowerSupplyMainVoltage",
				                                             thisPower.cpqHeFltTolPowerSupplyMainVoltage),
				                                 "Firmware Revision:",
				                                 displayItem("cpqHeFltTolPowerSupplyFirmwareRev",
				                                             thisPower.cpqHeFltTolPowerSupplyFirmwareRev));
			}
		}
		subsectionText += tblTail;
		subsectionText += whiteSpaceDivider();
	}
	return subsectionText;
}
//*************** End of Power Supply Group

//*************** Get OS String
function getOSString()
{
	var info1Str = displayItem("cpqHoName", cpqHoName);
	var info2Str = displayItem("cpqHoVersion", cpqHoVersion);
	var info3Str = displayItem("cpqHoDesc", cpqHoDesc);

	if(info2Str != "N/A")
	  info1Str += " " + info2Str;
	if(info3Str != "N/A")
	  info1Str += " " + info3Str;

  return info1Str;
}
//*************** End of Get OS String


//************ General Information
function generalInfo(friendly){
  
  //if (hpHttpMgEntityNetInfoEntry.length !=0)
  // InfoURL = hpHttpMgEntityNetInfoEntry[0].hpHttpMgEntityNetInfoURL;
   
  var strGenInfo = tableLabel("General Information");
  strGenInfo += ptTblHead(friendly);
  
  prodname = cpqSiProductName;
  strGenInfo += singleTableRow("Product:",
				    displayItem("cpqSiProductName",
						prodname));

  strGenInfo += singleTableRow("Operating System:", getOSString());
  strGenInfo += singleTableRow("HP Insight Agents Version:",
				    displayItem("cpqHoSwVerAgentsVer",
						cpqHoSwVerAgentsVer));

  if(isPartitionedSystem()){
      strGenInfo += singleTableRow("System UUID:",
		    displayItem("cpqSeComplexUUID",
			cpqSeComplexUUID));

  } else {
   

     UUIDFinal = "";
     
     for (var j=0; j< 16; j++) {
         UUIDformat = "%0.2x";
         var UUIDdec = ModUUID(UUIDformat, cpqHoGUID[j]);
         if ( UUIDdec.length < 2 ) {
            UUIDdec = "0"+UUIDdec;
         }
         if( j == 3 || j == 5 || j == 7 || j == 9 ) {
	       UUIDdec = UUIDdec+"-";
         }
	UUIDFinal = UUIDFinal+UUIDdec;
     }
      strGenInfo += singleTableRow("System UUID:",UUIDFinal);
      
  }
 
  if(cpqHoHWInfoPlatform == 5){
    strGenInfo += singleTableRow("System UUID (Logical):",
			    displayItem("cpqSiVirtualSystemUUID",cpqSiVirtualSystemUUID));

    strGenInfo += singleTableRow("System Serial Number (Logical):",
			    displayItem("cpqSiVirtualSystemSerialNumber",
	    		cpqSiVirtualSystemSerialNumber));
  
    strGenInfo += singleTableRow("Bay Number:",
			    displayItem("cpqSiServerBladeEnclosureBayNumber",
					cpqSiServerBladeEnclosureBayNumber));						

    strGenInfo += singleTableRow("Blade Height:",
			    displayItem("cpqSiServerBladeHeight",
					cpqSiServerBladeHeight));
  }						
  
  if (isHPVM() == false)
  {
    
    strGenInfo += singleTableRow("System Firmware:",
				      displayItem("cpqSeSysRomVer", cpqSeSysRomVer));

    if (!isPartitionedSystem())
    {
      strGenInfo += singleTableRow("BMC Firmware Version:",
					displayItem("cpqSeBMCFwVer",
						    cpqSeBMCFwVer));
    }
    strGenInfo += singleTableRow("Management Processor Firmware Version:",
				      displayItem("cpqSeMPFwVer", cpqSeMPFwVer));
  }
  else
  {
    strGenInfo += singleTableRow("HPVM Firmware Version:",
				      displayItem("cpqSeHPVMFwVer", cpqSeHPVMFwVer));
  }

  strGenInfo += singleTableRow("Management Processor Host Name:",
				    displayItem("cpqSiMPHostName",
						cpqSiMPHostName));
						

/*
  if( (hpHttpMgEntityNetInfoURL.length != 0) || (hpHttpMgEntityNetInfoIPAddress.length != 0))
  {
    var MPIP = (typeof(hpHttpMgEntityNetInfoIPAddress)!="undefined") ? displayItem(hpHttpMgEntityNetInfoIPAddress) : "N/A";
    if (isPartitionedSystem())
    {
      strGenInfo += singleTableRow("Management Processor IP Address:", MPIP);

	if( (hpHttpMgEntityNetInfoURL.length > 0) && (hpHttpMgEntityNetInfoURL[0] != "") )
	{
	strGenInfo += singleTableRow("Management Processor Home Page:",
					  "<a target=new href=" + hpHttpMgEntityNetInfoURL[0] + ">" + hpHttpMgEntityNetInfoURL[0] + " </a>");
	}
    }
    else
    {
      strGenInfo += singleTableRow("Lights-out Management Processor IP Address:", MPIP);

	if( (hpHttpMgEntityNetInfoEntry[0].hpHttpMgEntityNetInfoURL.length > 0) && (hpHttpMgEntityNetInfoEntry[0].hpHttpMgEntityNetInfoURL != "") )
        {
		strGenInfo += singleTableRow("Lights-out Management Processor Home Page:",
					  "<a target=new href=" + hpHttpMgEntityNetInfoURL[0] + ">" + hpHttpMgEntityNetInfoURL[0] + " </a>");
 	}
    }
  }
  */
  // Display the system Id/ product ID / System board ID
  servSysId = cpqSiServerSystemId;
  
 
//<?php if("Linux" != PHP_OS){?>

	 mpIcon = new cpqCondition(cpqSiMPHealthStatus);
  	 
         if(friendly) {
         	strGenInfo += singleTableRow("Management Processor Health Status:",
  	                                       displayItem("cpqSiMPHealthStatus", cpqSiMPHealthStatus));
         } else {
                strGenInfo += singleTableRow(mpIcon.image() +
  	                                       "Management Processor Health Status:",
  	                                       displayItem("cpqSiMPHealthStatus", cpqSiMPHealthStatus));
         }  	                                       

	var crashDumpState = "Unknown";
	if (cpqHoCrashDumpState > -1) {
		crashDumpState = displayItem("cpqHoCrashDumpState", cpqHoCrashDumpState)
	}
	strGenInfo += singleTableRow("Crash Dump State:", crashDumpState);
	dumpStatus = new cpqCondition(cpqHoCrashDumpCondition);

	strGenInfo += singleTableRow("Crash Dump Monitoring Status:", 
					displayItem("cpqHoCrashDumpMonitoring",
						    cpqHoCrashDumpMonitoring));

	if(friendly) {
	    strGenInfo += singleTableRow("Crash Dump Configuration Condition:",
					      displayItem("cpqHoCrashDumpCondition",
							  cpqHoCrashDumpCondition));
	} else {
	    strGenInfo += singleTableRow(dumpStatus.image() +
					      "Crash Dump Configuration Condition:",
					      displayItem("cpqHoCrashDumpCondition",
							  cpqHoCrashDumpCondition));
	}

	strGenInfo += singleTableRow("Current Paging File Size:",
				    displayItem("cpqHoBootPagingFileSize",
						cpqHoBootPagingFileSize));
	strGenInfo += singleTableRow("Minimum Paging File Size:",
				    displayItem("cpqHoBootPagingFileMinimumSize",
						cpqHoBootPagingFileMinimumSize));
//<?php } 
//?>
  strGenInfo += tblTail;
  strGenInfo += whiteSpaceDivider();

return(strGenInfo);
}
//************ End of General Information


//************ Asset Control Information
/*
function validateAssetTag()
{
	//alert(document.form.);
  	if(-1 != document.set.ASSETTAGTXT.value.indexOf(" ") || )
  	{
  	   alert("Blank characters are not allowed!");
  	   return false;
  	} else {
  	   return true;
  	}


}
*/

function assetControlInfo(friendly)
{
  var strGenInfo = tableLabel("Asset Control Information");
  strGenInfo += ptTblHead(friendly);

  serialNum = displayItem("cpqSiSysSerialNum", cpqSiSysSerialNum);
  strGenInfo += singleTableRow("Serial Number:", serialNum);

   if (isHPVM() == false)
  {
    
      if ( typeof(cpqSiAssetTag) != "undefined" )
	assettag = cpqSiAssetTag;
      else
	assettag = "";
      if (smhconfigauth && !friendly)
      {
	strGenInfo += '<center><form name="set" method="post" action="setassettag.php.en" >';
	var assetTagText = '<input type=text maxsize=64 name="ASSETTAGTXT" ' + ' value='+assettag +'><br>';
	assetTagText += '<input type="submit" name="save" value="Set"> ';
	assetTagText += '</form></canter>';
	strGenInfo += singleTableRow("Asset Tag:", assetTagText);
      }                                 
	else
      {
	assetTagText = displayItem("cpqSiAssetTag", cpqSiAssetTag);
	if(assetTagText.substring(0,1) == "'" && assetTagText.substring(assetTagText.length-2,assetTagText.length-1)) {
	   assetTagText = assetTagText.substring(1,assetTagText.length-2) ;
	}
	if(assetTagText.length == "0") {
	   assetTagText="N/A";
	}
	strGenInfo += singleTableRow("Asset Tag:", assetTagText);
      }
   strGenInfo += snmpAdminMsg();

  }


  strGenInfo += tblTail;
  strGenInfo += whiteSpaceDivider();

return(strGenInfo);
}
//************ End of Asset Control Information

//************ Rack and Enclosure Information
function rackEnclosureInfo(friendly){
	var strRackEncl = "";
	
	if (cpqHoHWInfoPlatform == 5){
		var thisEnc = cpqSiRackEnclosureMgrEntry[0];
		strRackEncl += tableLabel("Rack and Enclosure Information");
	  	strRackEncl += ptTblHead(friendly);
		
	  	var rackName = displayItem("cpqSiRackName", cpqSiRackName);
  		strRackEncl += singleTableRow("Rack Name:", rackName);
  		
  		var rackUUID = displayItem("cpqSiRackUUID", cpqSiRackUUID);
  		strRackEncl += singleTableRow("Rack UID:", rackUUID);
  		
  		var enclIcon = new cpqCondition(thisEnc.cpqSiRackEnclosureMgrCondition);  		
  		var enclName = displayItem("cpqSiRackEnclosureMgrName", thisEnc.cpqSiRackEnclosureMgrName);
		
		if(friendly) { 
			strRackEncl += singleTableRow("Enclosure Name:", enclName);
		} else {
			strRackEncl += singleTableRow(enclIcon.image() + 
							"Enclosure Name:", enclName);
		}
		
		var enclSerialNum = displayItem("cpqSiRackEnclosureMgrSerialNumber", thisEnc.cpqSiRackEnclosureMgrSerialNumber);
		strRackEncl += singleTableRow("Enclosure Serial Number:", enclSerialNum);
		
		var enclModel = displayItem("cpqSiRackEnclosureMgrModel", thisEnc.cpqSiRackEnclosureMgrModel);
		strRackEncl += singleTableRow("Enclosure Model:", enclModel);

		var BayNum = displayItem("cpqSiServerBladeEnclosureBayNumber", cpqSiServerBladeEnclosureBayNumber);
		strRackEncl += singleTableRow("Bay Number of Blade:",BayNum);

//                var enclOADesc = "N/A";
//                strRackEncl += singleTableRow("OA Description:", enclOADesc);
	
		var enclIPAddr = displayItem("cpqSiRackEnclosureMgrIpAddr", thisEnc.cpqSiRackEnclosureMgrIpAddr);
		strRackEncl += singleTableRow("OA IP Address:", enclIPAddr);
		
//		strRackEncl += singleTableRow("OA MAC Address:", "N/A");
 		
		var encWebLink = displayItem("cpqSiRackEnclosureMgrWebLink", thisEnc.cpqSiRackEnclosureMgrWebLink);
		
		var encOALink = "N/A";
		if (encWebLink != "N/A") {
			encOALink = "<a target=new href=" +
				    thisEnc.cpqSiRackEnclosureMgrWebLink +
				    ">" +
				    thisEnc.cpqSiRackEnclosureMgrWebLink +
				    " </a>";
		}
		strRackEncl += singleTableRow("URL to launch OA:", encOALink);
		strRackEncl += tblTail;
		strRackEncl += whiteSpaceDivider();
	}

	return(strRackEncl);

}
//************ End of Rack and Enclosure Information




//*************** USB ports
function sectionUSB() {
    var strUSB = "";

    if( (isHPVM() == false) && (isPartitionedSystem() == false) )
    {
	  if (cpqSeUSBPortType.length <= 0)
	  {
		return(getEmptySectionTable("USB Ports"));
	  }
	  else
	  {		
		strUSB = tableLabel("USB Ports");
		strUSB += ptTblHead();
		for (x=0; x < cpqSeUSBPortType.length; x++)
		{
			strUSB += singleTableRow("USB " + (x+1) + ": ", "Present");
		}
		strUSB += tblTail;
		strUSB += whiteSpaceDivider();
	  }
    }

    return strUSB;
}
//*************** end of USB ports
  
  
//*************** Firmware Version
function firmwareVersionSubsection()
{
	var retString = "";

	if (isHPVM() == false){
		if ((cpqSiFirmwareRevTable.length <= 0) && (cpqDaCntlrEntry.length <= 0) && 
		    (cpqFcaHostCntlrEntry.length <= 0) && (cpqScsiCntlrEntry.length <= 0)) {
			return getEmptySectionTable("Firmware Version Information");
		}
		else {
			retString = tableLabel("Firmware Version Information");
			retString += ptTblHead();

			var columns = new Array("Name", "Location", "Installed Version");
			retString += simpleTableRow(columns, columns.length, "B");

			var thisVersion;
			var dataRow;

			// smart array
			for(i=0; i< cpqDaCntlrEntry.length; i++) {
				thisVersion = cpqDaCntlrEntry[i];
				dataRow = new Array(displayItem("cpqDaCntlrModel", thisVersion.cpqDaCntlrModel),
				                    displayItem("cpqDaCntlrHwLocation", thisVersion.cpqDaCntlrHwLocation),
				                    displayItem("cpqDaCntlrFWRev", thisVersion.cpqDaCntlrFWRev));
				retString += simpleTableRow(dataRow, dataRow.length);
			}

			// fibre channel
			for(i=0; i< cpqFcaHostCntlrEntry.length; i++) {
				thisVersion = cpqFcaHostCntlrEntry[i];
				dataRow = new Array(displayItem("cpqFcaHostCntlrModel", thisVersion.cpqFcaHostCntlrModel),
				                    displayItem("cpqFcaHostCntlrHwLocation", thisVersion.cpqFcaHostCntlrHwLocation),
				                    displayItem("cpqFcaHostCntlrFirmwareVersion", thisVersion.cpqFcaHostCntlrFirmwareVersion));
				retString += simpleTableRow(dataRow, dataRow.length);
			}

			// scsi-u320
			var scsiName;
			for(i=0; i< cpqScsiCntlrEntry.length; i++) {
				thisVersion = cpqScsiCntlrEntry[i];
				if (thisVersion.cpqScsiCntlrModel == 9) {
					scsiName = displayItem("cpqScsiCntlrModelExtended", thisVersion.cpqScsiCntlrModelExtended);
				}
				else {
					scsiName = displayItem("cpqScsiCntlrModel", thisVersion.cpqScsiCntlrModel);
				}

				dataRow = new Array(scsiName,
				                    displayItem("cpqScsiCntlrHwLocation", thisVersion.cpqScsiCntlrHwLocation),
				                    displayItem("cpqScsiCntlrFWVers", thisVersion.cpqScsiCntlrFWVers));
				retString += simpleTableRow(dataRow, dataRow.length);
			}

			// server firmware
			for(i=0; i< cpqSiFirmwareRevTable.length; i++) {
				thisVersion = cpqSiFirmwareRevTable[i];
				dataRow = new Array(displayItem("cpqSiFirmwareRevDesc", thisVersion.cpqSiFirmwareRevDesc),
				                    displayItem("cpqSiFirmwareLocation", thisVersion.cpqSiFirmwareLocation),
				                    displayItem("cpqSiFirmwareRevString", thisVersion.cpqSiFirmwareRevString));
				retString += simpleTableRow(dataRow, dataRow.length);
			}			

			retString += tblTail;
			retString += whiteSpaceDivider();
		}
	}

	return retString;
}
//*************** End of Firmware Version

//*************** LED decoding
function ledDecoding (led)
{
	var returnled = new Array(8);
	
	// LED decoding loop - don't show LEDs on HPVM
	if (!isHPVM()) {
		var LEDmask = 0xff000000;
		var i = 0;
		var type = "";  // power, fault...
		var color = ""; // off, steady red...
		var value = 0;  // from the OID, apply mask here
		var cont = 0;
		
		for(i = 0; i < 4; i++)
		{
			value = led;
			value &= LEDmask;
			value = value >>> 24 - (8*i);

			type = decodeLEDType(value);

			// only write to page if not a reserved (invalid) LED
			if(type != "Reserved")
			{
				color = decodeLEDColor(value);
				returnled[cont] = type + " LED:";
				returnled[cont + 1] = color;
				cont += 2;
			} 

			LEDmask = LEDmask >>> 8;    // 0 fill right bit shift by 8 bits
		}
	}
	return returnled;
}
//*************** End LED decoding

//*************** IO Chassis Section
function getIOChassisTable(iocNum, friendly)
{
   var ioChassisStr= "";

   if (cpqSeIOCEntry.length) {
		ioChassisStr += tableLabel("IO Chassis Information");
		
	for(var i=0; i< cpqSeIOCEntry.length; i++) {
		// if iocNum == -1 then show all IO Chassis
		// if iocNum > -1 then show only selected IO Chassis
		if ((iocNum == -1) || (iocNum == i)) {

			var cabNum = parseInt(cpqSeIOCEntry[i].cpqSeIOCCabinetNumber);
			if (cabNum == 255) cabNum = "unknown";
			var bayNum = parseInt(cpqSeIOCEntry[i].cpqSeIOCBayNumber);
			var iocNumaux = parseInt(cpqSeIOCEntry[i].cpqSeIOCIOCNumber);
			
			var label = "IO Chassis at Cabinet " + cabNum + ", Bay " + bayNum + ", IOC " + iocNumaux;
		
			
			ioChassisStr += tableLabelH3(label);			
			ioChassisStr += ptTblHead(friendly);		

			var powerState = displayItem("cpqSeIOCPowerState",cpqSeIOCEntry[i].cpqSeIOCPowerState);
			var leds = ledDecoding(cpqSeIOCEntry[i].cpqSeIOCLEDState);

			var columns = new Array(	"Power State:", powerState,
							leds[0], leds[1],
							leds[2], leds[3],
							leds[4], leds[5],
							leds[6], leds[7]);
							
			ioChassisStr += tableRow(2, columns);
			ioChassisStr += tblTail;
			}
		}
		ioChassisStr += whiteSpaceDivider();
		return ioChassisStr;
	}
	else {
		return getEmptySectionTable("IO Chassis Information");
	}
}

//*************** End of IO Chassis Section

//*************** Get hotplug string
// returns the HotPlug/Board info used in Expansion Slots section
// ATTENTION: all OIDs used in this function must be declared in the PHP file
//            where this function is called
// receives: pciSlot - cpqSePciSlotEntry[i]
function getHotPlugString(pciSlot, friendly)
{
	var hotPlugString = "N/A";
	var boardCond;
	
	for (x = 0; x < cpqSiHotPlugSlotEntry.length; x++) {
		if (pciSlot.cpqSePciPhysSlot == cpqSiHotPlugSlotEntry[x].cpqSiHotPlugSlotIndex) {
			boardCond = cpqSiHotPlugSlotEntry[x].cpqSiHotPlugSlotBoardCondition;
			if (friendly) {
				if ((boardCond >= 1) && (boardCond <= 4)) {
					hotPlugString = displayItem("cpqSiHotPlugSlotBoardCondition", boardCond);
				}
			}
			else {
				var cond = new cpqCondition(boardCond);
				hotPlugString = cond.image();
			}
			break;
		}
	}
	
	return hotPlugString;
}
//*************** End of get hotPlug string

//*************** PCI Expansion Slots
function expansionSlotsSection(iocNum, friendly, inSystemReport){
	var subSectionText = "";

	if(!cpqSePciSlotEntry.length) {
		return getEmptySectionTable("PCI Expansion Slots");
	}
	else
	{
		var sectionHeader = tableLabel("PCI Expansion Slots");
		sectionHeader += ptTblHead(friendly);
		if (isHPVM()) {
			columns = new Array("Bus", "Device", "PCI Name");
		}
		else 
		{
			if (isPartitionedSystem()) {
				if (iocNum == -1){
					columns = new Array("HotPlug", "Bus", "Device", "Slot", "Type", 
							    "Current<br>Width", "Max<br>Width", "Current<br>Speed", 
							    "Max<br>Speed", "PCI Name", "Hardware Location");
				} else {
					columns = new Array("HotPlug", "Bus", "Device", "Slot", "Type", "Current<br>Width", 
					    		    "Max<br>Width", "Current<br>Speed", "Max<br>Speed", 
							    "PCI Name");
				}		
			} else {
				columns = new Array("HotPlug", "Bus", "Device", "Slot", "Type", "Current<br>Width", 
						    "Max<br>Width", "Current<br>Speed", "Max<br>Speed", 
						    "PCI Name");
			}
		}

		sectionHeader += simpleTableRow( columns, columns.length, "B" );


		var thisSlot, hotPlug, bus, device, pciSlot, pciBoard, currWidth, thisFunct, slotType, hwLocation;
		var emptyPci = 0, emptyPciX = 0, emptyPciExpress = 0;
		var headerPrinted = false;
		for ( i = 0 ; i < cpqSePciSlotEntry.length; i++)
		{
			thisSlot = cpqSePciSlotEntry[i];

			// If this section is shown in IO Chassis page, show only the
			// boards for the selected IOC
			if (iocNum >= 0) {
				var cabNum = parseInt(cpqSeIOCEntry[iocNum].cpqSeIOCCabinetNumber);
				if (cabNum == 255) cabNum = "unknown";
				var bayNum = parseInt(cpqSeIOCEntry[iocNum].cpqSeIOCBayNumber);
				var iocNumaux = parseInt(cpqSeIOCEntry[iocNum].cpqSeIOCIOCNumber);
			
				var nSlot = cabNum*10000 + bayNum*1000 + iocNumaux*100;
				
				var physSlot = thisSlot.cpqSePciPhysSlot;
				if (physSlot.length > 2) {
					physSlot = physSlot.substring(0, physSlot.length - 2);
					physSlot = parseInt(physSlot) * 100;
				}
				else {
					physSlot = 0;
				}				

				if ((physSlot != parseInt(nSlot)) ||
        	        (thisSlot.cpqSePciSlotIOCTablePtr != cpqSeIOCEntry[iocNum].cpqSeIOCUnitIndex)) {			
					continue;
				}
			}
			// HotPlug
			hotPlug = getHotPlugString(thisSlot, friendly);

			// Bus and Device
			if (thisSlot.cpqSePciSlotBusNumberIndex > 255) {
				// Bus
				bus = "N/A";

				// Device
				device = "N/A";
			}
			else 
			{
				// Bus
				bus = displayItem("cpqSePciSlotBusNumberIndex", thisSlot.cpqSePciSlotBusNumberIndex);   	                      

				// Device
				device = displayItem("cpqSePciSlotDeviceNumberIndex", thisSlot.cpqSePciSlotDeviceNumberIndex);
			}

			// PCI Slot                         
			if ((thisSlot.cpqSePciPhysSlot == 0) && (thisSlot.cpqSePciIsSlot0Embedded == 1)) {
				pciSlot = "Embedded";
			} else {
				pciSlot = displayItem("cpqSePciPhysSlot", thisSlot.cpqSePciPhysSlot);
			}

			// PCI Name
			pciBoard = displayItem("cpqSePciSlotBoardName", thisSlot.cpqSePciSlotBoardName);

			// PCIe information - (PCIe is cpqSePciSlotType == 6)
			// these are the default values and should not be changed
			currWidth = "N/A";
			maxWidth = "N/A";
			currSpeed = "N/A";
			maxSpeed = "N/A";

			if (thisSlot.cpqSePciSlotType == 6) {
				// Max Width
				if (thisSlot.cpqSePcieSlotMaxLinkWidth > 0) {
					maxWidth = "x" + thisSlot.cpqSePcieSlotMaxLinkWidth;
				}
				// Max Speed
				if (thisSlot.cpqSePcieSlotMaxLinkSpeed > 0) {
					maxSpeed =  GetCPUSpeedinTwoFloatDigit(thisSlot.cpqSePcieSlotMaxLinkSpeed) + " Gbps";
				}

				for(j=0; j < cpqSePciFunctEntry.length; j++) {
					thisFunct = cpqSePciFunctEntry[j];
					if ((thisFunct.cpqSePciFunctBusNumberIndex == thisSlot.cpqSePciSlotBusNumberIndex) &&
					(thisFunct.cpqSePciFunctDeviceNumberIndex == thisSlot.cpqSePciSlotDeviceNumberIndex)) {
						// Current Width
						if (thisFunct.cpqSePcieFunctNegotiatedLinkWidth > 0) {
							currWidth = "x" + thisFunct.cpqSePcieFunctNegotiatedLinkWidth;
						}
						// Current Speed
						if (thisFunct.cpqSePcieFunctNegotiatedLinkSpeed > 0) {
							currSpeed = GetCPUSpeedinTwoFloatDigit(thisFunct.cpqSePcieFunctNegotiatedLinkSpeed) + " Gbps";
						}
					}
				}
			} else {
				if (thisSlot.cpqSePciSlotType > 2) {
					// Current Width
					maxWidth = displayItem("cpqSePciSlotWidth", thisSlot.cpqSePciSlotWidth);
					// Current Speed
					if (thisSlot.cpqSePciCurrentSlotSpeed > 0) {
						currSpeed = thisSlot.cpqSePciCurrentSlotSpeed + " MHz";
					}
					// Max Speed
					if (thisSlot.cpqSePciMaxSlotSpeed > 0) {
						maxSpeed = thisSlot.cpqSePciMaxSlotSpeed + " MHz";
					}
				}
			}

                       // bug 7807 Type of IO Chassis displayed wrong value at web pageLast
                       // changed by Spark Xu 2008-07-22
                       //****************************************************************
                       if (thisSlot.cpqSePciSlotType <= 2)  {
                             slotType = "N/A";
		       } else if ((thisSlot.cpqSePciSlotType == 3)||(thisSlot.cpqSePciSlotType == 4)){
                             slotType = "PCI";
                       } else {
                             slotType = displayItem("cpqSePciSlotType", thisSlot.cpqSePciSlotType);
                       }
                       //****************************************************************

			if (!headerPrinted) {
				subSectionText += sectionHeader;
				headerPrinted = true;
			}

			// in system report, don't show Empty slots and show footnote with total empty slots
			if ( ( (pciBoard.toUpperCase() == "EMPTY") || (pciBoard.toUpperCase() == "(EMPTY)") ) && inSystemReport) {
				if (thisSlot.cpqSePciSlotType <= 4) {
					// PCI
					emptyPci++; 
				}
				else if (thisSlot.cpqSePciSlotType == 5) {
					// PCI-X
					emptyPciX++;
				}
				else if (thisSlot.cpqSePciSlotType == 6) {
					// PCIe
					emptyPciExpress++;
				}
			}
			else {
				if (isHPVM()) {
					dataRow = new Array(bus, device, pciBoard);
				} else {
					if (isPartitionedSystem()) {
						// Hardware Location
						hwLocation = displayItem("cpqSePciHwLocation", thisSlot.cpqSePciHwLocation);      

						if (iocNum == -1){
							dataRow = new Array(hotPlug, bus, device, pciSlot, slotType, currWidth, maxWidth,
							currSpeed, maxSpeed, pciBoard, hwLocation);
						} else {
							dataRow = new Array(hotPlug, bus, device, pciSlot, slotType, currWidth, maxWidth,
							currSpeed, maxSpeed, pciBoard);
						}		
					} else {
						dataRow = new Array(hotPlug, bus, device, pciSlot, slotType, currWidth, maxWidth,
						currSpeed, maxSpeed, pciBoard);
					}
				}
				subSectionText += simpleTableRow(dataRow, dataRow.length);
			}
		}
		
		// Empty PCI
		var postFix;
		if (isPartitionedSystem()) {
			postFix = " in this partition.";
		}
		else {
			postFix = " in this system.";
		}
		if (emptyPci == 1) {
			subSectionText += sectionFootnote("There is 1 empty PCI slot" + postFix);
		}
		else if (emptyPci > 1) {
			subSectionText += sectionFootnote("There are " + emptyPci + " empty PCI slots" + postFix);
		}
		// Empty PCI-X
		if (emptyPciX == 1) {
			subSectionText += sectionFootnote("There is 1 empty PCI-X slot" + postFix);
		}
		else if (emptyPciX > 1) {
			subSectionText += sectionFootnote("There are " + emptyPciX + " empty PCI-X slots" + postFix);
		}
		// Empty PCI Express
		if (emptyPciExpress == 1) {
			subSectionText += sectionFootnote("There is 1 empty PCI Express slot" + postFix);
		}
		else if (emptyPciExpress > 1) {
			subSectionText += sectionFootnote("There are " + emptyPciExpress + " empty PCI Express slots" + postFix);
		}
		
		subSectionText += tblTail;
		subSectionText += whiteSpaceDivider();
	}
	return subSectionText;
}
//*************** End of PCI Expansion Slots


function expansionDevicesSection(iocNum, friendly)
{
	var subSectionText = "";
	
	var pciBoardName, thisSlot, hotPlug, slotType, slot, hwLocation, bus;
	var device, pciFunct, pciFunctNo, pciFunctDesc, maxSpeed, maxWidth;

	for (i = 0; i < cpqSePciSlotEntry.length; i++) {
		thisSlot = cpqSePciSlotEntry[i];

		if ((thisSlot.cpqSePciSlotBoardName == "(Empty)") ||
			(thisSlot.cpqSePciSlotBoardName == "(EMPTY)") ||
			(thisSlot.cpqSePciSlotBoardName == "Empty") ||
			(thisSlot.cpqSePciSlotBoardName == "EMPTY")) {
			continue;
		}
	
		// If this section is shown in IO Chassis page, show only the
		// boards for the selected IOC
		if (iocNum >= 0) {
			var cabNum = parseInt(cpqSeIOCEntry[iocNum].cpqSeIOCCabinetNumber);
			if (cabNum == 255) cabNum = "unknown";
			var bayNum = parseInt(cpqSeIOCEntry[iocNum].cpqSeIOCBayNumber);
			var iocNumaux = parseInt(cpqSeIOCEntry[iocNum].cpqSeIOCIOCNumber);

			var nSlot = cabNum*10000 + bayNum*1000 + iocNumaux*100;

			var physSlot = thisSlot.cpqSePciPhysSlot;
			if (physSlot.length > 2) {
				physSlot = physSlot.substring(0, physSlot.length - 2);
				physSlot = parseInt(physSlot) * 100;
			}
			else {
				physSlot = 0;
			}				

			if ((physSlot != parseInt(nSlot)) ||
				(thisSlot.cpqSePciSlotIOCTablePtr != cpqSeIOCEntry[iocNum].cpqSeIOCUnitIndex)) {			
				continue;
			}
		}

		// PCI Name
		pciBoardName = displayItem("cpqSePciSlotBoardName", thisSlot.cpqSePciSlotBoardName);

		// HotPlug/Board
		hotPlug = getHotPlugString(thisSlot, friendly);
		if (hotPlug == "N/A") {
			hotPlug = "";
		}
		
		// Type
		if (thisSlot.cpqSePciSlotType < 3) {
			slotType = "PCI";
		}
		else {
			slotType = displayItem("cpqSePciSlotType", thisSlot.cpqSePciSlotType);
		}				

		// Slot             
		if ((thisSlot.cpqSePciPhysSlot == 0) && (thisSlot.cpqSePciIsSlot0Embedded == 1)) {
			slot = "Embedded " + slotType;
		}
		else {		
			slot = slotType + " Slot " + displayItem("cpqSePciPhysSlot", thisSlot.cpqSePciPhysSlot);
		}
		
		// Bus and Device
		if (thisSlot.cpqSePciSlotBusNumberIndex > 255) {
			bus = "N/A";
			device = "N/A";
		}
		else {
			bus = displayItem("cpqSePciSlotBusNumberIndex", thisSlot.cpqSePciSlotBusNumberIndex);
			device = displayItem("cpqSePciSlotDeviceNumberIndex", thisSlot.cpqSePciSlotDeviceNumberIndex);
		}
	
		subSectionText += whiteSpaceDivider();
		subSectionText += tableLabel(pciBoardName);
		subSectionText += ptTblHead();
		subSectionText += singleTableRow("Slot:", hotPlug + " " + slot);
		if (isPartitionedSystem()) {
			// Hardware Location
			hwLocation = displayItem("cpqSePciHwLocation", thisSlot.cpqSePciHwLocation);

			subSectionText += singleTableRow("Hardware Location:", hwLocation);
		}
		subSectionText += singleTableRow("Bus:", bus);
		subSectionText += singleTableRow("Device:", device);

		// PCI Function
		for (j = 0 ; j < cpqSePciFunctEntry.length; j++) {
			thisFunct = cpqSePciFunctEntry[j];
			if ((thisSlot.cpqSePciSlotBusNumberIndex == thisFunct.cpqSePciFunctBusNumberIndex) &&
			    (thisSlot.cpqSePciSlotDomainNumberIndex == thisFunct.cpqSePciFunctDomainNumberIndex) &&
			    (thisSlot.cpqSePciSlotDeviceNumberIndex == thisFunct.cpqSePciFunctDeviceNumberIndex)) {
				// PCI Function
				pciFunctNo = "PCI Function " + thisFunct.cpqSePciFunctIndex + ":";
				pciFunctDesc = thisFunct.cpqSePciFunctClassDescription;
				subSectionText += singleTableRow(pciFunctNo, pciFunctDesc);
				// PCIe Information
				if (thisSlot.cpqSePciSlotType == 6) {
					// Max Link Speed
					pciFunctNo = "Max Link Speed for Function " + thisFunct.cpqSePciFunctIndex + ":";
					pciFunctDesc = "N/A";
					if (thisFunct.cpqSePcieFunctMaxLinkSpeed > 0) {
						pciFunctDesc = GetCPUSpeedinTwoFloatDigit(thisFunct.cpqSePcieFunctMaxLinkSpeed) + " Gbps";
					}
					subSectionText += singleTableRow(pciFunctNo, pciFunctDesc);
					// Max Link Width
					pciFunctNo = "Max Link Width for Function " + thisFunct.cpqSePciFunctIndex + ":";
					pciFunctDesc = "N/A";
					if (thisFunct.cpqSePcieFunctMaxLinkWidth > 0) {
						pciFunctDesc = "x" + thisFunct.cpqSePcieFunctMaxLinkWidth;
					}
					subSectionText += singleTableRow(pciFunctNo, pciFunctDesc);				
				}
			}
		}

		subSectionText += tblTail;
		subSectionText += whiteSpaceDivider();
	}
	
	return subSectionText;
}



// function imported from storage file ms-fccmn.js.en
function fcChassisName(idx)
{
   var i = parseInt(idx) + 1;
   var rc = "Storage System ";
   if (idx >= 0 && idx < cpqSsChassisEntry.length)
      rc += cpqSsChassisEntry[idx].cpqSsChassisName + " (" + i + ")";
   return rc;
}

// function imported from storage file ms-fccmn.js.en
function fcTapeCntlrName(idx)
{
   var rc = "";
   if (idx >= 0 && idx < cpqFcTapeCntlrEntry.length)
   {
      if (cpqFcTapeCntlrEntry[idx].cpqFcTapeCntlrModel == "")
         rc = displayItem("cpqFcTapeCntlrType", cpqFcTapeCntlrEntry[idx].cpqFcTapeCntlrType);
      else
         rc = cpqFcTapeCntlrEntry[idx].cpqFcTapeCntlrModel;
      rc += " (" + cpqFcTapeCntlrEntry[idx].cpqFcTapeCntlrWWN + ")";
   }
   return rc;
}




function makePageAnchor(aName)
{
	return("<a name=\"" + aName + "\">" + aName + "</a>");
}


// function imported from storage file ms-fccnt.php.en
function makePageLink(aName)
{
   return("<a href=\"#" + aName + "\">" + aName + "</a>");
}


function octetFound(singleOctet, octetArray)
{
	for (j=0; j<= octetArray.length; j++) {
		if (singleOctet == octetArray[j]){
			return true;
		}
	}
	
	return false;
}


function fibrePhysDrive(physIndex, thisLog, isSpareDrive, friendly)
{
	var physDriveStr = "";
	var thisPhys = cpqFcaPhyDrvEntry[physIndex];
	// Physical Drive Name
	var sPhysName = "Physical Drive - " + fcaPhysDriveName(physIndex, isSpareDrive);
	if (isSpareDrive) sPhysName += " - Spare";
	
	if (!friendly) {
		var ssCond = new cpqCondition(thisPhys.cpqFcaPhyDrvCondition);
		sPhysName = ssCond.image() + " " + sPhysName;
	}
	// Status
	var sStatus = displayItem("cpqFcaPhyDrvStatus", thisPhys.cpqFcaPhyDrvStatus);
	// Action
	var sAction = "No Action Required";
	if ((thisPhys.cpqFcaPhyDrvStatus == 4) ||(thisPhys.cpqFcaPhyDrvStatus == 6) ||
		(thisPhys.cpqFcaPhyDrvStatus == 5)) {
		sAction = "Replace Drive";
	}
	// Capacity (MB)
	var sCapacity = daDisplayCapacity(displayItem("cpqFcaPhyDrvSize", thisPhys.cpqFcaPhyDrvSize));
	// Model
	var sModel = displayItem("cpqFcaPhyDrvModel", thisPhys.cpqFcaPhyDrvModel);
	// Firmware Version
	var sFirmware = displayItem("cpqFcaPhyDrvFWRev", thisPhys.cpqFcaPhyDrvFWRev);
	// Serial Number
	var sSerialNum = displayItem("cpqFcaPhyDrvSerialNum", thisPhys.cpqFcaPhyDrvSerialNum);
	// Service Hours
	var sServiceHours = displayItem("cpqFcaPhyDrvRefHours", thisPhys.cpqFcaPhyDrvRefHours);
	// Drive Type
	var sDriveType = displayItem("cpqFcaPhyDrvType", thisPhys.cpqFcaPhyDrvType);
	//
	var sSataVersion, sCurrWidth, sCurrSpeed, sRotatSpeed;
	if (thisPhys.cpqFcaPhyDrvType == 3) {
		sSataVersion = displayItem("cpqFcaPhyDrvSataVersion", thisPhys.cpqFcaPhyDrvSataVersion);
		sCurrWidth = "N/A";
		sCurrSpeed = "N/A";
		sRotatSpeed = "N/A";
	}
	else {
		sSataVersion = "N/A";
		sCurrWidth = displayItem("cpqFcaPhyDrvCurrentWidth", thisPhys.cpqFcaPhyDrvCurrentWidth);
		sCurrSpeed = displayItem("cpqFcaPhyDrvCurrentSpeed", thisPhys.cpqFcaPhyDrvCurrentSpeed);
		sRotatSpeed = displayItem("cpqFcaPhyDrvRotationalSpeed", thisPhys.cpqFcaPhyDrvRotationalSpeed);
	}
	// Placement
	var sPlacement = displayItem("cpqFcaPhyDrvPlacement", thisPhys.cpqFcaPhyDrvPlacement);
	// SHOW THE PHYSICAL DRIVES
	if (isSpareDrive) {
		physDriveStr += tableLabel4(sPhysName);
	}
	else {
		physDriveStr += tableLabel3(sPhysName);
	}

	physDriveStr += ptTblHead(friendly);
	physDriveStr += tripleTableRow("Action:", sAction,
	                               "Status:", sStatus,
	                               "Model:", sModel);
	physDriveStr += tripleTableRow("Service Hours:", sServiceHours,
	                               "Drive Type:", sDriveType,
	                               "Capacity:", sCapacity);
	physDriveStr += tripleTableRow("Current Width:", sCurrWidth,
	                               "Current Speed:", sCurrSpeed,
	                               "Rotational Speed:", sRotatSpeed);
	physDriveStr += tripleTableRow("SATA Version:", sSataVersion,
	                               "Serial Number:", sSerialNum,
	                               "Firmware Version:", sFirmware);
	physDriveStr += tblTail;

	// show spare information
	var spareIndex = -1;
	if (isSpareDrive) {
		// search for the correspoding spare entry
		for (var i = 0; i < cpqFcaSpareEntry.length; i++) {
			if ((cpqFcaSpareEntry[i].cpqFcaSpareBoxIndex == thisPhys.cpqFcaPhyDrvBoxIndex) &&
			    (cpqFcaSpareEntry[i].cpqFcaSparePhyDrvIndex == thisPhys.cpqFcaPhyDrvIndex)) {
		    	spareIndex = i;
		    	break;
		    }
		}
	}
	
	if (spareIndex >= 0) {
		var thisSpare = cpqFcaSpareEntry[spareIndex];

		// spare drive name
		spareName = "Spare Information";
		if (!friendly) {
			spareCond = new cpqCondition(thisSpare.cpqFcaSpareCondition);
			spareName = spareCond.image() + " " + spareName;
		}
		
		// Status
		spareStatus = displayItem("cpqFcaSpareStatus", thisSpare.cpqFcaSpareStatus);
		
		// Percent Rebuild Complete
		if (friendly) {
			percentRebuild = displayItem("cpqFcaSparePercentRebuild", thisSpare.cpqFcaSparePercentRebuild);
		}
		else {
			percentRebuild = percentGraph(thisSpare.cpqFcaSparePercentRebuild);
		}

		// Replaced Drives
		replacedDrive = "None";
		if ((thisSpare.cpqFcaSpareReplacedDrvBay != -1) &&
		    (thisSpare.cpqFcaSpareReplacedDrvBusNumber != -1)) {
			for (var i = 0; i < cpqFcaPhyDrvEntry.length; i++) {
				if ((cpqFcaPhyDrvEntry[i].cpqFcaPhyDrvBay == thisSpare.cpqFcaSpareReplacedDrvBay) &&
				    (cpqFcaPhyDrvEntry[i].cpqFcaPhyDrvBusNumber == thisSpare.cpqFcaSpareReplacedDrvBusNumber)) {
					replacedDrive = fcaPhysDriveName(i, false);
					break;
				}
			}
		}

		physDriveStr += tableLabel6(spareName);
		physDriveStr += ptTblHead(friendly);
		physDriveStr += tripleTableRow("Status:", spareStatus,
		                               "Percent Rebuild Complete:", percentRebuild,
		                               "Replaced Drive:", replacedDrive);
		physDriveStr += tblTail;
	}
	
	return physDriveStr;
}


function daDisplayCapacity(itemValue)
{
   if (null == itemValue || "" == itemValue || "NULL" == itemValue ||
       -1 == parseInt(itemValue) || 4294967295 == parseInt(itemValue) ||
       "4294967295" == itemValue)
   {
      rc = "N/A";
   }
   else
   {
      var size = parseInt(itemValue, 10);
      if (!isNaN(size) && size > 0)
      {
         if(size < 1024)
            rc = size + " MB";
         else if(size < 1048576)
            rc =  Math.round((size / 1024) * 100) / 100  + " GB";
         else
            rc = Math.round((size / 1048576) * 100) / 100 + " TB";
      }
      else
      rc = "N/A";
   }
   return rc;
}


function getDiskPartition(drvOsName)
{
	if(drvOsName.length == 0)
		return "N/A";

	if( (typeof(cpqOsPhysicalDiskEntry) == "undefined") )
		return "N/A";

	var words = drvOsName.split(" ");
	if( words.length != 2 )
		return "N/A";

	var drvId = Number(words[1]);
	var disksAtPartition = new String("");

	for(var j = 0; j < cpqOsPhysicalDiskEntry.length; j++)
	{
		if(cpqOsPhysicalDiskEntry[j].cpqOsPhysicalDiskInstance == "_Total")
			continue;
		var parts = cpqOsPhysicalDiskEntry[j].cpqOsPhysicalDiskInstance.split(" ");

		if(parts.length < 2)
			continue;

		if ( Number(parts[0]) == drvId )
		{
    		var tmpDisksAtPartition = new Array();

			for(var k = 1; k < parts.length; k++)
			{
    				tmpDisksAtPartition[k-1] = parts[k];
			}
    		disksAtPartition = tmpDisksAtPartition.join(", ");
		}
	}

	if (disksAtPartition == "")
	{
		return "N/A";
	}
	else
	{
		return disksAtPartition;
	}
}

function raidPhysDriveName(idx)
{
	var i;
	var drive = cpqDaPhyDrvEntry[idx];
	var size = parseInt(drive.cpqDaPhyDrvSize, 10);
	var name;

	if (drive.cpqDaPhyDrvType > 2) {
		name = "Port " + drive.cpqDaPhyDrvHostConnector + " Box " + drive.cpqDaPhyDrvBoxOnConnector + " Bay " + drive.cpqDaPhyDrvBay;
	}
	else {
		name = "Port " + drive.cpqDaPhyDrvBusNumber + " Drive " + drive.cpqDaPhyDrvBay;
	}
	
	if (!isNaN(size) && size > 0) {
		name += "  " + daDisplayCapacity(drive.cpqDaPhyDrvSize);
	}
	
	for (i = 0; i < cpqDaSpareEntry.length; i++) {
		if (cpqDaSpareEntry[i].cpqDaSpareCntlrIndex == drive.cpqDaPhyDrvCntlrIndex &&
		    cpqDaSpareEntry[i].cpqDaSparePhyDrvIndex == drive.cpqDaPhyDrvIndex) {
			name += " - Spare";
		}
	}
	
	return name;
}


function raidControllerName(idx, friendly)
{
	var thisRaid = cpqDaCntlrEntry[idx];
	var raidModel = displayItem("cpqDaCntlrModel", thisRaid.cpqDaCntlrModel);			
	var driveName = "RAID Controller " + (idx+1) + " - " + raidModel;
	if (!friendly) {
		var driveCond = new cpqCondition(thisRaid.cpqDaCntlrCondition);
		driveName = driveCond.image() + " " + driveName;
	}
	return driveName;
}


function raidPhysDrive(physIndex, thisLog, isSpareDrive, friendly)
{
	var physDriveStr = "";
	var thisPhys = cpqDaPhyDrvEntry[physIndex];
	// Physical Drive Name
	var driveName = "Physical Drive - " + raidPhysDriveName(physIndex);
	if (!friendly) {
		var driveCond = new cpqCondition(thisPhys.cpqDaPhyDrvCondition);
		driveName = driveCond.image() + " " + driveName;
	}

	// Location
	var drvLocation = "Port " + thisPhys.cpqDaPhyDrvBusNumber + 
	                  " - Drive " + thisPhys.cpqDaPhyDrvBay;

	// Capacity (MB)
	var size = parseInt(thisPhys.cpqDaPhyDrvSize, 10);
	if (isNaN(size) || (size <= 0)) {
		physSize = "N/A";
	}
	else {
		physSize = daDisplayCapacity(thisPhys.cpqDaPhyDrvSize);
	}


	// Current Speed
	var currSpeed = "";
	if (thisPhys.cpqDaPhyDrvType == 4) {
		currSpeed = displayItem("cpqDaPhyDrvNegotiatedLinkRate",
								thisPhys.cpqDaPhyDrvNegotiatedLinkRate);
	}
	else {
		currSpeed = displayItem("cpqDaPhyDrvCurrentSpeed",
								thisPhys.cpqDaPhyDrvCurrentSpeed);
	}

	// Status
	var physStatus = displayItem("cpqDaPhyDrvStatus", thisPhys.cpqDaPhyDrvStatus);

	// Model
	var physModel = displayItem("cpqDaPhyDrvModel", thisPhys.cpqDaPhyDrvModel);

	// Firmware Version
	var physFirmware = displayItem("cpqDaPhyDrvFWRev", thisPhys.cpqDaPhyDrvFWRev);

	// Serial Number
	var physSerial = displayItem("cpqDaPhyDrvSerialNum", thisPhys.cpqDaPhyDrvSerialNum);

	// Placement
	var physPlacement = displayItem("cpqDaPhyDrvPlacement", thisPhys.cpqDaPhyDrvPlacement);

	// Drive Type
	var physDriveType = displayItem("cpqDaPhyDrvType", thisPhys.cpqDaPhyDrvType);

	// show physical drive information
	if (isSpareDrive) {
		physDriveStr += tableLabel4(driveName);
	}
	else {
		physDriveStr += tableLabel3(driveName);
	}

	physDriveStr += ptTblHead(friendly);
	physDriveStr += tripleTableRow("Location:", drvLocation,
	                               "Status:", physStatus,
	                               "Capacity:", physSize);
	physDriveStr += tripleTableRow("Model:", physModel,
	                               "Firmware Version:", physFirmware,
	                               "Serial Number:", physSerial);					
	physDriveStr += tripleTableRow("Placement:", physPlacement,
	                               "Current Speed:", currSpeed,
	                               "Drive Type:", physDriveType);
	physDriveStr += tblTail;
	
	// show spare information
	var spareIndex = -1;
	if (isSpareDrive) {
		// search for the correspoding spare entry
		for (var i = 0; i < cpqDaSpareEntry.length; i++) {
			if ((cpqDaSpareEntry[i].cpqDaSpareCntlrIndex == thisPhys.cpqDaPhyDrvCntlrIndex) &&
		        (cpqDaSpareEntry[i].cpqDaSparePhyDrvIndex == thisPhys.cpqDaPhyDrvIndex)) {
		    	spareIndex = i;
		    	break;
		    }
		}
	}
	
	if (spareIndex >= 0) {		
		var thisSpare = cpqDaSpareEntry[spareIndex];

		// spare drive name
		spareName = "Spare Information";
		if (!friendly) {
			spareCond = new cpqCondition(thisSpare.cpqDaSpareCondition);
			spareName = spareCond.image() + " " + spareName;
		}
		
		// Status
		spareStatus = displayItem("cpqDaSpareStatus", thisSpare.cpqDaSpareStatus);

		// rebuild info
		if (friendly) {
			rebuildData = displayItem("cpqDaSparePercentRebuild", thisSpare.cpqDaSparePercentRebuild);
		}
		else {
			rebuildData = percentGraph(thisSpare.cpqDaSparePercentRebuild);
		}
		
		// Replaced Drives
		replacedDrive = "None";
		if (thisSpare.cpqDaSpareReplacedDrv != -1) {
			for (var i = 0; i < cpqDaPhyDrvEntry.length; i++) {
				if (cpqDaPhyDrvEntry[i].cpqDaPhyDrvIndex == thisSpare.cpqDaSpareReplacedDrv) {
					replacedDrive = raidPhysDriveName(i);
					break;
				}
			}
		}

		physDriveStr += tableLabel6(spareName);
		physDriveStr += ptTblHead(friendly);
		physDriveStr += tripleTableRow("Status:", spareStatus,
		                               "Percent Rebuild Complete:", rebuildData,
		                               "Replaced Drive:", replacedDrive);		
		physDriveStr += tblTail;
	}
	
	return physDriveStr;
}


function daCntlrBoardName(idx)
{
	var rc = displayItem("cpqDaCntlrModel", cpqDaCntlrEntry[idx].cpqDaCntlrModel) + " Controller ";
	
	if (cpqDaCntlrEntry[idx].cpqDaCntlrHwLocation != "") {
		if (cpqDaCntlrEntry[idx].cpqDaCntlrHwLocation == "Slot 0") {
			rc += "on System Board";
		}
		else {
			rc += "in "+ cpqDaCntlrEntry[idx].cpqDaCntlrHwLocation;
		}
	}
	else if (cpqDaCntlrEntry[idx].cpqDaCntlrSlot == 0) {
		rc += "on System Board";
	}
	else {
		rc += "in Slot " + cpqDaCntlrEntry[idx].cpqDaCntlrSlot;
	}
	return rc;
}


function daCntlrName(idx)
{
	var name = daCntlrBoardName(idx);
	
	with (cpqDaCntlrEntry[idx]) {
		if (typeof(cpqDaCntlrCurrentRole) != "undefined") {
			if (cpqDaCntlrCurrentRole == 3 && cpqDaCntlrPartnerSlot != -1) {
				if (cpqDaCntlrPartnerSlot == 0) {
					name += "/on System Board";
				}
				else if (cpqDaCntlrSlot == 0) {
					name += "/Slot " + cpqDaCntlrPartnerSlot;
				}
				else {
					name += "/" + cpqDaCntlrPartnerSlot;
				}
			}
			if ((cpqDaCntlrCurrentRole == 3 || cpqDaCntlrCurrentRole == 4) &&
			    (cpqDaCntlrPartnerSlot == -1))  {
				if (cpqDaCntlrRedundancyType == 3) {
					name += "/Other Server";
				}
				else {
					name += "/Unknown";
				}
			}
		}
	}
	return name;
}


function raidSasDriveBox(boxIndex, raidIndex, friendly)
{
	var driveStr = "";
	var thisBox = cpqSsDrvBoxEntry[boxIndex];
	
	// Storage Box Name
	var boxName = "Storage System: " + daCntlrBoardName(raidIndex);
	boxName += " Port " + thisBox.cpqSsBoxHostConnector +
	           " Box " + thisBox.cpqSsBoxBoxOnConnector;
	if (!friendly) {
		var boxCond = new cpqCondition(thisBox.cpqSsBoxCondition);
		boxName = boxCond.image() + " " + boxName;
	}
	
	// Connection Type
	var connectionType = displayItem("cpqSsBoxConnectionType", thisBox.cpqSsBoxConnectionType);
	
	// Drive Bays
	var totalBays = displayItem("cpqSsBoxTotalBays", thisBox.cpqSsBoxTotalBays);
	
	var vendor, fanStatus, model, pwrSupplyStatus, fwRev, tempStatus, serialNumber = "";	
	if (thisBox.cpqSsBoxModel != "") {
		// Vendor
		boxVendor = displayItem("cpqSsBoxVendor", thisBox.cpqSsBoxVendor);
		
		// Fan Status
		fanStatus = displayItem("cpqSsBoxFanStatus", thisBox.cpqSsBoxFanStatus);
		
		// Model
		model = displayItem("cpqSsBoxModel", thisBox.cpqSsBoxModel);
		
		// Power Supply Status
		pwrSupplyStatus = displayItem("cpqSsBoxFltTolPwrSupplyStatus", thisBox.cpqSsBoxFltTolPwrSupplyStatus);
		
		// Firmware Revision
		fwRev = displayItem("cpqSsBoxFWRev", thisBox.cpqSsBoxFWRev);
		
		// Thermal Status
		tempStatus = displayItem("cpqSsBoxTempStatus", thisBox.cpqSsBoxTempStatus);
		
		// Serial Number
		serialNumber = displayItem("cpqSsBoxSerialNumber", thisBox.cpqSsBoxSerialNumber);
	}


	// show logical drive information
	driveStr += tableLabel2(boxName);
	driveStr += ptTblHead(friendly);
	
	if (thisBox.cpqSsBoxModel == "") {
		driveStr += tripleTableRow("Connection Type:", connectionType,
		                           "Drive Bays:", totalBays,
		                           "", "");
	}
	else {
		driveStr += tripleTableRow("Connection Type:", connectionType,
		                           "Drive Bays:", totalBays,
		                           "Vendor:", boxVendor);
		driveStr += tripleTableRow("Fan Status:", fanStatus,
		                           "Model:", model,
		                           "Power Supply Status:", pwrSupplyStatus);
		driveStr += tripleTableRow("Firmware Revision:", fwRev,
		                           "Thermal Status:", tempStatus,
		                           "Serial Number:", serialNumber);
	}
	
	driveStr += tblTail;
	
	return driveStr;
}


function raidDriveBox(boxIndex, raidIndex, friendly)
{
	var driveStr = "";
	var thisBox = cpqSsDrvBoxEntry[boxIndex];
	
	// Storage Box Name
	var boxName = "Storage System: " + daCntlrBoardName(raidIndex);
	if (thisBox.cpqSsBoxPlacement == 2) {
		boxName += " Internal ";
	}
	else if (thisBox.cpqSsBoxPlacement == 3) {
		boxName += " External ";
	}
	boxName += " Storage System on Port " + thisBox.cpqSsBoxBusIndex;
	
	if (!friendly) {
		var boxCond = new cpqCondition(thisBox.cpqSsBoxCondition);
		boxName = boxCond.image() + " " + boxName;
	}
	
	// Box Type
	var placement = displayItem("cpqSsBoxPlacement", thisBox.cpqSsBoxPlacement);
	
	// Thermal Status
	var tempStatus = displayItem("cpqSsBoxTempStatus", thisBox.cpqSsBoxTempStatus);
	
	// Vendor
	var boxVendor = displayItem("cpqSsBoxVendor", thisBox.cpqSsBoxVendor);
		
	// Fan Status
	var fanStatus = displayItem("cpqSsBoxFanStatus", thisBox.cpqSsBoxFanStatus);
		
	// Model
	var model = displayItem("cpqSsBoxModel", thisBox.cpqSsBoxModel);
		
	// Power Supply Status
	var pwrSupplyStatus = displayItem("cpqSsBoxFltTolPwrSupplyStatus", thisBox.cpqSsBoxFltTolPwrSupplyStatus);

	// Serial Number
	var serialNumber = displayItem("cpqSsBoxSerialNumber", thisBox.cpqSsBoxSerialNumber);
	
	// Backplane Speed
	var backplaneSpeed = displayItem("cpqSsBoxBackplaneSpeed", thisBox.cpqSsBoxBackplaneSpeed);
		
	// Firmware Revision
	var fwRev = displayItem("cpqSsBoxFWRev", thisBox.cpqSsBoxFWRev);
	
	// Drive Bays
	var totalBays = displayItem("cpqSsBoxTotalBays", thisBox.cpqSsBoxTotalBays);
	
	// Board Revision
	var boardRevision = displayItem("cpqSsBoxBoardRevision", thisBox.cpqSsBoxBoardRevision);
	
	// Duplex Option
	var duplexOption = displayItem("cpqSsBoxDuplexOption", thisBox.cpqSsBoxDuplexOption);
	
	// show logical drive information
	driveStr += tableLabel2(boxName);
	driveStr += ptTblHead(friendly);
	

	driveStr += tripleTableRow("Box Type:", placement,
	                           "Thermal Status:", tempStatus,
	                           "Vendor:", boxVendor);
	driveStr += tripleTableRow("Fan Status:", fanStatus,
	                           "Model:", model,
	                           "Power Supply Status:", pwrSupplyStatus);
	driveStr += tripleTableRow("Serial Number:", serialNumber,
	                           "Backplane Speed:", backplaneSpeed,
	                           "Firmware Revision:", fwRev);
	driveStr += tripleTableRow("Drive Bays:", totalBays,
	                           "Board Revision:", boardRevision,
	                           "Duplex Option:", duplexOption);	
	driveStr += tblTail;
	
	return driveStr;
}

function daDisplayCacheSize(itemValue)
{
   if (null == itemValue || "" == itemValue || "NULL" == itemValue ||
       -1 == parseInt(itemValue) || 4294967295 == parseInt(itemValue) ||
       "4294967295" == itemValue)
   {
      rc = "N/A";
   }
   else
   {
      var size = parseInt(itemValue, 10);
      if (!isNaN(size) && size > 0)
      {
         if(size < 1024)
            rc = size + " KB";
         else if(size < 1048576)
            rc =  Math.round((size / 1024) * 100) / 100  + " MB";
         else
            rc = Math.round((size / 1048576) * 100) / 100 + " GB";
      }
      else
      rc = "N/A";
   }
   return rc;
}

// RAID CONTROLLERS ***********************************************************
function raidControllersSection(friendly)
{
	var sectionStr = "";
	
	var raidEntries = cpqDaCntlrEntry.length;
	
	if (raidEntries > 0) {
		var logEntries = cpqDaLogDrvEntry.length;
		var physEntries = cpqDaPhyDrvEntry.length;
		
		sectionStr += tableLabel("Smart Array RAID Controllers");
	
		// variables used in the controller loop (i)
		var thisRaid, raidModel, driveName;
		var intPorts, extPorts, portsCount;
		var raidLocation, raidStatus, raidFirmware, raidRevision;
		var raidSerialNum, raidDaughter, driveCond;
		
		// variables used in the logical drives loop (j)
		var thisLog;
		var logOsName, logStatus, logSize, logFault;

		// variables used in the physical drives loop (k)
		var thisPhys;
		var drvLocation, physSize, currSpeed, physStatus, physModel;
		var physFirmware, physSerial, physPlacement, physDriveType;
		
		// variables used in the spare drives loop (k)
		var availSpares;
		
		for (var i = 0; i < raidEntries; i++) {
			thisRaid = cpqDaCntlrEntry[i];
			
			// Controller Name
			driveName = raidControllerName(i, friendly);
			
			// Ports
			intPorts = parseInt(thisRaid.cpqDaCntlrNumberOfInternalPorts);
			if (isNaN(intPorts)) {
				intPorts = 0;
			}
			extPorts = parseInt(thisRaid.cpqDaCntlrNumberOfExternalPorts);
			if (isNaN(extPorts)) {
				extPorts = 0;
			}
			portsCount;
			if ((intPorts > 0) || (extPorts > 0)) {
				portsCount = intPorts + extPorts;
			}
			else {
				portsCount = displayItem("cpqDaCntlrNumberOfBuses", thisRaid.cpqDaCntlrNumberOfBuses);
			}
			
			// Location
			raidLocation = displayItem("cpqDaCntlrHwLocation", thisRaid.cpqDaCntlrHwLocation);
			
			// Status
			raidStatus = displayItem("cpqDaCntlrBoardStatus", thisRaid.cpqDaCntlrBoardStatus);
			
			// Firmware Version
			raidFirmware = displayItem("cpqDaCntlrFWRev", thisRaid.cpqDaCntlrFWRev);
			
			// Product Revision
			raidRevision = displayItem("cpqDaCntlrProductRev", thisRaid.cpqDaCntlrProductRev);
			
			// Serial Number
			raidSerialNum = displayItem("cpqDaCntlrSerialNumber", thisRaid.cpqDaCntlrSerialNumber);
			
			// Daughter Board Type
			raidDaughter = displayItem("cpqDaCntlrDaughterBoardType", thisRaid.cpqDaCntlrDaughterBoardType);
			
			// show the controller information
			sectionStr += tableLabelH3(driveName);
			sectionStr += ptTblHead(friendly);
			sectionStr += tripleTableRow("Location:", raidLocation,
			                             "Status:", raidStatus,
			                             "Firmware Version:", raidFirmware);
			sectionStr += tripleTableRow("Serial Number:", raidSerialNum,
			                             "Daughter Board Type:", raidDaughter,
			                             "Ports:", portsCount);
			sectionStr += tripleTableRow("Product Revision:", raidRevision,
			                             "", "",
			                             "", "");
			sectionStr += tblTail;
				
			// Display accelerator information
			cntlrIdx = thisRaid.cpqDaCntlrIndex;
			accelIdx = -1;
			for (var j = 0; j < cpqDaAccelEntry.length; j++) {
				if (cpqDaAccelEntry[j].cpqDaAccelCntlrIndex == cntlrIdx &&
				    cpqDaAccelEntry[j].cpqDaAccelStatus != 2) {
					accelIdx = j;
					break;
				}
			}
			
			if (accelIdx >= 0 && accelIdx < cpqDaAccelEntry.length) {
				thisAccel = cpqDaAccelEntry[accelIdx];
				thisAccelCondition = new cpqCondition(thisAccel.cpqDaAccelCondition);

				if ((typeof(thisAccel.cpqDaAccelReadCachePercent) != "undefined") &&
				(thisAccel.cpqDaAccelReadCachePercent != MAXCOUNT)) {
					readCache  = thisAccel.cpqDaAccelReadCachePercent  + "%";
					writeCache = thisAccel.cpqDaAccelWriteCachePercent + "%";
				} else {
					readCache  = displayItem("cpqDaAccelReadMemory", daDisplayCacheSize(thisAccel.cpqDaAccelReadMemory));
					writeCache = displayItem("cpqDaAccelMemory", daDisplayCacheSize(thisAccel.cpqDaAccelMemory));
				}

				if ((thisAccel.cpqDaAccelBattery == 4) && (thisAccel.cpqDaAccelErrCode == 4)) {
					errorCode  = "Replace Battery";
				} else {
					errorCode  = displayItem("cpqDaAccelErrCode", thisAccel.cpqDaAccelErrCode);
				}

				var ssName = "Accelerator";
				if (!friendly) {
					ssCond = new cpqCondition(thisAccel.cpqDaAccelCondition);
					ssName = ssCond.image() + " " + ssName;
				}

				// SHOW FIELDS
				sectionStr += tableLabel6(ssName);
				sectionStr += ptTblHead(friendly);

				sectionStr += tripleTableRow("Battery Status:", displayItem("cpqDaAccelBattery", thisAccel.cpqDaAccelBattery),
				                             "Status:", displayItem("cpqDaAccelStatus", thisAccel.cpqDaAccelStatus),
				                             "Total Memory:", displayItem("cpqDaAccelTotalMemory", daDisplayCacheSize(thisAccel.cpqDaAccelTotalMemory)));
				sectionStr += tripleTableRow("Serial Number:", displayItem("cpqDaAccelSerialNumber", thisAccel.cpqDaAccelSerialNumber),
				                             "Read Cache:", readCache,
				                             "Read Errors:", displayItem("cpqDaAccelReadErrs", thisAccel.cpqDaAccelReadErrs));
				sectionStr += tripleTableRow("Error Code:", errorCode,
				                             "Write Cache:", writeCache,
				                             "Write Errors:", displayItem("cpqDaAccelWriteErrs", thisAccel.cpqDaAccelWriteErrs));
				sectionStr += tripleTableRow("Bad Data:", displayItem("cpqDaAccelBadData", thisAccel.cpqDaAccelBadData),
				                             "", "",
				                             "", "");
				sectionStr += tblTail;
			}		
			// End of display accelerator information
			
			// LOGICAL DRIVES *************************************************
			for (var j = 0; j < logEntries; j++) {
				thisLog = cpqDaLogDrvEntry[j];
				
				// match the logical drive with the current controller
				if (thisRaid.cpqDaCntlrIndex != thisLog.cpqDaLogDrvCntlrIndex) {
					continue;
				}

				// OS Disk Name
				logOsName = displayItem("cpqDaLogDrvOsName", thisLog.cpqDaLogDrvOsName);
				
				// Logical Drive Name
				driveCond = new cpqCondition(thisLog.cpqDaLogDrvCondition);
				driveName = "Logical Drive " + thisLog.cpqDaLogDrvIndex;
				if (logOsName != "N/A") {
				 	driveName += " - " + logOsName;
				}
				if (!friendly) {
					driveName = driveCond.image() + " " + driveName;
				}
			
				// Disk Partition
				var str = getDiskPartition(thisLog.cpqDaLogDrvOsName);
				if (str != "N/A"){
					logOsName += " - " + getDiskPartition(thisLog.cpqDaLogDrvOsName);
				}
			
				// Status
				logStatus = displayItem("cpqDaLogDrvStatus", thisLog.cpqDaLogDrvStatus);
				
				// Capacity (MB)
				logSize = daDisplayCapacity(displayItem("cpqDaLogDrvSize", thisLog.cpqDaLogDrvSize));
				
				// Fault Tolerance
				logFault = displayItem("cpqDaLogDrvFaultTol", thisLog.cpqDaLogDrvFaultTol);
				
				// show logical drive information
				sectionStr += tableLabel2(driveName);
				sectionStr += ptTblHead(friendly);
				sectionStr += tripleTableRow("OS Disk Name:", logOsName,
				                             "Status:", logStatus,
				                             "Fault Tolerance:", logFault);
				sectionStr += tripleTableRow("Capacity:", logSize,
				                             "", "",
				                             "", "");
				sectionStr += tblTail;

				// PHYSICAL DRIVES ********************************************
				for (var k = 0; k < physEntries; k++) {
					thisPhys = cpqDaPhyDrvEntry[k];
					rawData = cpqDaLogDrvPhyDrvIDs[j];
					 bigIdx = 0;
        				for ( tmpC = 0; tmpC < rawData.length; tmpC++)
        				{
                				if (rawData[tmpC] != 0)
                				{
                        				if (bigIdx < tmpC)
                                				bigIdx = tmpC;
                				}
        				}
        				rawData.length = bigIdx + 1;				
					// match the physical drives with the current logical drive
					if (!octetFound(thisPhys.cpqDaPhyDrvIndex, rawData) ||
					    (thisRaid.cpqDaCntlrIndex != thisPhys.cpqDaPhyDrvCntlrIndex)) {
						continue;
					}

					sectionStr += raidPhysDrive(k, thisLog, false, friendly);
				}
				
				
				// SPARE DRIVES ***********************************************
				availSpares = "";
				if (typeof(cpqDaLogDrvAvailSpares[j]) != "undefined") {
					availSpares = cpqDaLogDrvAvailSpares[j];
				}
				//for (var s = 0; s < availSpares.length; s++) {
				for (var k = 0; k < cpqDaPhyDrvEntry.length; k++) {						
					// loop through the spare drives
					//for (var k = 0; k < cpqDaPhyDrvEntry.length; k++) {	
					for (var s = 0; s < availSpares.length; s++) {
						thisPhys = cpqDaPhyDrvEntry[k];						
						// find the corresponding physical drive
						if ((thisPhys.cpqDaPhyDrvCntlrIndex == thisRaid.cpqDaCntlrIndex) &&
						    (thisPhys.cpqDaPhyDrvIndex == availSpares[s])) {
						    sectionStr += raidPhysDrive(k, thisLog, true, friendly);
						    break;
						}
					}
				}
			}
			// STORAGE SYSTEMS ************************************************
			for (var j = 0; j < cpqSsDrvBoxEntry.length; j++) {
				// match the storage boxes with the current controller
				if (cpqSsDrvBoxEntry[j].cpqSsBoxCntlrIndex != thisRaid.cpqDaCntlrIndex) {
					continue;
				}
				
				if (cpqSsDrvBoxEntry[j].cpqSsBoxConnectionType == 3) {
					sectionStr += raidSasDriveBox(j, i, friendly);
				}
				else {
					sectionStr += raidDriveBox(j, i, friendly);
				}
			}
			
			// UNCONFIGURED DRIVES ********************************************
			var unconfigDrives = 0;
			for (var k = 0; k < cpqDaPhyDrvEntry.length; k++) {
				if (thisRaid.cpqDaCntlrIndex != cpqDaPhyDrvEntry[k].cpqDaPhyDrvCntlrIndex) {
					continue;
				}
				if (cpqDaPhyDrvEntry[k].cpqDaPhyDrvConfigurationStatus == "3") {
					unconfigDrives++;
				}
			}
			
			if (unconfigDrives > 0) {
				if (unconfigDrives == 1) {
					sectionStr += ptTblHead(friendly);
					sectionStr += sectionFootnote("There is 1 unconfigured physical drive in this controller.");
					sectionStr += tblTail;
				}
				else {
					sectionStr += sectionFootnote("There are " + unconfigDrives + " unconfigured physical drives in this controller.");
				}
			}
		}
		sectionStr += tblTail;		
		sectionStr += whiteSpaceDivider();
	}
	return sectionStr;
}


function writeSasDriveBox(box){
	
	var driveBoxStr= "";
	var vendor = "N/A";
	var fanStatus = "N/A";
	var model = "N/A";
	var powerSupStatus = "N/A";
	var firmwareRev = "N/A";
	var thermalStatus = "N/A";
	var serialNum = "N/A";
	if (box.cpqSsBoxModel != "") {	
		vendor = displayItem("cpqSsBoxVendor", box.cpqSsBoxVendor);
		fanStatus = displayItem("cpqSsBoxFanStatus", box.cpqSsBoxFanStatus);
		model = displayItem("cpqSsBoxModel", box.cpqSsBoxModel);
		powerSupStatus = displayItem("cpqSsBoxFltTolPwrSupplyStatus", box.cpqSsBoxFltTolPwrSupplyStatus);
		firmwareRev = displayItem("cpqSsBoxFWRev", box.cpqSsBoxFWRev);
		thermalStatus = displayItem("cpqSsBoxTempStatus", box.cpqSsBoxTempStatus);
		serialNum = displayItem("cpqSsBoxSerialNumber", box.cpqSsBoxSerialNumber);
	}

	
	driveBoxStr += ptTblHead(friendly);
	driveBoxStr += tripleTableRow("Connection Type:", displayItem("cpqSsBoxConnectionType", box.cpqSsBoxConnectionType),
		                      "Drive Bays:", displayItem("cpqSsBoxTotalBays", box.cpqSsBoxTotalBays),
	                              "Vendor:", vendor);
	driveBoxStr += tripleTableRow("Fan Status:", fanStatus,
				      "Model:", model,
				      "Power Supply Status:", powerSupStatus);
	driveBoxStr += tripleTableRow("Firmware Revision:", firmwareRev,
				      "Thermal Status:", thermalStatus,
				      "Serial Number:", serialNum);
	driveBoxStr += tblTail;
	
	return driveBoxStr;

}


function sasPhysDrive(physIndex, thisLog, isSpareDrive, friendly){
	
	var physDriveStr = "";
	var thisPhys = cpqSasPhyDrvEntry[physIndex];
	
	// Physical Drive Name
	var driveName = "Physical Drive - " + phyDriveName(physIndex);
	if (!friendly) {
		var driveCond = new cpqCondition(thisPhys.cpqSasPhyDrvCondition);
		driveName = driveCond.image() + " " + driveName;
	}

	// show physical drive information
	if (isSpareDrive) {
		physDriveStr += tableLabel4(driveName);
	}
	else {
		physDriveStr += tableLabel3(driveName);
	}

	var sasAddress = "N/A";
	var rotationalSpeed = "N/A";
	var usedRealloc = "N/A";
	if (thisPhys.cpqSasPhyDrvType == "2") {
		sasAddress = displayItem("cpqSasPhyDrvSasAddress", thisPhys.cpqSasPhyDrvSasAddress);
		rotationalSpeed = displayItem("cpqSasPhyDrvRotationalSpeed", thisPhys.cpqSasPhyDrvRotationalSpeed);
		usedRealloc = displayItem("cpqSasPhyDrvUsedReallocs", thisPhys.cpqSasPhyDrvUsedReallocs);
	}
	
	var osAssignedName = "N/A";
	if (thisPhys.cpqSasPhyDrvMemberLogDrv == 4)
		osAssignedName = displayItem("cpqSasPhyDrvOsName", thisPhys.cpqSasPhyDrvOsName);


	physDriveStr += ptTblHead(friendly);
	physDriveStr += tripleTableRow("Model:", displayItem("cpqSasPhyDrvModel", thisPhys.cpqSasPhyDrvModel),
				       "Status:", displayItem("cpqSasPhyDrvStatus", thisPhys.cpqSasPhyDrvStatus),
	                               "Serial Number:", displayItem("cpqSasPhyDrvSerialNumber", thisPhys.cpqSasPhyDrvSerialNumber));
	physDriveStr += tripleTableRow("Capacity:", displayCapacity(thisPhys.cpqSasPhyDrvSize),
				       "Firmware Version:", displayItem("cpqSasPhyDrvFWRev", thisPhys.cpqSasPhyDrvFWRev),
	                               "Placement:",  displayItem("cpqSasPhyDrvPlacement", thisPhys.cpqSasPhyDrvPlacement));
	physDriveStr += tripleTableRow("Drive Type:", displayItem("cpqSasPhyDrvType", thisPhys.cpqSasPhyDrvType),				
				       "SAS Address:", sasAddress,
	                               "Rotational Speed:", rotationalSpeed);
	physDriveStr += tripleTableRow("Used Realloc:", usedRealloc,				
				       "OS Assigned Name:", osAssignedName,
		                       "", "");
	physDriveStr += tblTail;
	
	return physDriveStr;
}

function getReplacedDrive(idx, hbaIndex){
   var i, drive = "N/A";
   if (idx != "" && idx >= 0){
      for (i = 0; i < cpqSasPhyDrvEntry.length; i++){
 	   if (cpqSasPhyDrvEntry[i].cpqSasPhyDrvIndex == idx
	       &&  cpqSasPhyDrvEntry[i].cpqSasPhyDrvHbaIndex == hbaIndex){
            		drive = phyDriveName(i);
            		break;
           }

      }
   }
   return drive;
}


// SAS CONTROLLERS ***********************************************************
function sasControllersSection(friendly)
{
	var sectionStr = "";
	
	var sasEntries = cpqSasHbaEntry.length;
	
	if (sasEntries > 0) {
		var logEntries  = cpqSasLogDrvEntry.length;
		var physEntries = cpqSasPhyDrvEntry.length;
		var boxEntries  = cpqSsDrvBoxEntry.length;
		
		sectionStr += tableLabel("SAS Controllers");
	
		// variables used in the controller loop (i)
		var thisSas, driveName, driveCond;
		var sasContName, sasHwLocation, sasHbaIndex;
		// variables used in the logical drives loop (j)
		var thisLog, logOsName, stripe;

		// variables used in the physical drives loop (k)
		var thisPhys;
	
		for (var i = 0; i < sasEntries; i++) {
			thisSas = cpqSasHbaEntry[i];
			
			// Controller Name
			sasContName = displayItem("cpqSasHbaModel", thisSas.cpqSasHbaModel);
			sasHwLocation = displayItem("cpqSasHbaHwLocation", thisSas.cpqSasHbaHwLocation);
			
			if (sasHwLocation != "N/A") {
				if (sasHwLocation  == "Slot 0") {
					sasContName += " on System Board";
				}
				else {
					sasContName += " in " + sasHwLocation;
				}
			}
			
			sasHbaIndex = displayItem("cpqSasHbaIndex", thisSas.cpqSasHbaIndex);
			sasContName += " (" + sasHbaIndex + ")";
								
			driveName = "SAS Controller " + (i+1) + " - " + sasContName;
			
			if (!friendly) {
				var driveCond = new cpqCondition(thisSas.cpqSasHbaCondition);
				driveName = driveCond.image() + " " + driveName;
			}

			// show the controller information
			sectionStr += tableLabelH3(driveName);
			
			sectionStr += ptTblHead(friendly);
			sectionStr += tripleTableRow("Status:", displayItem("cpqSasHbaStatus", thisSas.cpqSasHbaStatus),
						     "Bios Version:", displayItem("cpqSasHbaBiosVersion", thisSas.cpqSasHbaBiosVersion), 
						     "Serial Number:", displayItem("cpqSasHbaSerialNumber", thisSas.cpqSasHbaSerialNumber));
			sectionStr += tripleTableRow("Firmware Version:", displayItem("cpqSasHbaFwVersion", thisSas.cpqSasHbaFwVersion),
			                             "", "",
			                             "", "");
			sectionStr += tblTail;
			
			
			// LOGICAL DRIVES *************************************************
			for (var j = 0; j < logEntries; j++) {
				thisLog = cpqSasLogDrvEntry[j];
								
				// match the logical drive with the current controller
				if (thisSas.cpqSasHbaIndex != thisLog.cpqSasLogDrvHbaIndex) {
					continue;
				}
				
				// OS Disk Name
				if (thisLog.cpqSasLogDrvOsName != "")
					logOsName = displayItem("cpqSasLogDrvOsName", thisLog.cpqSasLogDrvOsName);
				
				// Logical Drive Name
				driveCond = new cpqCondition(thisLog.cpqSasLogDrvCondition);
				driveName = "Logical Drive " + thisLog.cpqSasLogDrvIndex; 
				if (thisLog.cpqSasLogDrvOsName != "") {
					driveName += " - " + logOsName;
				}
				if (!friendly) {
					driveName = driveCond.image() + " " + driveName;
				}
				
			
				if(thisLog.cpqSasLogDrvStripeSize == 0)
				      stripe = "N/A";
				   else
      				      stripe = displayItem("cpqSasLogDrvStripeSize", thisLog.cpqSasLogDrvStripeSize);
      				      
				// Rebuild Percent Complete
				// Rebuilding Drive
				var rebuildPercent = "N/A";
				var rebuildDrive = "N/A";
				
				if (thisLog.cpqSasLogDrvStatus == 4) {
					rebuildPercent = displayItem("cpqSasLogDrvRebuildingPercent", thisLog.cpqSasLogDrvRebuildingPercent);
					rebuildDrive = getReplacedDrive(thisLog.cpqSasLogDrvRebuildingDisk,
									thisLog.cpqSasLogDrvHbaIndex);
				}
    
				// show logical drive information
				sectionStr += tableLabel2(driveName);
				sectionStr += ptTblHead(friendly);
				sectionStr += tripleTableRow("Status:", displayItem("cpqSasLogDrvStatus", thisLog.cpqSasLogDrvStatus),
				                             "Raid Level:", displayItem("cpqSasLogDrvRaidLevel", thisLog.cpqSasLogDrvRaidLevel),
				                             "Capacity:", displayCapacity(thisLog.cpqSasLogDrvCapacity));
				sectionStr += tripleTableRow("Stripe Size:", stripe,
				                             "Rebuild Percent Complete:", rebuildPercent,
				                             "Rebuilding Drive:", rebuildDrive);

				sectionStr += tblTail;

 				//used in both Physical and Spare drives
 				rawData = cpqSasLogDrvPhyDrvIds[j];
 				
 				// PHYSICAL DRIVES ********************************************
				for (var r = 0; r < rawData.length; r+=4){
					Idx = (rawData[r+3] * 0x1000000) + (rawData[r+2] * 0x10000) +
					      (rawData[r+1] * 0x100) + (rawData[r] * 1);  // 4 byte value

					for (var k = 0; k < physEntries; k++){
						if (cpqSasPhyDrvEntry[k].cpqSasPhyDrvMemberLogDrv == 2 &&
						    cpqSasPhyDrvEntry[k].cpqSasPhyDrvIndex == Idx &&
						    cpqSasPhyDrvEntry[k].cpqSasPhyDrvHbaIndex == cpqSasHbaEntry[i].cpqSasHbaIndex){
							
							sectionStr += sasPhysDrive(k, thisLog, false, friendly);
							break;
							
						}
					}
				}

				rawData = cpqSasLogDrvSpareIds[j];
				// SPARE DRIVES ***********************************************
				for (r = 0; r < rawData.length; r+=4){
					Idx = (rawData[r+3] * 0x1000000) + (rawData[r+2] * 0x10000) +
					      (rawData[r+1] * 0x100) + (rawData[r] * 1);  // 4 byte value

					for (k = 0; k < physEntries; k++){
						if (cpqSasPhyDrvEntry[k].cpqSasPhyDrvMemberLogDrv == 3 &&
						    cpqSasPhyDrvEntry[k].cpqSasPhyDrvIndex == Idx &&
						    cpqSasPhyDrvEntry[k].cpqSasPhyDrvHbaIndex == cpqSasHbaEntry[i].cpqSasHbaIndex){

							sectionStr += sasPhysDrive(k, thisLog, true, friendly);
							break;

						}
					}
				}
			}

			// STORAGE BOXES ************************************************
			for (var j = 0; j < boxEntries; j++) {
				thisBox = cpqSsDrvBoxEntry[j];
				// match the storage boxes with the current controller
				if (thisBox.cpqSsBoxCntlrIndex != thisSas.cpqSasHbaIndex) {
					continue;
				}
				driveName = "SAS Storage System";
				if (!friendly) {
					var driveName = new cpqCondition(thisBox.cpqSsBoxCondition);
					driveName = boxCond.image() + " " + driveName;
				}
				sectionStr += tableLabel2(driveName);
				sectionStr += ptTblHead(friendly);
				sectionStr += writeSasDriveBox(thisBox); 
				sectionStr += tblTail;
			}

		}
		sectionStr += tblTail;		
		sectionStr += whiteSpaceDivider();
	}
	return sectionStr;
}





// FIBRE CHANNEL CONTROLLERS **************************************************
function fcaControllersSection(friendly)
{
	var sectionStr = "";
	
	var fcaEntries = cpqFcaHostCntlrEntry.length;
	
	if (fcaEntries > 0) {
		var logEntries = cpqFcaLogDrvEntry.length;
		var physEntries = cpqFcaPhyDrvEntry.length;

		sectionStr += tableLabel("Fibre Channel Controllers");
		
		// variables used in the controllers loop (i)
		var thisFibre, driveName, driveCond;
		var fibreModel, intPorts, extPorts, portsCount, fibreStatus;
		var fibreFirmware, fibreSerial, fibreWWPort, fibreWWNode, storageSys, fibreTapeCntlr;
		var ssIndex, ssFound, thisChassi, ssCond;
		var tcIndex, tcFound, thisTapeCntlr, tcCond;
		var ssIndexArray = new Array(), splitOctet = new Array();

		for (var i = 0; i < fcaEntries; i++) {
			thisFibre = cpqFcaHostCntlrEntry[i];

			// Controller Name
			driveCond = new cpqCondition(thisFibre.cpqFcaHostCntlrCondition);
			fibreModel = displayItem("cpqFcaHostCntlrModel", thisFibre.cpqFcaHostCntlrModel);
			
			driveName = "Fibre Channel Controller " + (i+1) + " - " + fibreModel;
			if (!friendly) {
				driveName = driveCond.image() + " " + driveName;
			}
				
			// Status
			fibreStatus = displayItem("cpqFcaHostCntlrStatus", thisFibre.cpqFcaHostCntlrStatus);
			
			// Firmware Version
			fibreFirmware = displayItem("cpqFcaHostCntlrFirmwareVersion", thisFibre.cpqFcaHostCntlrFirmwareVersion);
			
			// Serial Number
			fibreSerial = displayItem("cpqFcaHostCntlrSerialNumber",  thisFibre.cpqFcaHostCntlrSerialNumber);
			
			// World Wide Port
			fibreWWPort = displayItem("cpqFcaHostCntlrWorldWidePortName", thisFibre.cpqFcaHostCntlrWorldWidePortName);
			
			// World Wide Node
			fibreWWNode = displayItem("cpqFcaHostCntlrWorldWideName", thisFibre.cpqFcaHostCntlrWorldWideName);

			//Option ROM Version
			optionROMVersion = displayItem("cpqFcaHostCntlrOptionRomVersion", thisFibre.cpqFcaHostCntlrOptionRomVersion);
			
			
         	// Storage Systems
         	// mount the array with the storage systems indexes
         	ssIndexArray = new Array();
         	splitOctet = cpqFcaHostCntlrStorBoxList[i];
         	for (var j = 0; j < splitOctet.length; j += 2) {
            	// converts each 2 octets to an integer
            	ssIndex = parseInt(splitOctet[j], 10) + parseInt(splitOctet[j+1] * 0x100, 10);

				if (isNaN(ssIndex)) {
					continue;
				}
				
				// verify if this is not a duplicate
				ssFound = false;
				for (var k = 0; k < ssIndexArray.length; k++) {
					if (ssIndex == ssIndexArray[k]) {
						ssFound = true;
						break;
					}
				}
				// if it is not a duplicate, add it to the array
				if (!ssFound) {
					ssIndexArray.push(ssIndex);
				}
            }

            // get the storage systems names using the array of indexes            
            storageSys = "";
            for (var j = 0; j < ssIndexArray.length; j++) {
            	for (var k = 0; k < cpqSsChassisEntry.length; k++) {
            		thisChassi = cpqSsChassisEntry[k];
            		if (thisChassi.cpqSsChassisIndex != ssIndexArray[j]) {
            			continue;
            		}
            		
            		ssCond = new cpqCondition(thisChassi.cpqSsChassisOverallCondition);
            		if (storageSys != "") {
            			storageSys += ", ";
            		}
            		if (friendly) {
            			storageSys += fcChassisName(k);
            		}
            		else {
            			storageSys += ssCond.image() + " " + makePageLink(fcChassisName(k));
            		}
            	}
            }
            if (storageSys == "") {
            	storageSys = "None";
            }

			// Fibre Tape Controller
         	// mount the array with the fibre tape controller indexes
         	tcIndexArray = new Array();
         	splitOctet = cpqFcaHostCntlrTapeCntlrList[i];
         	for (var j = 0; j < splitOctet.length; j += 2) {
            	// converts each 2 octets to an integer
            	tcIndex = parseInt(splitOctet[j], 10) + parseInt(splitOctet[j+1] * 0x100, 10);

				if (isNaN(tcIndex)) {
					continue;
				}
				
				// verify if this is not a duplicate
				tcFound = false;
				for (var k = 0; k < tcIndexArray.length; k++) {
					if (tcIndex == tcIndexArray[k]) {
						tcFound = true;
						break;
					}
				}
				// if it is not a duplicate, add it to the array
				if (!tcFound) {
					tcIndexArray.push(tcIndex);
				}
            }

            // get the fibre tape controller names using the array of indexes            
            fibreTapeCntlr = "";
            for (var j = 0; j < tcIndexArray.length; j++) {
            	for (var k = 0; k < cpqFcTapeCntlrEntry.length; k++) {
            		thisTapeCntlr = cpqFcTapeCntlrEntry[k];
            		if (thisTapeCntlr.cpqFcTapeCntlrIndex != tcIndexArray[j]) {
            			continue;
            		}

            		tcCond = new cpqCondition(thisTapeCntlr.cpqFcTapeCntlrOverallCondition);
            		if (fibreTapeCntlr != "") {
            			fibreTapeCntlr += ", ";
            		}
            		if (friendly) {
            			fibreTapeCntlr += fcTapeCntlrName(k);
            		}
            		else {
            			fibreTapeCntlr += tcCond.image() + " " + makePageLink(fcTapeCntlrName(k));
            		}
            	}
            }
            if (fibreTapeCntlr == "") {
            	fibreTapeCntlr = "None";
            }

			// show controller information
			sectionStr += tableLabelH3(driveName);		
			sectionStr += ptTblHead(friendly);
			sectionStr += tripleTableRow("Location:", hostControllerSlot(i),
			                             "Status:", fibreStatus,
			                             "Firmware Version:", fibreFirmware);
			sectionStr += tripleTableRow("Serial Number:", fibreSerial,
			                             "World Wide Node:", fibreWWNode,
			                             "World Wide Port:", fibreWWPort);
			sectionStr += tripleTableRow("Storage Systems:", storageSys,
			                             "Option ROM Version:", optionROMVersion,
			                             "", "");                             
// 			                             "Tape Controllers:", fibreTapeCntlr);                             
			sectionStr += tblTail;
		}

		sectionStr += whiteSpaceDivider();
	}
	return sectionStr;
}


function fcaPhysDriveName(idx, isSpareDrive)
{
	var thisPys, sSize;
	var driveName = "";

	if ((idx >= 0) && (idx < cpqFcaPhyDrvEntry.length)) {
		thisPhys = cpqFcaPhyDrvEntry[idx];

		driveName += " Port " + thisPhys.cpqFcaPhyDrvBusNumber +
		            " Drive " + thisPhys.cpqFcaPhyDrvBay;

		sSize = parseInt(thisPhys.cpqFcaPhyDrvSize, 10);
		if (!isNaN(sSize) && (sSize > 0)) {
			driveName += "  " + displayCapacity(thisPhys.cpqFcaPhyDrvSize);
		}

		if (isSpareDrive) {
			rc += " - Spare";
		}
	}
	return driveName;
}


// STORAGE SYSTEMS SECTION ****************************************************
function storageSysSection(friendly)
{
	var sectionStr = "";

	var ssEntries = cpqSsChassisEntry.length;
	
	// variables used in the storage systems loop
	var thisSS, ssModel, ssConnection, ssSerial, ssName, ssCond;
	var ssIOModule, ssIOSlot1, ssIOSlot2, ssPrefPath, slotControllers;
	
	// variables used in the controllers loop
	var thisContr, sContrName, sModel, sStatus, sRole, sFirmware, sRevision;
	var sSerialNum, sRedundMode, sRedundError, sWWPort, sWWNode, sRebuild;
	var sExpand, contrEntries;
	
	// variables used in the controller accelerator loop
	var accelEntries, thisAccel, accelIndex, sBadData, sWriteCache;
	var sBatteryStatus, sReadErrors, sTotalMem, sWriteErrors, sReadCache;
	var sErrorCode;
	
	// variables used in the logical drives loop
	var logEntries, thisLog, sRebuildDrive, sPrefPath, sCurrPath;
	var sRebuildComplete, sRebuildCaption, sStripeSize, sAccel, sCapacity;
	var sFaultTol, sStatus, sLogName, logOsName;
	
	// variables used in the physical drives loop
	var physEntries, thisPhys, sAction, sServiceHours;
	var sDriveType, sSataVersion, sCurrWidth, sCurrSpeed, sRotatSpeed;
	var sPlacement, sPhysName;

	// variables used in the external storages loop
	var externalEntries, thisExt, sVendor, sTemperatureStatus, sFanStatus;
	var sSpeed, sDriveBays, sVersion, sDuplexOptions;
	
	// variables used in the spare drives loop
	var availSpares;
	
	if (ssEntries > 0) {
		contrEntries = cpqFcaCntlrEntry.length;
		accelEntries = cpqFcaAccelEntry.length;
		logEntries = cpqFcaLogDrvEntry.length;
		physEntries = cpqFcaPhyDrvEntry.length;
		externalEntries = cpqSsBackplaneEntry.length;
		
		sectionStr += tableLabel("Storage Systems");

		for (var i = 0; i < ssEntries; i++) {
			thisSS = cpqSsChassisEntry[i];
		
			// Storage System Name			
			if (friendly) {
				ssName = fcChassisName(i);
			}
			else {
				ssCond = new cpqCondition(thisSS.cpqSsChassisOverallCondition);
				ssName = ssCond.image() + " " + makePageAnchor(fcChassisName(i));
			}
				
			// Model
			ssModel = displayItem("cpqSsChassisModel", thisSS.cpqSsChassisModel);
			
			// Connection
			ssConnection = displayItem("cpqSsChassisConnectionType", thisSS.cpqSsChassisConnectionType);

			// IO Slots
			ssIOSlot1 = "Not Installed";
			ssIOSlot2 = "Not Installed";
			for (var j = 0; j < cpqSsIoSlotEntry.length; j++) {
				if (cpqSsIoSlotEntry[j].cpqSsIoSlotChassisIndex == thisSS.cpqSsChassisIndex) {
					// IO Slot 1
					if (cpqSsIoSlotEntry[j].cpqSsIoSlotIndex == "1") {
						if (cpqSsIoSlotEntry[j].cpqSsIoSlotControllerType == "6") {
							ssIOSlot1 = "N/A";
						}
						else {
							ssIOSlot1 = displayItem("cpqSsIoSlotControllerType", cpqSsIoSlotEntry[j].cpqSsIoSlotControllerType);
						}
					}
					// IO Slot 1
					if (cpqSsIoSlotEntry[j].cpqSsIoSlotIndex == "2") {
						if (cpqSsIoSlotEntry[j].cpqSsIoSlotControllerType == "6") {
							ssIOSlot2 = "N/A";
						}
						else {
							ssIOSlot2 = displayItem("cpqSsIoSlotControllerType", cpqSsIoSlotEntry[j].cpqSsIoSlotControllerType);
						}
					}
				}
			}
			
			// IO Module Type, Preferred Path Mode
			ssIOModule = "N/A";
			ssPrefPath = "N/A";
			if (thisSS.cpqSsChassisModel > 2) {
				ssIOModule = displayItem("cpqSsChassisScsiIoModuleType", thisSS.cpqSsChassisScsiIoModuleType);				
				ssPrefPath = displayItem("cpqSsChassisPreferredPathMode", thisSS.cpqSsChassisPreferredPathMode);
			}
			
			// RSO Status
			ssRSOStatus = "N/A";
			if (thisSS.cpqSsChassisModel == 4) {
				ssRSOStatus = displayItem("cpqSsChassisRsoStatus", thisSS.cpqSsChassisRsoStatus);
			}
			
			// Serial Number
			ssSerial = displayItem("cpqSsChassisSerialNumber", thisSS.cpqSsChassisSerialNumber);
			
			// show storage system information
			sectionStr += tableLabelH3(ssName);
			sectionStr += ptTblHead(friendly);
			sectionStr += tripleTableRow("Model:", ssModel,
			                             "Connection:", ssConnection,
			                             "Serial Number:", ssSerial);
			sectionStr += tripleTableRow("IO Slot 1:", ssIOSlot1,
			                             "IO Slot 2:", ssIOSlot2,
			                             "RSO Status:", ssRSOStatus);
			sectionStr += tripleTableRow("IO Module Type:", ssIOModule,
			                             "Preferred Path Mode:", ssPrefPath,
			                             "", "");		
			sectionStr += tblTail;
			
			
			// CONTROLLERS ****************************************************
			for (var j = 0; j < contrEntries; j++) {
				thisContr = cpqFcaCntlrEntry[j];
				// match the controller with the current storage system
				if (thisSS.cpqSsChassisIndex != thisContr.cpqFcaCntlrBoxIndex) {
					continue;
				}
				// Controller Name
				sContrName = displayItem("cpqFcaCntlrModel", thisContr.cpqFcaCntlrModel);
				if (thisContr.cpqFcaCntlrBoxIoSlot != 0) {
					sContrName += " in Slot " + thisContr.cpqFcaCntlrBoxIoSlot;
				}
				if (!friendly) {
					ssCond = new cpqCondition(thisContr.cpqFcaCntlrCondition);
					sContrName = ssCond.image() + " " + sContrName;
				}
				// Model
				sModel = displayItem("cpqFcaCntlrModel", thisContr.cpqFcaCntlrModel);
				// Controller Status
				sStatus = displayItem("cpqFcaCntlrStatus", thisContr.cpqFcaCntlrStatus);
				// Current Role
				sRole = displayItem("cpqFcaCntlrCurrentRole", thisContr.cpqFcaCntlrCurrentRole);
				// Firmware Version
				sFirmware = displayItem("cpqFcaCntlrFWRev", thisContr.cpqFcaCntlrFWRev);
				// Product Revision
				sRevision = displayItem("cpqFcaCntlrProductRev", thisContr.cpqFcaCntlrProductRev);
				// Serial Number
				sSerialNum = displayItem("cpqFcaCntlrSerialNumber", thisContr.cpqFcaCntlrSerialNumber);
				// Redundancy Mode
				sRedundMode = displayItem("cpqFcaCntlrRedundancyType", thisContr.cpqFcaCntlrRedundancyType);
				// Redundancy Error
				sRedundError = displayItem("cpqFcaCntlrRedundancyError", thisContr.cpqFcaCntlrRedundancyError);
				// World Wide Port Name
				sWWPort = displayItem("cpqFcaCntlrWorldWideName", thisContr.cpqFcaCntlrWorldWideName);
				// World Wide Node Name
				sWWNode = displayItem("cpqFcaCntlrWorldWideNodeName", thisContr.cpqFcaCntlrWorldWideNodeName);
				// Rebuild Priority
				sRebuild = displayItem("cpqFcaCntlrRebuildPriority", thisContr.cpqFcaCntlrRebuildPriority);
				// Expand Priority
				sExpand = displayItem("cpqFcaCntlrExpandPriority", thisContr.cpqFcaCntlrExpandPriority);
				// SHOW THE CONTROLLERS
				sectionStr += tableLabel2(sContrName);
				sectionStr += ptTblHead(friendly);
				sectionStr += tripleTableRow("Current Role:", sRole,
				                             "Controller Status:", sStatus,
				                             "Product Revision:", sRevision);
				sectionStr += tripleTableRow("Redundancy Mode:", sRedundMode,
				                             "Redundancy Error:", sRedundError,
				                             "Firmware Version:", sFirmware);
				sectionStr += tripleTableRow("World Wide Port Name:", sWWPort,
				                             "World Wide Node Name:", sWWNode,
				                             "Serial Number:", sSerialNum);
				sectionStr += tripleTableRow("Rebuild Priority:", sRebuild,
				                             "Expand Priority:", sExpand,
				                             "", "");
				sectionStr += tblTail;
				
				// CONTROLLERS ACCELERATORS ***********************************
				// find the index for the current controller's accelerator
				accelIndex = -1;
				for (var k = 0; k < accelEntries; k++) {					
					if ((cpqFcaAccelEntry[k].cpqFcaAccelBoxIndex == thisContr.cpqFcaCntlrBoxIndex) &&
					    (cpqFcaAccelEntry[k].cpqFcaAccelBoxIoSlot == thisContr.cpqFcaCntlrBoxIoSlot)) {
						accelIndex = k;
						break;
					}					
				}
				if (accelIndex < 0) {
					continue;
				}
				thisAccel = cpqFcaAccelEntry[accelIndex];
				// Accelerator Name
				ssName = "Accelerator";
				if (!friendly) {
					ssCond = new cpqCondition(thisAccel.cpqFcaAccelCondition);
					ssName = ssCond.image() + " " + ssName;
				}
				// Status
				sStatus = displayItem("cpqFcaAccelStatus", thisAccel.cpqFcaAccelStatus);
				// Battery Status
				sBatteryStatus = displayItem("cpqFcaAccelBatteryStatus", thisAccel.cpqFcaAccelBatteryStatus);
				// Serial Number
				sSerialNum = displayItem("cpqFcaAccelSerialNumber", thisAccel.cpqFcaAccelSerialNumber);
				// Read Errors
				sReadErrors = displayItem("cpqFcaAccelReadErrs", thisAccel.cpqFcaAccelReadErrs);
				// Total Memory
				sTotalMem = displayCapacity(displayItem("cpqFcaAccelTotalMemory", thisAccel.cpqFcaAccelTotalMemory));
				// Write Errors
				sWriteErrors = displayItem("cpqFcaAccelWriteErrs", thisAccel.cpqFcaAccelWriteErrs);
				// Read Cache
				sReadCache = displayCapacity(displayItem("cpqFcaAccelReadCache", thisAccel.cpqFcaAccelReadCache));
				// Error Code
				sErrorCode = displayItem("cpqFcaAccelErrCode", thisAccel.cpqFcaAccelErrCode);
				// Write Cache
				sWriteCache = displayCapacity(displayItem("cpqFcaAccelWriteCache", thisAccel.cpqFcaAccelWriteCache));
				// Bad Data
				sBadData = displayItem("cpqFcaAccelBadData", thisAccel.cpqFcaAccelBadData);
				// SHOW FIELDS
 				sectionStr += tableLabel6(ssName);
				sectionStr += ptTblHead(friendly);
				sectionStr += tripleTableRow("Status:", sStatus,
				                             "Battery Status:", sBatteryStatus,
				                             "Serial Number:", sSerialNum);
				sectionStr += tripleTableRow("Read Errors:", sReadErrors,
				                             "Total Memory:", sTotalMem,
				                             "Write Errors:", sWriteErrors);
				sectionStr += tripleTableRow("Read Cache:", sReadCache,
				                             "Error Code:", sErrorCode,
				                             "Write Cache:", sWriteCache);
				sectionStr += tripleTableRow("Bad Data:", sBadData,
				                             "", "",
				                             "", "");
				sectionStr += tblTail;
			}
			
			
			// LOGICAL DRIVES *************************************************
			for (j = 0; j < logEntries; j++) {
				thisLog = cpqFcaLogDrvEntry[j];
				// match the logical drive with the current storage system
				if ((thisLog.cpqFcaLogDrvBoxIndex != thisSS.cpqSsChassisIndex) ||
				    ((thisLog.cpqFcaLogDrvSnapshotSourceDrvIndex != "") &&
				     (thisLog.cpqFcaLogDrvSnapshotSourceDrvIndex != "-1"))) {
					continue;
				}
				// OS Disk Name
				logOsName = displayItem("cpqFcaLogDrvOsName", thisLog.cpqFcaLogDrvOsName);
				// Logical Drive Name
				sLogName = "Logical Drive " + thisLog.cpqFcaLogDrvIndex;
				if (thisLog.cpqFcaLogDrvFaultTol == 2) {
					sLogName += " - No Fault Tolerance";
				}
				else if (thisLog.cpqFcaLogDrvFaultTol > 2) {
					sLogName += " - ";
					sLogName += displayItem("cpqFcaLogDrvFaultTol", thisLog.cpqFcaLogDrvFaultTol);
				}
				if (logOsName != "N/A") {
					sLogName += " - ";
					sLogName += logOsName;
				}
				if (!friendly) {
					ssCond = new cpqCondition(thisLog.cpqFcaLogDrvCondition);
					sLogName = ssCond.image() + " " + sLogName;
				}
				
				// Disk Partition
				var str = getDiskPartition(thisLog.cpqFcaLogDrvOsName);
				if (str != "N/A"){
					logOsName += " - " + getDiskPartition(thisLog.cpqFcaLogDrvOsName);
				}
				
				// Status
				sStatus = displayItem("cpqFcaLogDrvStatus", thisLog.cpqFcaLogDrvStatus);
				// Fault Tolerance
				sFaultTol = displayItem("cpqFcaLogDrvFaultTol", thisLog.cpqFcaLogDrvFaultTol);
				// Capacity (MB)
				sCapacity = daDisplayCapacity(displayItem("cpqFcaLogDrvSize", thisLog.cpqFcaLogDrvSize));
				// Accelerator
				sAccel = displayItem("cpqFcaLogDrvHasAccel", thisLog.cpqFcaLogDrvHasAccel);
				// Stripe Size
				sStripeSize = displayItem("cpqFcaLogDrvStripeSize", thisLog.cpqFcaLogDrvStripeSize);
				sStripeSize += " KB";

				// Rebuild/Expand Complete (%)
				if (thisLog.cpqFcaLogDrvStatus == 12) {
					sRebuildCaption = "Expand Complete (%):";
				}
				else {
					sRebuildCaption = "Rebuild Complete (%):";
				}
				if (friendly) {
					sRebuildComplete = displayItem("cpqFcaLogDrvPercentRebuild", thisLog.cpqFcaLogDrvPercentRebuild);
				}
				else {
					sRebuildComplete = percentGraph(thisLog.cpqFcaLogDrvPercentRebuild);
				}
				// Current Path
				sCurrPath = "N/A";
				if (thisLog.cpqFcaLogDrvCurrentPath != -1) {
					sCurrPath = "Controller " + thisLog.cpqFcaLogDrvCurrentPath;
				}
				// Preferred Path
				sPrefPath = "N/A";
				if (thisLog.cpqFcaLogDrvPreferredPath != -1) {
					sPrefPath = "Controller " + thisLog.cpqFcaLogDrvPreferredPath;
				}
				// Rebuilding Drive
				sRebuildDrive = "N/A";
				if (thisLog.cpqFcaLogDrvStatus == 7) {
					for (var k = 0; k < physEntries; k++) {
						if (cpqFcaPhyDrvEntry[k].cpqFcaPhyDrvIndex == thisLog.cpqFcaLogDrvRebuildingPhyDrv) {
							sRebuildDrive = fcaPhysDriveName(k, false);
							break;
						}
					}
				}				
				
				// SHOW THE LOGICAL DRIVES
				sectionStr += tableLabel2(sLogName);
				sectionStr += ptTblHead(friendly);
				sectionStr += tripleTableRow("OS Disk Name:", logOsName,
				                             "Status:", sStatus,
				                             "Fault Tolerance:", sFaultTol);
				sectionStr += tripleTableRow("Capacity:", sCapacity,
				                             "Current Path:", sCurrPath,
				                             "Preferred Path:", sPrefPath);
				sectionStr += tripleTableRow("Rebuilding Drive:", sRebuildDrive,
				                             sRebuildCaption, sRebuildComplete,
				                             "Stripe Size:", sStripeSize);
				sectionStr += tripleTableRow("Accelerator:", sAccel,
				                             "", "",
				                             "", "");
				sectionStr += tblTail;
				
				
				// PHYSICAL DRIVES ********************************************
				for (var k = 0; k < physEntries; k++) {					
					thisPhys = cpqFcaPhyDrvEntry[k];
					// match the physical drives with the current logical drive
					if ((thisPhys.cpqFcaPhyDrvBoxIndex != thisLog.cpqFcaLogDrvBoxIndex) ||
					    !octetFound(thisPhys.cpqFcaPhyDrvIndex, cpqFcaLogDrvPhyDrvIDs[j])) {
						continue;
					}
					
					sectionStr += fibrePhysDrive(k, thisLog, false, friendly);
				}
				
				
				// SPARE DRIVES ***********************************************
				availSpares = cpqFcaLogDrvAvailSpares[j];
				for (var s = 0; s < availSpares.length; s++) {
					// loop through the spare drives
					for (var k = 0; k < cpqFcaPhyDrvEntry.length; k++) {						
						thisPhys = cpqFcaPhyDrvEntry[k];
						// find the corresponding physical drive
						if ((thisPhys.cpqFcaPhyDrvBoxIndex == thisLog.cpqFcaLogDrvBoxIndex) &&
						    (thisPhys.cpqFcaPhyDrvIndex == availSpares[s])) {
						    sectionStr += fibrePhysDrive(k, thisLog, true, friendly);
						    break;
						}
					}
				}			
			}
			
			// EXTERNAL STORAGES **********************************************
			for (var j = 0; j < externalEntries; j++) {
				thisExt = cpqSsBackplaneEntry[j];
				// show only external storages matching the following criteria,
				// according to storages templates
				if (((thisSS.cpqSsChassisConnectionType != 2) &&
				     (thisSS.cpqSsChassisConnectionType != 4)) ||
				     (thisSS.cpqSsChassisModel <= 2)) {
					continue;
				}
				// match the external storages with the current storage system
				if ((thisExt.cpqSsBackplaneChassisIndex != thisSS.cpqSsChassisIndex) ||
				    (thisExt.cpqSsBackplanePlacement != 3)) {
					continue;
				}
				// External Storage Name
				sExtName = displayItem("cpqSsBackplanePlacement", thisExt.cpqSsBackplanePlacement);
				sExtName += " Storage System (" + thisExt.cpqSsBackplaneIndex + ")";
				if (!friendly) {
					ssCond = new cpqCondition(thisExt.cpqSsBackplaneCondition);
					sExtName = ssCond.image() + " " + sExtName;
				}
				// Vendor
				sVendor = displayItem("cpqSsBackplaneVendor", thisExt.cpqSsBackplaneVendor);
				// Temperature Status
				sTemperatureStatus = displayItem("cpqSsBackplaneTempStatus", thisExt.cpqSsBackplaneTempStatus);
				// Model
				sModel = displayItem("cpqSsBackplaneModel", thisExt.cpqSsBackplaneModel);
				// Fan Status
				sFanStatus = displayItem("cpqSsBackplaneFanStatus", thisExt.cpqSsBackplaneFanStatus);
				// Serial Number
				sSerialNum = displayItem("cpqSsBackplaneSerialNumber", thisExt.cpqSsBackplaneSerialNumber);
				// Power Supply Status
				sPowerStatus = displayItem("cpqSsBackplaneFtpsStatus", thisExt.cpqSsBackplaneFtpsStatus);
				// Firmware Revision
				sFirmware = displayItem("cpqSsBackplaneFWRev", thisExt.cpqSsBackplaneFWRev);
				// Speed
				sSpeed = displayItem("cpqSsBackplaneSpeed", thisExt.cpqSsBackplaneSpeed);
				// Board Revision
				sRevision = displayItem("cpqSsBackplaneBoardRevision", thisExt.cpqSsBackplaneBoardRevision);
				// Drive Bays
				sDriveBays = displayItem("cpqSsBackplaneDriveBays", thisExt.cpqSsBackplaneDriveBays);
				// Version
				sVersion = displayItem("cpqSsBackplaneVersion", thisExt.cpqSsBackplaneVersion);
				// Duplex Options
				sDuplexOptions = displayItem("cpqSsBackplaneDuplexOption", thisExt.cpqSsBackplaneDuplexOption);
				// Placement
				sPlacement = displayItem("cpqSsBackplanePlacement", thisExt.cpqSsBackplanePlacement);
				// SHOW THE EXTERNAL STORAGE
				sectionStr += tableLabel2(sExtName);
				sectionStr += ptTblHead(friendly);
				sectionStr += tripleTableRow("Vendor:", sVendor,
				                             "Temperature Status:", sTemperatureStatus,
				                             "Model:", sModel);
				sectionStr += tripleTableRow("Fan Status:", sFanStatus,
				                             "Serial Number:", sSerialNum,
				                             "Power Supply Status:", sPowerStatus);
				sectionStr += tripleTableRow("Firmware Revision:", sFirmware,
				                             "Speed:", sSpeed,
				                             "Board Revision:", sRevision);
				sectionStr += tripleTableRow("Drive Bays", sDriveBays,
				                             "Version:", sVersion,
				                             "Duplex Option:", sDuplexOptions);
				sectionStr += tripleTableRow("Placement:", sPlacement,
				                             "", "",
				                             "", "");
				sectionStr += tblTail;
			}
			
			
			// UNCONFIGURED DRIVES ********************************************
			var unconfigDrives = 0;
			for (var k = 0; k < cpqFcaPhyDrvEntry.length; k++) {
				if (thisSS.cpqSsChassisIndex != cpqFcaPhyDrvEntry[k].cpqFcaPhyDrvBoxIndex) {
					continue;
				}
				if (cpqFcaPhyDrvEntry[k].cpqFcaPhyDrvStatus == "2") {
					unconfigDrives++;
				}
			}
			
			if (unconfigDrives > 0) {
				if (unconfigDrives == 1) {
					sectionStr += ptTblHead(friendly);
					sectionStr += sectionFootnote("There is 1 unconfigured physical drive in this storage system.");
					sectionStr += tblTail;
				}
				else {
					sectionStr += sectionFootnote("There are " + unconfigDrives + " unconfigured physical drives in this storage system.");
				}
			}
		}
		sectionStr += tblTail;		
		sectionStr += whiteSpaceDivider();
	}
	
	return sectionStr;
}



// SCSI CONTROLLERS SECTION ***************************************************
function scsiControllersSection(friendly)
{
	var sectionStr = "";
	
	var scsiEntries = cpqScsiCntlrEntry.length;
	
	if (scsiEntries > 0) {
		var physEntries = cpqScsiPhyDrvEntry.length;
	
		sectionStr += tableLabel("SCSI Controllers (Other than SCSI LSI 1010/U160)");
	
		// variables used in the controllers loop (i)
		var thisScsi, modelName, scsiStatus, scsiFirmware, scsiSerial, scsiLocation, driveName, driveCond;

		// variables used in the physical drives loop (j)
		var thisPhys;
		var physName, physStatus, physSize, physModel, physFirmware, physSerial, physPlacement, physOSName;
		
		for (var i = 0; i < scsiEntries; i++) {
			thisScsi = cpqScsiCntlrEntry[i];
			
			// Controller Name
			if (thisScsi.cpqScsiCntlrModel == 9) {
				modelName = displayItem("cpqScsiCntlrModelExtended", thisScsi.cpqScsiCntlrModelExtended);
			}
			else {
				modelName = displayItem("cpqScsiCntlrModel", thisScsi.cpqScsiCntlrModel);
			}
			driveName = "SCSI Controller " + (i+1) + " - " + modelName;
			if (!friendly) {
				driveCond = new cpqCondition(thisScsi.cpqScsiCntlrStatus);
				if (thisScsi.cpqScsiCntlrStatus == 3) {
					driveCond.set(4);
   				}
   				driveName = driveCond.image() + " " + driveName;
			}
							
			// Status
			scsiStatus = displayItem("cpqScsiCntlrStatus", thisScsi.cpqScsiCntlrStatus);
			// Firmware Version
			scsiFirmware = displayItem("cpqScsiCntlrFWVers", thisScsi.cpqScsiCntlrFWVers);
			// Serial Number
            scsiSerial = displayItem("cpqScsiCntlrSerialNum", thisScsi.cpqScsiCntlrSerialNum);
            // Location
            scsiLocation = displayItem("cpqScsiCntlrHwLocation", thisScsi.cpqScsiCntlrHwLocation);
			// show controller information
			sectionStr += tableLabelH3(driveName);			
			sectionStr += ptTblHead(friendly);
			sectionStr += tripleTableRow("Location:", scsiLocation,
			                             "Status:", scsiStatus,
			                             "Firmware Version:", scsiFirmware);
			sectionStr += tripleTableRow("Serial Number:", scsiSerial,
			                             "", "",
			                             "", "");			
			sectionStr += tblTail;

			// PHYSICAL DRIVES ************************************************
			for (var j = 0; j < physEntries; j++) {
				thisPhys = cpqScsiPhyDrvEntry[j];
				// match the physical drives with the current controller
				if ((thisPhys.cpqScsiPhyDrvCntlrIndex != thisScsi.cpqScsiCntlrIndex) ||
				    (thisPhys.cpqScsiPhyDrvBusIndex != thisScsi.cpqScsiCntlrBusIndex)) {
					continue;
				}
				// Physical Drive Name
				physOSName = displayItem("cpqScsiPhyDrvOsName", thisPhys.cpqScsiPhyDrvOsName);
				driveName = "Physical Drive " + (j+1) + " - " + physOSName;
				if (!friendly) {
					driveCond = new cpqCondition(thisPhys.cpqScsiPhyDrvCondition);
					driveName = driveCond.image() + " " + driveName;
				}
								
				physName = "Port " + thisPhys.cpqScsiPhyDrvBusIndex +
				               " - SCSI ID " + thisPhys.cpqScsiPhyDrvIndex;
				physStatus = displayItem("cpqScsiPhyDrvStatus", thisPhys.cpqScsiPhyDrvStatus);
				
				// Capacity
				physSize = parseInt(thisPhys.cpqScsiPhyDrvSize, 10);				
				if (isNaN(physSize) || physSize <= 0) {
					physSize = "N/A";
				}
				else {
					physSize = daDisplayCapacity(displayItem("cpqScsiPhyDrvSize", thisPhys.cpqScsiPhyDrvSize));
				}
				
				// Model
				physModel = displayItem("cpqScsiPhyDrvModel", thisPhys.cpqScsiPhyDrvModel);
				
				// Firmware Version
				physFirmware = displayItem("cpqScsiPhyDrvFWRev", thisPhys.cpqScsiPhyDrvFWRev);
				
				// Serial Number
				physSerial = displayItem("cpqScsiPhyDrvSerialNum", thisPhys.cpqScsiPhyDrvSerialNum);
				
				// Placement
				physPlacement = displayItem("cpqScsiPhyDrvPlacement", thisPhys.cpqScsiPhyDrvPlacement);
				
				// show physical drive information
				sectionStr += tableLabel3(driveName);
				sectionStr += ptTblHead(friendly);
				sectionStr += tripleTableRow("Name:", physName,
				                             "Status:", physStatus,
				                             "Capacity:", physSize);								  
				sectionStr += tripleTableRow("Placement:", physPlacement,
				                             "Firmware Version:", physFirmware,
				                             "Serial Number:", physSerial);
				sectionStr += tripleTableRow("Model:", physModel,
				                             "", "",
				                             "", "");
				sectionStr += tblTail;
			}
		}
		sectionStr += whiteSpaceDivider();
	}	
	return sectionStr;
}


function fanGroupsSection(friendly)
{
	if (cpqHeFltTolFanEntry.length <= 0) {
		return getEmptySectionTable("Fault Tolerant Fan Groups")
	}

	// group fans according to cpqHeFltTolFanRedundantPartner
	var fanGroup = new Array();
	var thisFan, currGroup, currFan, groupFound, newGroup;
	for(var i = 0; i < cpqHeFltTolFanEntry.length; i++)
	{
		thisFan = cpqHeFltTolFanEntry[i];
		currGroup = thisFan.cpqHeFltTolFanRedundantPartner;
		currFan = thisFan.cpqHeFltTolFanIndex;
		// verify if the current group was already added to
		// fanGroup vector
		groupFound = false;
		for (var j = 0; j < fanGroup.length; j++) {
			if (fanGroup[j].groupNumber == currGroup) {
				groupFound = true;
				fanGroup[j].fan.push(thisFan);
				break;
			}
		}
		// if the group isn't in the vector, add the new group
		// with the current fan
		if (!groupFound) {
			newGroup = new Object;
			newGroup.groupNumber = currGroup;
			newGroup.fan = new Array;
			newGroup.fan.push(thisFan);
			fanGroup.push(newGroup);
		}
	}

	// Print the fan groups
	if (!isPartitionedSystem()) {
		columns = new Array("Fan", "Location", "Type", "Present",
							"Hot Pluggable", "Current Speed", "Speed");
	}
	else {
		columns = new Array("Fan", "Location", "Type", "Present",
							"Hot Pluggable", "Speed");
	}
	var sectionStr = tableLabel("Fault Tolerant Fan Groups");
	sectionStr += ptTblHead(friendly);

	firstGroupPrinted = false;
	var groupHeader, groupRedundancy;

	for(var i = 0; i < fanGroup.length; i++)
	{
		if (typeof(fanGroup[i]) == "undefined")
		{
			continue;
		}

		currGroup = fanGroup[i];

		// print line separating groups
		if (firstGroupPrinted)
		{
			sectionStr += "\n<tr><td colspan=7><hr noshade size=1/></td></tr>";
		}
		firstGroupPrinted = true;

		// compose group header with redundancy info and columns names
		groupHeader = "";

		currGroupRedundancy = fanGroupRedundancy(currGroup.fan);

		if (currGroupRedundancy == 3) {
			if (friendly) {
				groupHeader = oneItemTableRowInDoubleTable("<b>Group Redundancy:</b> Redundant");
			}
			else {
				groupHeader = oneItemTableRowInDoubleTable("<img src='images/ok.gif' width=14 height=14> <b>Group Redundancy:</b> Redundant");
			}
		}
		else if (currGroupRedundancy == 2) {
			if (friendly) {
				groupHeader = oneItemTableRowInDoubleTable("<b>Group Redundancy:</b> Not Redundant");
			}
			else {
				groupHeader = oneItemTableRowInDoubleTable("<img src='images/degraded.gif' width=14 height=14> <b>Group Redundancy:</b> Not Redundant");
			}
		}
		else {
			groupHeader = oneItemTableRowInDoubleTable("<b>Group Redundancy:</b> N/A");
		}
		groupHeader += simpleTableRow( columns, columns.length, "B" );

		if (currGroup.groupNumber != 0) {
			sectionStr += groupHeader;
		}

		for (var j = 0; j < currGroup.fan.length; j++) {
			// fans in group 0 are singletons, so they must be displayed
			// in separate groups (one group header for each fan)
			if (currGroup.groupNumber == 0) {
				sectionStr += groupHeader;
			}

			thisFan = currGroup.fan[j];

			if (friendly) {
				fanIndexStr = thisFan.cpqHeFltTolFanIndex;
			}
			else {
				fanStatus = new cpqCondition(thisFan.cpqHeFltTolFanCondition);
				fanIndexStr = fanStatus.image() + " " + thisFan.cpqHeFltTolFanIndex;
			}

			if (!isPartitionedSystem()) {
				fanCurSpeed  = thisFan.cpqHeFltTolFanCurrentSpeed;
				if(fanCurSpeed == "0") {
					fanCurSpeed = "N/A";
				}
				else {
					fanCurSpeed += " RPM";
				}
				dataRow = new Array(fanIndexStr,
									displayItem("cpqHeFltTolFanHwLocation", thisFan.cpqHeFltTolFanHwLocation),
									displayItem("cpqHeFltTolFanType", thisFan.cpqHeFltTolFanType),
									displayItem("cpqHeFltTolFanPresent", thisFan.cpqHeFltTolFanPresent),
									displayItem("cpqHeFltTolFanHotPlug", thisFan.cpqHeFltTolFanHotPlug),
									displayItem("cpqHeFltTolFanCurrentSpeed", fanCurSpeed),
									displayItem("cpqHeFltTolFanSpeed", thisFan.cpqHeFltTolFanSpeed));
			}
			else {
				dataRow = new Array(fanIndexStr,
									displayItem("cpqHeFltTolFanHwLocation", thisFan.cpqHeFltTolFanHwLocation),
									displayItem("cpqHeFltTolFanType",thisFan.cpqHeFltTolFanType),
									displayItem("cpqHeFltTolFanPresent", thisFan.cpqHeFltTolFanPresent),
									displayItem("cpqHeFltTolFanHotPlug", thisFan.cpqHeFltTolFanHotPlug),
									displayItem("cpqHeFltTolFanSpeed", thisFan.cpqHeFltTolFanSpeed));
			}
			sectionStr += simpleTableRow(dataRow, dataRow.length);
		}
	}
	sectionStr += tblTail;
	sectionStr += whiteSpaceDivider();
	
	return sectionStr;
}


function fansSection(friendly)
{
	if (cpqHeFltTolFanEntry.length > 0) {
		return "";
	}
	
	var fanEntries = cpqHeThermalFanEntry.length;
	if (fanEntries <= 0) {
		return getEmptySectionTable("Fans");
	}
	
	var sectionStr = tableLabel("Fans");
	sectionStr += ptTblHead(friendly);
	var columns = new Array("Index", "Type", "Status");
	sectionStr += simpleTableRow( columns, columns.length, "B" );

	var thisFan, dataRow;
	for (var i = 0; i < fanEntries; i++) {
		thisFan = cpqHeThermalFanEntry[i];
		if ((thisFan.cpqHeThermalFanPresent != 2) && (thisFan.cpqHeThermalFanRequired != 2)) {
			dataRow = new Array(displayItem("cpqHeThermalFanIndex", thisFan.cpqHeThermalFanIndex),
			                    displayItem("cpqHeThermalFanCpuFan", thisFan.cpqHeThermalFanCpuFan),
			                    displayItem("cpqHeThermalFanStatus", thisFan.cpqHeThermalFanStatus));
			sectionStr += simpleTableRow( dataRow, dataRow.length );
		}
	}

	sectionStr += tblTail;

	sectionStr += whiteSpaceDivider();
	
	return sectionStr;
}


function redundPowerSupplySection()
{
	if (cpqHeFltTolPowerSupplyEntry.length > 0) {
		return "";
	}
	
	var sectionStr = tableLabel("Redundant Power Supply");
	sectionStr += ptTblHead();
	sectionStr += singleTableRow("Installed:", displayItem("cpqHeFltTolPwrSupplyStatus", cpqHeFltTolPwrSupplyStatus));
	sectionStr += singleTableRow("Status:", displayItem("cpqHeFltTolPwrSupplyCondition", cpqHeFltTolPwrSupplyCondition));
	if ((cpqHeFltTolPwrSupplyStatus != 4) || (cpqHeFltTolPwrSupplyCondition != 2)) {
		sectionStr += singleTableRow("Operation:", "N/A");
	}
	else {
		sectionStr += singleTableRow("Operation:", "Fault Tolerant");
	}	
	sectionStr += tblTail;
	sectionStr += whiteSpaceDivider();
	
	return sectionStr;
}

function enclosurePowerSupplySection(friendly) {
	var sectionStr = tableLabel("Enclosure Power Supplies");
	sectionStr += ptTblHead(friendly);

	var thisEnc = cpqSiRackEnclosureMgrEntry[0];
	var encOALink = "N/A";
	var encWebLink = displayItem("cpqSiRackEnclosureMgrWebLink", thisEnc.cpqSiRackEnclosureMgrWebLink);

	if (encWebLink != "N/A") {
		if (friendly) {
			encOALink = thisEnc.cpqSiRackEnclosureMgrWebLink;
		}
		else {
			encOALink = "<a target=new href=" +
				    thisEnc.cpqSiRackEnclosureMgrWebLink +
				    ">" +
				    thisEnc.cpqSiRackEnclosureMgrWebLink +
				    "</a>";
		}
	}
	dataRow = new Array("For details go to " + displayItem("encOALink", encOALink) + " and navigate to enclosure power supply section.");
	sectionStr += simpleTableRow( dataRow, dataRow.length );

	sectionStr += tblTail;
	sectionStr += whiteSpaceDivider();

	return sectionStr;
}

function enclosureFansSection(friendly) {
	var sectionStr = tableLabel("Enclosure Fans");
	sectionStr += ptTblHead(friendly);

	var thisEnc = cpqSiRackEnclosureMgrEntry[0];
	var encOALink = "N/A";
	var encWebLink = displayItem("cpqSiRackEnclosureMgrWebLink", thisEnc.cpqSiRackEnclosureMgrWebLink);

	if (encWebLink != "N/A") {
		if (friendly) {
			encOALink = thisEnc.cpqSiRackEnclosureMgrWebLink;
		}
		else {
			encOALink = "<a target=new href=" +
				    thisEnc.cpqSiRackEnclosureMgrWebLink +
				    ">" +
				    thisEnc.cpqSiRackEnclosureMgrWebLink +
				    "</a>";
		}
	}

	dataRow = new Array("For details go to " + encOALink + " and navigate to enclosure fans section.");
	sectionStr += simpleTableRow( dataRow, dataRow.length );

	sectionStr += tblTail;
	sectionStr += whiteSpaceDivider();

	return sectionStr;
}



//*************** Partition Information
function partitionInfoSection(friendly, showIcon)
{
	if (!isPartitionedSystem()) {
		return "";
	}

	var partName = "";
	if (showIcon) {
	    var partitionInfo = new cpqCondition();
	    partitionInfo.update(getPartitionInfoStatus());
	    partName = partitionInfo.image();
	}
	partName += "Partition Information";

	var sectionStr = tableLabel(partName);
	sectionStr += ptTblHead(friendly);
	
	// Total Number of Active CPUs
	var totalCpu = "Unknown";
	if (cpqSePartitionTotalCPU != 0) {
		totalCpu = displayItem("cpqSePartitionTotalCPU", cpqSePartitionTotalCPU);
	}	
	sectionStr += singleTableRow("Total Number of Active CPUs:", totalCpu);
	
	// Number of Available Cell Slots
	var cellSlots = displayItem("cpqSePartitionAvailableCellSlots", cpqSePartitionAvailableCellSlots);
	sectionStr += singleTableRow("Number of Available Cell Slots:", cellSlots);
	
	// Number of Installed Cells
	var installedCells = "Unknown";
	if (cpqSePartitionInstalledCells != 0) {
		installedCells = displayItem("cpqSePartitionInstalledCells", cpqSePartitionInstalledCells);
	}
	sectionStr += singleTableRow("Number of Installed Cells:", installedCells);
	
	// Number of Powered On Cells
	var poweredOnCells = "Unknown";
	if (cpqSePartitionPoweredOnCells != 0) {
		poweredOnCells = displayItem("cpqSePartitionPoweredOnCells", cpqSePartitionPoweredOnCells);
	}
	sectionStr += singleTableRow("Number of Powered On Cells:", poweredOnCells);
	
	// Number of Ready for Reconfigure Cells
	var reconfigCells = displayItem("cpqSePartitionReadyForReconfigCells", cpqSePartitionReadyForReconfigCells);
	sectionStr += singleTableRow("Number of Ready for Reconfigure Cells:", reconfigCells);

	// Partition Name
	var partitionName = displayItem("cpqSePartitionName", cpqSePartitionName);
	sectionStr += singleTableRow("Partition Name:", partitionName);
	
	// Root Cell Number
	var coreCell = displayItem("cpqSePartitionCoreCell", cpqSePartitionCoreCell);
	var coreCabinet = displayItem("cpqSePartitionCoreCellCabinet", cpqSePartitionCoreCellCabinet);
	var rootCellNum = "N/A";
	if ((coreCell != "N/A") && (coreCabinet != "N/A")) {
		rootCellNum = "cell " + coreCell + " in cabinet " + coreCabinet;
	}
	sectionStr += singleTableRow("Root Cell Number:", rootCellNum);
	
	// Total Partition Memory
	var totalMemMB = displayItem("cpqSeTotalMemMB", cpqSeTotalMemMB);
	if (totalMemMB != "N/A") {
		totalMemMB = displayCapacity(totalMemMB);
	}
	sectionStr += singleTableRow("Total Partition Memory:", totalMemMB);

	sectionStr += tblTail;
	sectionStr += whiteSpaceDivider();

	return sectionStr;
}  
//*************** End of partition Info

//*************** Complex Cells
function complex_cells(friendly){
	if (!isPartitionedSystem() || (cpqSeComplexCellSlotStatusEntry.length <= 0)) {
		return "";
	}
	
	// Feature 170
	var sectionStr = tableLabel("Complex Cells");
	sectionStr += ptTblHead(friendly);

	var ShowComplexCellSlotHeader = true;
	var rcPartitionTable = "";
	for(var cellslot = 0; cellslot < cpqSeComplexCellSlotStatusEntry.length ; cellslot++)
	{
		highlightBegin = "";
		highlightEnd = "";

		if (ShowComplexCellSlotHeader)
		{
			rcPartitionTable += "<TABLE style={font-family:\"Arial\"} border=1 cellspacing=0 cellpadding=3>";

			rcPartitionTable += "<TR>";
			rcPartitionTable += "<TD align=center rowspan='2'><small><b>Cabinet No.</b></small></TD>";
			rcPartitionTable += "<TD align=center rowspan='2'><small><b>Cell Slot No.</b></small></TD>";
			rcPartitionTable += "<TD align=center rowspan='2'><small><b>Status</b></small></TD>";
			rcPartitionTable += "<TD align=center colspan='2'><small><b>Assigned To<b></small></TD>";
			rcPartitionTable += "</TR>";
			rcPartitionTable += "<TR>";
			rcPartitionTable += "<TD align=center ><small><b>Partition No.</b></small></TD>";
			rcPartitionTable += "<TD align=center ><small><b>Partition Name</b></small></TD>";
			rcPartitionTable += "</TR>";
			ShowComplexCellSlotHeader = false;
		}
		if(cpqSeComplexCellSlotStatusEntry[cellslot].cpqSeComplexCellSlotPartitionNo == cpqSePartitionNumber)
		{
			highlightBegin = "<b>";
			highlightEnd = "</b>";
		}
		rcPartitionTable += "<TR>";
		rcPartitionTable += "<TD align=center ><small>"+ highlightBegin + cpqSeComplexCellSlotStatusEntry[cellslot].cpqSeComplexCellSlotStatusCabinetNo+ highlightEnd + "</small></TD>";
		rcPartitionTable += "<TD align=center ><small>"+ highlightBegin + cpqSeComplexCellSlotStatusEntry[cellslot].cpqSeComplexCellSlotStatusSlotNo+ highlightEnd + "</small></TD>";
		CellSlotStatus = displayItem( "cpqSeComplexCellSlotStatus", cpqSeComplexCellSlotStatusEntry[cellslot].cpqSeComplexCellSlotStatus );
		rcPartitionTable += "<TD align=center ><small>"+ highlightBegin + CellSlotStatus+ highlightEnd + "</small></TD>";
		
		CellPartitionNo = displayItem( "cpqSeComplexCellSlotPartitionNo", cpqSeComplexCellSlotStatusEntry[cellslot].cpqSeComplexCellSlotPartitionNo );
		rcPartitionTable += "<TD align=center ><small>"+ highlightBegin + CellPartitionNo + highlightEnd + "</small></TD>";

		rcPartitionTable += "<TD align=center ><small>"+ highlightBegin + cpqSeComplexCellSlotStatusEntry[cellslot].cpqSeComplexCellSlotPartitionName+ highlightEnd + "</small></TD>";
		rcPartitionTable += "</TR>";
	}

	if (!ShowComplexCellSlotHeader)
	{
		rcPartitionTable += "</TABLE>";
		sectionStr += tblTail;
		sectionStr += ptTblHead(friendly);
		sectionStr += centerDataRow( "" );
		sectionStr += centerDataRow( rcPartitionTable );
		sectionStr += centerDataRow( "" );
		sectionStr += tblTail;
		sectionStr += whiteSpaceDivider();
	}
	return sectionStr;
}
//*************** End of Complex Cells

//*************** Cell Board Information
function cellBoardInformation(indx, friendly)
{
	  if (!isPartitionedSystem()) {
		return "";
	  }

	  var sectionStr = "";

	  label = "Cell Board Information";
	   
	 
    	  var cellBoardStatus = new cpqCondition();
	  var cellCLMCondition = new cpqCondition();
    	  for(var i=0; i < cpqSeCellEntry.length; i++){
		if ((indx == -1) || (indx == i) ){
			cellCLMCondition.update(cpqSeCellEntry[i].cpqSeCellCLMCondition);
			cellBoardStatus.update(cellCLMCondition.state);

			if( typeof(cpqSeCellEntry[i].cpqSeCellCLMCondition) != "undefined" ) {
				cellBoardStatus.update(cpqSeCellEntry[i].cpqSeCellCLMCondition);
			}
		}
	  }
	  if (!friendly) {
		label = cellBoardStatus.image() + label;
	  }
         
	  sectionStr += tableLabel(label);
	  sectionStr += ptTblHead(friendly);

	  sectionStr += tripleTableRow(	"Product Name:", displayItem("cpqSiProductName", cpqSiProductName), 
					"Redundant ROM Version:", displayItem("cpqSeRedundantSysRomVer", cpqSeRedundantSysRomVer), 
					"Minutes in Service:", displayItem("cpqHeSysUtilLifeTime", cpqHeSysUtilLifeTime));

	  sectionStr += tripleTableRow(	"Board Revision Level:", displayItem("cpqSiBoardRevCur", cpqSiBoardRevCur[0]), 
					"", "", 
					"", ""); 


	var cellBoardStatus = "";
	var cellCLMCondition = "";
	for(var i=0; i < cpqSeCellEntry.length; i++)
	{
		if ((indx == -1) || (indx == i) ){
			cellBoardStatus = new cpqCondition();
			cellCLMCondition = new cpqCondition();
			cellCLMCondition.update(cpqSeCellEntry[i].cpqSeCellCLMCondition);
			cellBoardStatus.update(cellCLMCondition.state);

			if( typeof(cpqSeCellEntry[i].cpqSeCellCLMCondition) != "undefined" ) {
				cellBoardStatus.update(cpqSeCellEntry[i].cpqSeCellCLMCondition);
			}

			cellname = "Cabinet " + cpqSeCellEntry[i].cpqSeCellCabinetNumber + ", Cell " + cpqSeCellEntry[i].cpqSeCellCellNumber;
			if (!friendly) {
				cellname = cellBoardStatus.image() + cellname;
			}

			sectionStr += tableLabelH3(cellname);
			sectionStr += ptTblHead(friendly);

			// Line 1
			if(cpqSeCellEntry[i].cpqSeCellIOCTablePtr == -1)
			{
				ioboard = "No IOC Board";
			}
			else

			{
				cabNum = parseInt(cpqSeIOCEntry[cpqSeCellEntry[i].cpqSeCellIOCTablePtr].cpqSeIOCCabinetNumber);
				if (cabNum == 255) cabNum = "unknown";
				ioboard = "cab: " + cabNum + ", bay: " +
				      cpqSeIOCEntry[cpqSeCellEntry[i].cpqSeCellIOCTablePtr].cpqSeIOCBayNumber +
				      ", chassis: " + cpqSeIOCEntry[cpqSeCellEntry[i].cpqSeCellIOCTablePtr].cpqSeIOCIOCNumber;
			}

			// Line 2
			cableStatus = "";
			if( 0x40 & cpqSeCellEntry[i].cpqSeCellToScanBusConnectionStatus)
			{
				cableStatus = "Cables Swapped - "+ cableStatus;
			}
			if( 0x20 & cpqSeCellEntry[i].cpqSeCellToScanBusConnectionStatus)
			{
				cableStatus = "Cables Id Mismatched - " + cableStatus;
			}
			if( 0x10 & cpqSeCellEntry[i].cpqSeCellToScanBusConnectionStatus)
			{
				cableStatus = "Output Parity Error - " + cableStatus;
			}
			if( 0x08 & cpqSeCellEntry[i].cpqSeCellToScanBusConnectionStatus)
			{
				cableStatus = "Output Cable Detached - " + cableStatus;
			}
			if( 0x04 & cpqSeCellEntry[i].cpqSeCellToScanBusConnectionStatus)
			{
				cableStatus = "Input Parity Error - " + cableStatus;
			}
			if( 0x02 & cpqSeCellEntry[i].cpqSeCellToScanBusConnectionStatus)
			{
				cableStatus = "Input Cable Detached - " + cableStatus;
			}
			if( 0x01 & cpqSeCellEntry[i].cpqSeCellToScanBusConnectionStatus)
			{
				cableStatus =  cableStatus + "Connection Valid";
			}
			// The FW team confirms when bit 0=0 but bits 1 & 3 are set, it doesn't indicate an error.
			else if( 0x0A == cpqSeCellEntry[i].cpqSeCellToScanBusConnectionStatus)
			{
				cableStatus =  "No Cable";
			}
			else
			{
				cableStatus = cableStatus + "Error";
			}

			// Line 3
			var numCPUs = 0;
			for (x=0; x<=cpqSeCpuEntry.length-1; x++)
			{
				if ((i == cpqSeCpuEntry[x].cpqSeCpuCellTablePtr) && (cpqSeCpuEntry[x].cpqSeCpuStatus != 0) )
				{
					numCPUs++;
				}
			}

			// Line 4

			// Line 5 and 6
			var cLMSettings = "";
			if (cpqSeCellEntry[i].cpqSeCellCLMCondition == 2)
			{
				cLMSettings = "Optimal";
			}
			else
			{
				cLMSettings = "Not Optimal";
			}
			if (!friendly) {
				cLMSettings = cellCLMCondition.image() + cLMSettings;
			}
			var leds = ledDecoding(cpqSeCellEntry[i].cpqSeCellLEDState);

			// create array values
			var columns = new Array( 
					"Cell Serial Number:", displayItem("cpqSeCellSerialNumber", cpqSeCellEntry[i].cpqSeCellSerialNumber), 
					"IOC Board:", ioboard, 
					"Firmware Version:", displayItem("cpqSeCellSysFwVersion", cpqSeCellEntry[i].cpqSeCellSysFwVersion),
					"Boot Inhibited:", displayItem("cpqSeCellBootInhibited", cpqSeCellEntry[i].cpqSeCellBootInhibited), 
					"RIO Cable Status:", cableStatus, 
					"Core IO:", displayItem("cpqSeCellHasCoreIO", cpqSeCellEntry[i].cpqSeCellHasCoreIO),
					"Power:", displayItem("cpqSeCellHasPower", cpqSeCellEntry[i].cpqSeCellHasPower), 
					"Ready For Reconfigure:", displayItem("cpqSeCellReadyForReconfig",cpqSeCellEntry[i].cpqSeCellReadyForReconfig), 
					"Number of CPUs in Cell:", numCPUs,
					"Total Cell Memory:", daDisplayCapacity(cpqSeCellEntry[i].cpqSeCellTotalMemory/1024), 
					"Interleave Memory Allocated Size:", daDisplayCapacity(cpqSeCellEntry[i].cpqSeCellInterleaveAllocatedSize/1024));
			
			
			// Dont show CLM in single-cell partitions
			if (cpqSeCellEntry.length > 1) {
			
				// Create CLM fields array
				var array2 = new Array(
						"CLM Allocated Size:", daDisplayCapacity(cpqSeCellEntry[i].cpqSeCellCLMAllocatedSize/1024),
						"CLM Requested Percentage:", cpqSeCellEntry[i].cpqSeCellCLMRequestPercentage + "%", 
						"CLM Settings:", cLMSettings);
				
				// Add array2 to colluns array
				for (var l=0; l < array2.length; l++){
					columns.splice((columns.length + l),0,array2[l]);
				}
			}
			
			// Add leds information
			for (var l=0; l < leds.length; l++){
				columns.splice((columns.length + l),0,leds[l]);
			}
			
			// create a dynamic table
			sectionStr += tableRow(3, columns);
		}

	}
	sectionStr += tblTail;
        sectionStr += whiteSpaceDivider();
	return sectionStr;

}
//************ End of Cell Board Information

//************ Cluster Information
function clusterInformation (friendly)
{
	var clusterInfoStr = "";
	if( !cpqClusterNodeEntry.length ){
	
	    return clusterInfoStr;
	} 
	
	var clusterName = displayItem("cpqClusterName", cpqClusterName);
	
	var cond = new cpqCondition( cpqClusterMibCondition );
	
	if (!friendly) clusterName = cond.image() + clusterName;
		

	clusterInfoStr += tableLabel("Cluster Information");
	clusterInfoStr += ptTblHead(friendly);
	
	var csdVersion = "";
	if (cpqClusterCSDVersion == "") {
		csdVersion = "none";
	}
	else {
		csdVersion = displayItem("cpqClusterCSDVersion", cpqClusterCSDVersion);
	}   
	var columns = new Array("Cluster Name:", clusterName,
				"IP Address:", displayItem("cpqClusterIpAddress", cpqClusterIpAddress),
				"SW Version:", cpqClusterMajorVersion + "." + cpqClusterMinorVersion,
				"SW Vendor:", displayItem("cpqClusterVendorId", cpqClusterVendorId),
				"CSD Version:", csdVersion);
	clusterInfoStr += tableRow(2, columns);
		
	clusterInfoStr += tblTail;
	clusterInfoStr += whiteSpaceDivider();
	
	return clusterInfoStr;
}	
//************ End of Cluster Information

  	 //************ Firmware Version
function firmwareVersion()
{
	var firmwareVersionStr = "";
	if (!isPartitionedSystem() && !isHPVM()) {
		if (cpqSiFirmwareRevTable.length <= 0)
		{
			return getEmptySectionTable("Firmware Versions");
		}
		else
		{
			var thisVersion;
			var columns;
			var columnsInternal;
			
			firmwareVersionStr += tableLabel("Firmware Versions");			
			firmwareVersionStr += ptTblHead();
			
			columns = new Array("Index", "Description", "Revision", "Location", "Status");
			firmwareVersionStr += simpleTableRow( columns, columns.length, "B" );
			
			
			for(i=0; i< cpqSiFirmwareRevTable.length; i++)
			{
				thisVersion = cpqSiFirmwareRevTable[i];
				columnsInternal = new Array(displayItem("cpqSiFirmwareRevIndex", thisVersion.cpqSiFirmwareRevIndex),
							displayItem("cpqSiFirmwareRevDesc", thisVersion.cpqSiFirmwareRevDesc),
							displayItem("cpqSiFirmwareRevString", thisVersion.cpqSiFirmwareRevString),
							displayItem("cpqSiFirmwareLocation", thisVersion.cpqSiFirmwareLocation),
							displayItem("cpqSiFirmwareStatus", thisVersion.cpqSiFirmwareStatus));
							
				firmwareVersionStr += simpleTableRow(columnsInternal, columnsInternal.length);
				
			}

			firmwareVersionStr += tblTail;
			firmwareVersionStr += whiteSpaceDivider();
		}
	}
	
	return firmwareVersionStr;
}

  	 //************ End of Firmware Version
